2000-12-31  Alexandre Oliva  <aoliva@redhat.com>

	* resource.c (mark_referenced_resources): Abort() before
	attempting to mark a pseudo register.
	(mark_set_resources): Likewise.

2000-12-31  Philip Blundell  <philb@gnu.org>

	* config/arm/linux-gas.h (CLEAR_INSN_CACHE): Add missing asm
	operands.

2000-12-30  Richard Henderson  <rth@redhat.com>

	* dbxout.c (dbxout_block): Invert logic on eliding LBRAC/RBRAC.
	Initialize variables properly for DBX_LBRAC_FIRST.

2000-12-30  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case COMPONENT_REF): Fix typo in last change.

2000-12-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (validate_arglist): New function, use it.

2000-12-30  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.c (arm_expand_prologue): Fix typos in error
	message and comment.  Note location of testcase for an unhandled
	situation.

2000-12-30  Jeffrey Oldham  <oldham@codesourcery.com>

	* defaults.h (BUILD_VA_LIST_TYPE): New definition.
	* tree.c (build_common_tree_nodes_2): Ensure the va_list_type_node
	is a copy, not an alias.

2000-12-30  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* calls.c (calls_function_1, case CONSTRUCTOR): New case.

	* alias.c (alias_sets_conflict_p): New function.
	(mems_in_disjoint_alias_sets_p): Use it.
	(readonly_fields_p): Moved from expr.c; check for record type.
	(objects_must_conflict_p): New function.
	* calls.c (expand_call): Use assign_temp as much as possible, use
	readonly variant if assigned once, and don't set memory attributes.
	(emit_library_call_value_1, store_one_arg): Likewise.
	* integrate.c (expand_inline_function): Likewise.
	* stmt.c (expand_asm_operands, expand_return): Likewise.
	* expr.c (copy_blkmode_from_reg, store_constructor): Likewise.
	(store_field, save_noncopied_parts, expand_expr): Likewise.
	(expand_expr_unaligned): Likewise.
	(readonly_fields_p): Moved to alias.c.
	(safe_from_p): Rework handling of SAVE_EXPR.
	MEMs ony conflict if alias sets conflict; likewise for INDIRECT_REF.
	* function.c (struct temp_slot): Delete field ALIAS_SET; add TYPE.
	(assign_stack_for_temp): Use objects_must_confict_p.
	Set all memory attributes from type, if specified.
	(mark_temp_slot): Mark TYPE field.
	* tree.h (alias_sets_conflict_p, readonly_fields_p): New decls.
	(objects_must_conflict_p): Likewise.

	* stmt.c (expand_decl): Don't use assign_stack_temp in error case.
	(add_case_node): No need to copy nodes anymore.

2000-12-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (split_branches): Don't dereference re-computed
	`beyond' before checking it's non-NULL.

2000-12-29  Robert Lipe <robertl@sco.com>

	Remove COFF support from i?86-pc-sco3.2v5.
	* i386/sco5.h (PREFERRED_DEBUGGING_TYPE): Change to Dwarf II.
	(TARGET_ELF): Now always true.
	(SUBTARGET_SWTICHES: )Remove -mcoff.

	* i386/t-sco5 (MULTILIB_OPTIONS, MULTILIB_DIRNAMES,
	MULTILIB_EXCEPTION): Nuke coff.
	(CRTSTUFF_T_CFLAGS_S):  Deleted.
	(TARGET_LIBGCC2_CFLAGS): Added.

2000-12-29  Alexandre Oliva  <aoliva@redhat.com>

	* varasm.c (output_constant_def): Don't ENCODE_SECTION_INFO
	twice.  Update desc->rtl and ->label, in case ENCODE_SECTION_INFO
	modifies them.

2000-12-29  Bernd Schmidt  <bernds@redhat.com>

	* ia64.c (ia64_expand_load_address): Accept additional scratch
	register argument.  All callers & prototype changed.
	Use scratch register when generating load_symptr insns.
	* ia64.md (movdi_symbolic): Clobber a scratch register.  Use it
	when calling ia64_expand_load_address.
	(movdi): Generate movdi_symbolic with additional operand.
	(load_gprel64): Use pic_offset_table_rtx instead of (reg:DI 1).
	(load_symptr): Likewise.  Use additional operand as a scratch
	register instead of generating it here.

	* basic-block.h: Add a comment.
	* flow.c (PROP_POSTRELOAD): New macro.
	(update_life_info): Add it to prop_flags.
	(mark_set_1): If it is set, compute REG_N_SETS for the original
	register number of a hard reg.

	* emit-rtl.c (gen_raw_REG): New function.
	(gen_rtx_REG, gen_reg_rtx, init_emit_once): Use it instead of
	gen_rtx_raw_REG.
	* print-rtl.c (print_rtx): Print ORIGINAL_REGNO.
	* final.c (alter_subreg): Update it.
	* regrename.c (do_replace): Likewise.  Use gen_raw_REG.
	* rtl.def (REG): Update comment.
	* rtl.h (X0UINT, ORIGINAL_REGNO): New macros.
	(gen_raw_REG): Declare.

2000-12-29  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.c (get_set_constructor_bits): Use host_integerp and
	tree_low_cst.

	* local-alloc.c (update_equiv_regs): Don't use copy_rtx on PATTERN.

	* toplev.c (main): Call xmalloc_set_program_name.
	* gcc.c (main): Likewise.

2000-12-29  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.c (arm_override_options): Fix typo in warning
	message.

2000-12-29  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_expand_block_move): Initialize
	src_align and dst_align in bits.  Do unaligned quadword loads
	if possible for BWX too.
	(alpha_expand_block_clear): Initialize align in bits.  Track
	small leading offsets into a larger alignment.  Play games with
	stq_u for large 4-byte aligned blocks.  Use load/mask/store
	for appropreately aligned heads and tails.

2000-12-29  Alexandre Oliva  <aoliva@redhat.com>

	* function.c (assign_parms): Convert arguments passed by
	reference to the right mode.

2000-12-28  Geoffrey Keating  <geoffk@redhat.com>

	* c-parse.in (select_or_iter_stmt): Use truthvalue_conversion
	on the condition of a FOR statement, so that it gets typechecked
	and optimized.

2000-12-29  Alexandre Oliva  <aoliva@redhat.com>

	* c-decl.c (grokdeclarator): Prevent crash in case of overflow in
	array size.

	* calls.c (emit_library_call_value_1): Add to call_fusage the
	stack slot assigned to argument passed by reference.

2000-12-28  Jeffrey Oldham  <oldham@codesourcery.com>

	* toplev.h (extern really_sorry): Remove extern declaration for
        nonexistent function.

2000-12-28  Jeffrey Oldham  <oldham@codesourcery.com>

	* varasm.c (initializer_constant_valid_p): Indicate subtraction of
	pointers to the same string constant is absolute.

2000-12-28  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (enum format_type): Add strfmon_format_type.
	(decl_attributes): Handle format attributes strfmon and
	__strfmon__.
	(FMT_FLAG_USE_DOLLAR, FMT_FLAG_ZERO_WIDTH_BAD,
	FMT_FLAG_EMPTY_PREC_OK): Define.
	(format_char_info): Update comment for flag_chars.
	(format_flag_spec): Add skip_next_char.
	(format_kind_info): Add left_precision_char.
	(printf_flag_specs, scanf_flag_specs, strftime_flag_specs,
	format_types): Update for these new structure members and flags.
	(time_char_table): Make const.
	(strfmon_length_specs, strfmon_flag_specs, strfmon_flag_pairs,
	monetary_char_table): New.
	(format_types): Add details of strfmon formats.
	(init_function_format_info): Create default attribute for strfmon.
	(check_format_info_main): Check the new flags.  Handle
	skip_next_char and left precision.
	* toplev.c (documented_lang_options): Update description of
	-Wformat.
	* extend.texi: Document strfmon format attributes.  Document
	attribute forms such as __printf__.  Clarify format_arg attribute
	documentation.
	* invoke.texi (-Wformat): Update for strfmon formats.

2000-12-28  Andreas Jaeger  <aj@suse.de>

	* expmed.c (store_bit_field): Fix last patch.

2000-12-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/crt1.asm (start_l): `__SH4_SINGLE_ONLY__' was missing
	the trailing `__'.

2000-12-28  Alan Lehotsky  <lehotsky@tiac.net>

	* expmed.c (store_bit_field): Correctly compute smallest mode that
	is sufficient to contain all bits we are storing.

2000-12-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (build_function_call_expr): New function.  Use it
	everywhere in lieu of manually constructing a CALL_EXPR.

2000-12-27  Chandrakala Chavva  <cchavva@redhat.com>

	* calls.c (store_one_arg):  If parm is passed both in stack and in
	register and offset is greater than reg_parm_stack_space, split
	the offset and call emit_push_insn().

2000-12-27  Nick Clifton  <nickc@redhat.com>

	* ifcvt.c (noce_emit_store_flag): Handle jump insns that are
	PARALLEL.

2000-12-27  Alexandre Oliva  <aoliva@redhat.com>

	* rtl.c (copy_most_rtx, shallow_copy_rtx): Copy frame_related
	flag.

2000-12-27  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.in: fix for ancient Bourne shell
	* fixinc/Makefile.BEOS: obsolete
	* fixinc/Makefile.DOS: obsolete
	* fixinc/fixincl.sh(LINKS): use `test -d' rather than `ls' for testing

2000-12-27  Bernd Schmidt  <bernds@redhat.com>

	* sched-deps.c (get_condition, conditions_mutex_p): New functions.
	(add_dependence): Use them to avoid adding unnecessary dependencies
	between conditionally executed insns.
	(sched_analyze_1, sched_analyze_2, sched_analyze_insn): Don't free
	dependency lists if current insn is a COND_EXEC.

2000-12-27  Geoffrey Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.md (define_attr "length"): Correct
	calculation.

2000-12-26  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c: Fix a comment typo.
	(get_shift_alg): Fix a typo in the assembly code for 12-bit
	ASHIFTRT in HImode.  Do not output extra whitespace after one line
	of assembly code.  Output a tab after an opcode instead of a
	space.
	(emit_a_shift): Output a tab after an opcode instead of a space.

2000-12-23  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (out_movqi_r_mr, out_movhi_r_mr, out_movsi_r_mr,
	out_movsi_mr_r, out_movqi_mr_r, out_movhi_mr_r): Use %o instead of
	%4 in output templates, do not modify operands passed by the caller.

2000-12-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* builtins.def (BUILT_IN_LABS, BUILT_IN_LLABS, BUILT_IN_IMAXABS):
	Don't define.
	* builtins.c (expand_builtin): Don't handle BUILT_IN_LABS,
	BUILT_IN_LLABS and BUILT_IN_IMAXABS.
	* c-common.c (c_common_nodes_and_builtins): Use BUILT_IN_ABS for
	builtin labs, llabs and imaxabs.
	(expand_tree_builtin): Don't handle BUILT_IN_LABS, BUILT_IN_LLABS
	and BUILT_IN_IMAXABS.

2000-12-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (builtin_function_2): New function.
	(c_common_nodes_and_builtins): Use it to define each pair (foo,
	__builtin_foo) of builtins in one place.

2000-12-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gccbug.in: Add libgcj and preprocessor categories.

2000-12-22  Bernd Schmidt  <bernds@redhat.com>

	* config/ia64/ia64.c (itanium_reorder): Only schedule stops in
	the final scheduling pass.

2000-12-22  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h (struct machine_function): Add new field
	'lr_save_eliminated'.
	* config/arm/arm.c (arm_compute_save_reg_mask): Do not include the
	link register if its save has been eliminated.
	(output_arm_prologue): Mention if the save of the link register
	has been eliminated.
	(output_arm_epilogue): Rename 'live_regs_mask' to
	'saved_regs_mask'.
	Test 'saved_regs_mask' for the link register, not regs_ever_live.
	(arm_expand_prologue): If the link register has not been saved set
	lr_save_eliminated and emit a USE to prevent later passes from
	scavenging it.

	* dwarf2out_frame_debug_expr: Allow the (scratch) frame
	pointer to be initialized from the stack pointer plus a
	constant.

2000-12-22  Bernd Schmidt  <bernds@redhat.com>

	* regrename.c (struct du_chain): New field "earlyclobber".
	(enum scan_actions): Remove unused entry "note_reference".
	(enum scan_actions_name): Likewise.
	(note_sets, clear_dead_regs, merge_overlapping_regs): New static
	functions.
	(regrename_optimize): Use them to compute unavailable regs; get
	rid of the more simpleminded code we used to have here.
	Use a tick array to ensure registers are allocated in a more
	round-robin way.  Disable code that only optimizes registers
	that were seen more than once.
	(referenced_regs): Remove variable.
	(scan_rtx_reg): New arg "earlyclobber".  All callers changed.
	Store its value in newly generated du_chain structures.
	Add new du_chains at the end, not the start, of the list.
	Don't handle the "note_reference" action.
	(scan_rtx): New arg "earlyclobber".  All callers changed.
	(build_def_use): Lose code to keep track of referenced regs.

2000-12-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (sched-deps.o, sched-rgn.o): Fix dependency typo.

	* fp-bit.h (usi_to_float): Add prototype.

	* i386.c (ix86_expand_builtin): Delete unused label.

	* dwarf2out.c (file_info_cmp): Prototype.
	(dwarf2out_line): Hide variable `old_in_use'.

	* objc-act.c (objc_fatal): Delete.

	* sched-vis.c (visualize_stall_cycles): Remove unused variable.

	* system.h (getopt): Fix error in last change.

	* varasm.c (assemble_trampoline_template): Constify.

2000-12-22  Jason Merrill  <jason@redhat.com>

	* collect2.c (main): Use auto_demangling.

2000-12-22  Alexandre Oliva  <aoliva@redhat.com>

	* function.c (assign_parms): Update parm's DECL_INCOMING_RTL
	when optimizing PARALLEL to REG.

2000-12-22  Graham Stott  <grahams@redhat.com>

	* reload.c (update_auto_inc_notes): New, broken out from ...
	(find_reloads_address_1): ... use here, also correct possible
	use of uninitialized reloadnum.

2000-12-21  David O'Brien  <obrien@FreeBSD.org>

	* config/freebsd.h (LIB_SPEC): remove -kthread option.

2000-12-22  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* resource.c (mark_set_resources): Use MARK_SRC_DEST for
	PRE_MODIFY and POST_MODIFY cases.

	* rtlanal.c (side_effects_p): Handle PRE_MODIFY and POST_MODIFY.

2000-12-22  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* md.texi (Looping Patterns): New node.

2000-12-21  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi, cpp.texi: Update last-updated dates.

2000-12-21  Chandrakala Chavva  <cchavva@redhat.com>

	* varasm.c (output_addressed_constants): Use language specific
	expander on unknown nodes.

2000-12-21  Graham Stott  <grahams@redhat.com>

	* combine.c (distribute_notes): Handle REG_NON_LOCAL_GOTO notes.

2000-12-21  Bernd Schmidt  <bernds@redhat.com>

	* Makefile.in (out_object_file): Depend on sched-int.h.
	* rtl.h (single_set_1): New macro.
	(single_set_2): Renamed from single_set_1 and extra argument added.
	* rtlanal.c (single_set_2): Likewise.

	* config/ia64/ia64-protos.h (get_bundle_name, ia64_issue_rate,
	ia64_adjust_cost, ia64_sched_init, ia64_sched_finish,
	ia64_sched_reorder, ia64_sched_reorder2, ia64_variable_issue):
	Declare.
	* config/ia64/ia64.c: Include "sched-int.h".
	(hard_regno_rename_ok): Also disallow renaming from the various
	reg_save_* regs.
	(ia64_safe_itanium_requiers_unit0, ia64_safe_itanium_class,
	ia64_safe_type, init_insn_group_barriers, group_barrier_needed_p,
	safe_group_barrier_needed_p, fixup_errata): New static functions.
	(rtx_needs_barrier):  Handle bundle selector and cycle display
	insns.
	(emit_insn_group_barriers): Accept additional FILE * arg.  All
	callers changed.  Rework to only generate stop bits between
	basic blocks that haven't been inserted by scheduling.
	(struct bundle, struct ia64_packet): New structures.
	(NR_BUNDLES, NR_PACKETS): New macros.
	(bundle, packets, type_names): New static arrays.
	(ia64_final_schedule): New variable.
	(ia64_single_set, insn_matches_slot, ia64_emit_insn_before,
	gen_nop_type, finish_last_head, rotate_one_bundle, rotate_two_bundles,
	cycle_end_fill_slots, packet_matches_p, get_split, find_best_insn,
	find_best_packet, itanium_reorder, dump_current_packet, schedule_stop):
	New static functions.
	(ia64_issue_rate, ia64_sched_init, ia64_sched_reorder,
	ia64_sched_finish, ia64_sched_reorder2, ia64_variable_issue): New
	functions.
	(ia64_reorg): Perform a final scheduling pass.
	* config/ia64/ia64.h (CONST_COSTS): Slightly increase SYMBOL_REF costs.
	(MAX_CONDITIONAL_EXECUTE, ADJUST_COST, ISSUE_RATE, MD_SCHED_INIT,
	MD_SCHED_REORDER, MD_SCHED_REORDER2, MD_SCHED_FINISH,
	MD_SCHED_VARIABLE_ISSUE): Define macros.
	(ia64_final_schedule): Declare variable.
	* config/ia64/ia64.md (attr itanium_class): Add some more classes.
	(attr type): Account for them.
	(itanium_requires_unit0): New attribute.
	(function units): Rewrite.
	(some splitters): Don't create scheduling barriers here.
	(gr_spill_internal, gr_restore_internal): Don't predicate the
	pseudo-op.
	(nop_m, nop_i, nop_f, nop_b, nop_x, cycle_display, cycle_display_1,
	bundle_selector): New patterns.
	(insn_group_barrier): Now has an operand.

2000-12-21  DJ Delorie  <dj@redhat.com>

	* dwarf2out.c (simple_decl_align_in_bits): new
	(field_byte_offset): Try both the type align and the
	decl align, use whichever works, preferring the type align.

2000-12-21  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gccbug.in: Fix typo.

2000-12-20  Benjamin Kosnik  <bkoz@redhat.com>

	* Makefile.in (gcc_gxx_target_include_dir): Use instead of
	build_tooldir and libstdcxx_incdir.

2000-12-20  Robert Lipe <robertlipe@usa.net>

	* haifa-sched.c (schedule_block): Provide empty source statement
	if not MD_SCHED_REORDER2.

2000-12-20  Richard Henderson  <rth@redhat.com>

	* rtl.h (REG_NON_LOCAL_GOTO): New.
	* rtl.c (reg_note_name): Update.
	* stmt.c (expand_goto): Emit a REG_NON_LOCAL_GOTO note.
	* builtins.c (expand_builtin_longjmp): Likewise.
	* flow.c (make_edges): Check for REG_NON_LOCAL_GOTO and do
	not emit an edge.

2000-12-20  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (out_movsi_r_mr, out_movsi_mr_r, out_movhi_mr_r):
	Do not output undefined opcodes where source or destination register
	overlaps with modified pointer register.  Handle (X + d) addresses.
	* config/avr/avr.md (*movhi, *movsi, *movsf): Correct insn length
	in alternatives with memory operand.

2000-12-20  Richard Henderson  <rth@redhat.com>

	* c-typeck.c (build_asm_stmt): New, broken out from ...
	(c_expand_asm_operands): ... here.  Just do rtl expansion.
	(c_expand_return): Return the new stmt node.
	(c_start_case, do_case): Likewise.
	* c-common.c (c_expand_expr_stmt): Likewise.
	* c-common.h: Update declarations.
	* c-tree.h: Likewise.
	* c-semantics.c (build_stmt): Use STMT_LINENO not TREE_COMPLEXITY.
	* c-parse.in (fndef): Set DECL_SOURCE_LINE to the open brace.
	(nested_function, notype_nested_function): Likewise.
	(compstmt): Return the compound statement not the binding level.
	(lineno_labeled_stmt): Simplify.
	(lineno_stmt, lineno_label): Set STMT_LINENO.
	(stmt, label): Return the new stmt node.

2000-12-20  Bernd Schmidt  <bernds@redhat.com>

	* Makefile.in (OBJS): Add sched-ebb.o.
	(sched-ebb.o): New rule.
	(sched-vis.o): Depend on hard-reg-set.h and $(BASIC_BLOCK_H).
	(haifa-sched.o): Depend on insn-flags.h.
	* haifa-sched.c: Include "insn-flags.h".
	(priority): Don't access BLOCK_NUM, use the new contributes_to_priority
	callback.
	* rtl.h (schedule_ebbs): Declare.
	* sched-int.h (struct sched_info): Add new members
	contributes_to_priority and compute_jump_reg_dependencies.
	* sched-rgn.c (contributes_to_priority, compute_jump_reg_dependencies):
	New functions.
	(region_sched_info): Add them.
	* sched-vis.c: Include "hard-reg-set.h" and "basic-block.h".
	* sched-ebb.c: New file.
	* sched-deps.c (sched_analyze_insn): Add code to handle JUMP_INSNs.

	* flow.c (ior_reg_cond, and_reg_cond, elim_reg_cond): Properly
	handle all relational operators.

2000-12-20  Alexandre Oliva  <aoliva@redhat.com>

	* final.c (output_addr_const): Use ASM_OUTPUT_SYMBOL_REF.
	* tm.texi: Document it.

2000-12-19  Benjamin Kosnik  <bkoz@redhat.com>

	* Makefile.in (-DGPLUSPLUS_TOOL_INCLUDE_DIR): Use build_tooldir
	instead of gcc_tooldir.

2000-12-19  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* system.h (getopt): Update prototype to match include/getopt.h.

2000-12-19  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	From Jeff Law.
	* pa.c (basereg_operand): Simplify.

2000-12-19  Bernd Schmidt  <bernds@redhat.co.uk>

	* haifa-sched.c (rm_line_notes): Arguments are now head and tail,
	not block number.  All callers and prototype changed.
	(set_priorities): Likewise.
	(save_line_notes): Add head and tail arguments; all callers and
	prototype changed.
	(restore_line_notes): Likewise.  Don't crash on insns generated
	during scheduling.
	(schedule_block): Don't use BLOCK_HEAD/BLOCK_END macros.
	Call MD_SCHED_INIT with additional argument.
	When starting a new cycle, emit cycle_display insns if available.
	Don't stop scheduling when encountering a JUMP_INSN, but add another
	call to schedule_more_p in the inner loop.
	Call MD_SCHED_REORDER2 after scheduling an insn.
	Call MD_SCHED_FINISH once all insns are scheduled.
	(sched_init): Compensate for the fact that get_block_head_tail
	doesn't include leading notes.
	* sched-deps.c (free_deps): Free vectors here.
	* sched-rgn.c (compute_block_backward_dependencies): Not here.
	(last_was_jump): New static variable.
	(schedule_more_p): Test it.
	(init_ready_list): Initialize it.
	(can_schedule_ready_p): Set it if we have a JUMP_INSN.

	* config/i386/i386.h (MD_SCHED_INIT): Add new arg.
	* config/m32r/m32r.h (MD_SCHED_INIT): Add new arg.
	* config/sparc/sparc.h (MD_SCHED_INIT): Add new arg.

	* md.texi (cycle_display): Document.
	* tm.texi (MD_SCHED_INIT): Document new arg.
	(MD_SCHED_FINISH, MD_SCHED_REORDER2): Document.

	* flow.c (ior_reg_cond, nand_reg_cond, not_reg_cond): Rewrite
	to use different representation.  All callers changed.
	(and_reg_cond): Renamed from nand_reg_cond; caller changed.
	(init_propagate_block_info): Don't test flags to determine
	whether to compute conditional lifetimes.
	Adjust code for new representation of conditional lifetimes.
	(mark_regno_cond_dead): Similar adjustment.
	(free_reg_cond_life_info): Similar adjustment.
	(elim_reg_cond): New function.
	(flush_reg_cond_1): Use it.

2000-12-19  Catherine Moore  <clm@redhat.com>

	* reload1.c (reload_combine): Take multi-hard-regs into account
	when processing CALL_INSN_FUNCTION_USAGE.

2000-12-19  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi (-print-search-dirs): Make references to cpp refer
	to cpp0 instead.

2000-12-18  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fold-const.c (tree_expr_nonnegative_p): Treat truth values as
	non-negative.

Tue Dec 19 00:37:08 2000  J"orn Rennecke <amylaar@redhat.com>

	* reload.c (push_reload): When using a dying register for the reload
	register in an in-out reload, use outmode if wider than inmode.

2000-12-19  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config/d30v/d30v.h (EXIT_BODY): Update comment.

2000-12-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config.gcc (*-*-linux*): Don't define HAVE_ATEXIT or BSTRING.
	* tm.texi (EXIT_BODY): Update documentation.
	* config/freebsd.h, config/netware.h, config/arm/coff.h,
	config/arm/conix-elf.h, config/arm/unknown-elf.h,
	config/d30v/d30v.h, config/mcore/mcore.h, config/pj/pj.h,
	sparc/sp86x-aout.h: Remove definitions of HAVE_ATEXIT (some
	commented out) and associated comments.

2000-12-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (STD_C9L, ADJ_STD): Define.
	(printf_length_specs, scanf_length_specs): Mark "ll" as standard
	STD_C9L.
	(T99_LL): Rename to T9L_LL.
	(T99_ULL): Rename to T9L_ULL.
	(print_char_table, scan_char_table): Use T9L_LL and T9L_ULL
	instead of T99_LL and T99_ULL.
	(check_format_info_main): Use ADJ_STD on all format standard
	versions being compared.
	* c-common.h: Declare warn_long_long.
	* c-tree.h: Don't declare warn_long_long.

2000-12-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* COPYING: Update to current
	ftp://ftp.gnu.org/pub/gnu/Licenses/COPYING-2.0 (fixes references
	to 19yy as example year in copyright notice).

2000-12-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (cb_file_change): Treat in_system_header as strictly
	boolean (0 or 1).

2000-12-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppmain.c: Update print.lineno with -P.

2000-12-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c: s/change_file/file_change.
	* cpplib.h: Similarly.
	* cppmain.c: Similarly.
	* fix-header.c: Similarly.
	* cppfiles.c (stack_include_file): Pass the buffer location and
	size to cpp_push_buffer.  Generate the file_change callback,
	so that sysp is already set.
	* cpphash.h: Add _cpp_do_file_change.
	* cpplib.c (do_line): Set buffer->sysp directly. Generate the
	file_change callback after setting sysp.
	(_cpp_do_file_change): Handle FC_ENTER and the FC_RENAME exception
	here.
	(cpp_push_buffer): Don't generate a callback.  Clear sysp.
	(cpp_pop_buffer): Clean up logic.

2000-12-18  Benjamin Kosnik  <bkoz@redhat.com>

	* configure.in (gcc_gxx_include_dir): Simplify.
	(libstdcxx_incdir): Export.
	* configure: Regenerate.
	* Makefile.in (PREPROCESSOR_DEFINES): Add in
	GPLUSPLUS_TOOL_INCLUDE_DIR bits here..
	(libstdcxx_incdir): Add.
	* cppdefault.c (GPLUSPLUS_TOOL_INCLUDE_DIR): Add search path.

2000-12-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (lex_lineno): Remove.
	(init_c_lex, c_lex): Remove lex_lineno.
	(cb_change_file): Update lineno correctly, both before calling
	push_srcloc and before leaving the function.
	(cb_def_pragma): Set lineno before outputting diagnostics.

Sun Dec 17 18:45:41 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* print-tree.c (print_node): Print DECL_USER_ALIGN and TYPE_USER_ALIGN.
	Print TYPE_MIN_VALUE and TYPE_MAX_VALUE for REAL_TYPE.
	Use print_node_brief to print bounds.

2000-12-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplib.h (struct cpp_reader): Remove references to string_pool
	and temp_string_pool.
	* cppinit.c (cpp_create_reader, cpp_cleanup): Similarly; using
	ident_pool in place.
	* cpplex.c (parse_number, unescaped_terminator_p, parse_string,
	save_comment, cpp_token_as_text): Similarly.
	* cpplib.c (do_define, glue_header_name, parse_assertion): Similarly.
	* cppmacro.c (make_number_token, builtin_macro, lock_pools,
	unlock_pools, stringify_arg, paste_tokens): Similarly.

Sun Dec 17 12:41:48 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* dwarf2out.c (loc_descriptor_from_tree, case NOP_EXPR): New case.
	(loc_descriptor_from_tree, case CONVERT_EXPR): Likewise.
	(loc_descriptor_from_tree, case NON_LVALUE_EXPR): Likewise.

2000-12-17  Richard Earnshaw  <rearnsha@arm.com>

	* Makefile.in (check-po): Use $(MAKE).
	(risky-stage1, risky-stage2, risky-stage3, risky-stage4): Likewise.

2000-12-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppmain.c (check_multiline_token): New function.
	(scan_buffer): Use it.
	(cb_change_file): Restructure to avoid warning.
	* cpperror.c (print_location): Initialize col.

2000-12-14  Philipp Thomas  <pthomas@suse.de>

	* protoize.c (main): Correctly set locale categories.
	* gcc.c (main): Likewise.
	* cppmain.c (general_init): Likewise.
	* toplev.c (main): Likewise.
	* gcov.c (main): Likewise.
	* collect2.c (main): Likewise.

2000-12-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c (c_common_nodes_and_builtins): Create a
	cstring_endlink, use it.  Rename int_ftype_string_string to
	int_ftype_cstring_cstring, string_ftype_string_int to
	string_ftype_cstring_int, and string_ftype_string_string to
	string_ftype_cstring_cstring.  Prefer sizetype_endlink and
	int_endlink to manually recreating them.  Fix the prototype
	set for __builtin_strspn/__builtin_strcspn.

2000-12-12  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (out_set_stack_ptr): Update comment.
	(print_operand): Add support for %~ and %o.

2000-12-17 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* c4x.h: Add ASM_OUTPUT_DEF definition for bounded pointer code.

2000-12-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c: Move main_input_filename handling to FC_ENTER. Clean up.
	* cpperror.c (print_containing_files): Get right line number.
	(print_location): Output column of 1 if 0.
	* cppfiles.c (stack_include_file): cpp_push_buffer handles
	the callback.
	* cpphash.h (_cpp_do_file_change): No longer external.
	* cpplib.c (do_file_change): Now local to cpplib.c.
	(do_line): Fake a buffer stack for preprocessed files.
	(cpp_push_buffer): Create a file_change callback.  Handle faked
	buffers.
	(cpp_pop_buffer): Similarly.
	* cpplib.h: BUF_FAKE: New buffer type.
	* cppmain.c: Update to handle correct file renaming where a
	#line is the first line of the main file, and produce only
	the renamed file, not the original file, as output.

2000-12-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.md: Remove redundant @s from output patterns.

2000-12-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>
            Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* config/c4x/c4x.h (REGISTER_TARGET_PRAGMAS): Call c4x_init_pragma.

	* config/c4x/c4x-protos.h (c4x_init_pragma): New prototype.

	* config/c4x/c4x.c (c4x_init_pragma): New function.
	(c_lex_func): New variable.
	(c4x_parse_pragma): Use c_lex_func.

2000-12-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>
            Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* config/c4x/c4x.h (MD_INIT_BUILTINS): Add void_list_node argument
	to c4x_init_builtins.

	* config/c4x/c4x-protos.h (c4x_init_builtins): Add tree argument.

	* config/c4x/c4x.c (c4x_init_builtins): Add tree argument.
	(c4x_output_ascii):  Fix.

2000-12-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>
            Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* config/c4x/c4x.h (MD_INIT_BUILTINS, MD_EXPAND_BUILTIN): Define.

	* config/c4x/c4x-protos.h (c4x_init_builtins): New prototype.
	(c4x_expand_builtin): Likewise.

	* config/c4x/c4x.c (c4x_init_builtins): New function.
	(c4x_expand_builtin): Likewise.

	* config/c4x/c4x.md (floatunsqihf2): New pattern.
	(*floatqihf2_set, *fixhfqi_set, fix_trunchfqi2): Likewise.
	(fixuns_trunchfqi2, toieee, frieee, *ldhf_conditional): Likewise.
	(*ldhf_conditional_noov, movhfcc, trap, cond_trap_cc): Likewise.
	(*toieee_movqf_clobber, *frieee_movqf_clobber): Likewise.

2000-12-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* libgcc2.h: Use Wtype for SItype and DWtype for DItype in prototypes.
	* libgcc2.c (__absvsi2): Use Wtype and DWtype.
	(__absvdi2, __addvsi3, __addvdi3, __subvsi3): Likewise.
	(__subvdi3, __mulvsi3, __mulvdi3, __negvsi2, __negvdi2): Likewise.

2000-12-16  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (INITIALIZE_TRAMPOLINE): Enclose the block
	statement in do/while(0).

Sat Dec 16 19:56:24 MET 2000  Jan Hubicka  <jh@suse.cz>

	* i386.md (ashrsi3_cmpno, ashrhi3_cmpno, ashrqi3_cmpno, lshrsi3_cmpno,
	lshrhi3_cmpno): Remove redundant '@' from the template.

	* i386.md (cmpstrsi_1): Fix type of the compare.

	* genattrtab.c (attr_rtx_cost): New function.
	(simplify_test_exp): Avoid overactive inlining; use temporary
	obstacks for tests.

Sat Dec 16 10:41:11 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* diagnostic.c (finish_abort): Deleted.
	(fatal): Add code from finish_abort.
	(error_recursion, fancy_abort): Call fatal, not finish_abort.
	(trim_filename): Remove leading "../".
	* diagnostic.h (finish_abort): Deleted.
	* toplev.c (crash_signal): Call fatal, not finish_abort.

	* stor-layout.c (place_field): Treat overflowing DECL_SIZE_UNIT
	as if size were variable.

	* expmed.c (expand_mult): Write REG_EQUAL note with proper mode.

2000-12-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* tradcpp.c: T_WARNING: New.
	(do_warning): New function.
	(finclude): Skip past the newline and increase the line number
	before calling output_line_command.
	(do_line): Skip the new line after output_line_command.  Don't
	pre-decrement the line number.

2000-12-15  Diego Novillo  <dnovillo@redhat.com>

	* i386/unix.h (ASM_OUTPUT_MI_THUNK): Fix references to
	_GLOBAL_OFFSET_TABLE_ when using Intel syntax.

2000-12-15  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (cpp_options): Pass -fno-operator-names.
	* cpplib.h (struct cpp_options): Add operator_names.
	* cppinit.c (cpp_create_reader): Initialize it.
	(initialize_builtins): If -fno-operator-names, don't add
	C++ alternate operator names.
	(COMMAND_LINE_OPTIONS): Add -fno-operator-names.
	(cpp_handle_option): Clear operator_names.

2000-12-15  Jason Merrill  <jason@redhat.com>

	* jump.c (jump_optimize_1): Don't delete the line note after the
	prologue even if it seems redundant.

	* config/arm/arm.c (arm_expand_prologue): Set RTX_FRAME_RELATED_P
	on all insns used to adjust the stack.

Fri Dec 15 15:32:16 MET 2000  Jan Hubicka  <jh@suse.cz>

	* combine.c (cant_combine_insn_p): Get around SUBREGs when determining
	hardreg<->reg moves.

Fri Dec 15 14:48:37 MET 2000  Jan Hubicka  <jh@suse.cz>

	* genrecog.c (add_to_sequence): Remove special case for
	const_int_operand.
	(maybe_both_true): Return 1 when falling out of sequence when
	trying to find common position in the pattern.

Fri Dec 15 14:44:51 MET 2000  Jan Hubicka  <jh@suse.cz>

	* integrate.c (copy_rtx_and_substitute): Copy mode too.

Fri Dec 15 14:11:57 MET 2000  Jan Hubicka  <jh@suse.cz>

	* flow.c (notice_stack_pointer_modification_1): Cleanup.

2000-12-15  Alexandre Oliva  <aoliva@redhat.com>

	* function.c (adjust_trampoline_addr): New function.
	(trampoline_address): Call it instead of round_trampoline_addr().
	* tm.texi (TRAMPOLINE_ADJUST_ADDRESS): Document it.

2000-12-14  Zack Weinberg  <zack@wolery.stanford.edu>

	* cppfiles.c (hack_vms_include_specification): Delete function
	(not used since 1998).

Fri Dec 15 03:37:51 2000  J"orn Rennecke <amylaar@redhat.com>

	* haifa-sched.c (sched_init): Don't put a note in front of any BARRIER.

2000-12-14  Jim Wilson  <wilson@redhat.com>

	* alias.c (get_alias_set): Call record_component_aliases for
	COMPLEX_TYPE.
	(record_component_aliases): Handle COMPLEX_TYPE.

2000-12-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixinc/gnu-regex.c: Disable NLS.

2000-12-14  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_emit_conditional_move): Do not swap
	comparison operands when that would create non-canonical rtl.

	* config/i386/i386.md (umulsi3_highpart): Remove * from name.
	(smulsi3_highpart): Likewise.

2000-12-14  Neil Booth  <neil@daikokuya.demon.co.uk>

	* gcc.c (cpp_options): Add -remap.

2000-12-14  Neil Booth  <neil@daikokuya.demon.co.uk>

	* gcc.c (cpp_options): Update to use '&'.
	(struct switchstr): Change type of validated to save space.
	New member 'ordering'.
	(handle_braces, validate_switches): Update to handle '&'.

2000-12-13  Laurynas Biveinis  <lauras@softhome.net>

	* fixinc/inclhack.def: skip stdio_va_list fix if __DJ_va_list
	found in a header.
	* fixinc/fixincl.x: regenerated.

2000-12-13  DJ Delorie  <dj@redhat.com>

	* config.gcc (cygwin, win32, mingw32): Use float-i386.h.

2000-12-13  Tom Tromey  <tromey@redhat.com>

	* gcc.c (handle_braces): Handle %{<S*} spec correctly.

2000-12-13  Alexandre Oliva  <aoliva@redhat.com>

	* function.c (assign_parms): Optimize incoming PARALLELs into
	REGs if possible.

2000-12-13  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.in(*): substantial rewrite to accommodate systems
	that cannot handle bi-directional pipes, viz. BeOS and DOS.
	* fixinc/fixlib.h(IGNORE_ARG): new macro
	(STATIC): define for all of fixinc to use
	* fixinc/fixfixes.c(*): eliminate unused arg warnings
	* fixinc/fixtests.c(*): ditto
	* fixinc/fixincl.c(start_fixer): chain_open now uses const arg list
	* fixinc/gnu-regex.c: reorder some includes to avoid _GNU_SOURCE
	warning.  Also, eliminate the ``#ifdef emacs'' stuff.
	(re_syntax_options): make global as it is declared so.
	* fixinc/mkfixinc.sh: process the argument list more consistently
	(beos/msdosdjgpp): set TARGETS to twoprocess vs. oneprocess
	* fixinc/procopen.c(globals): include "fixlib.h" for std defs
	* fixinc/server.c(globals): ditto
	* fixinc/server.h(defines): ditto

2000-12-13  Neil Booth  <neil@daikokuya.demon.co.uk>

	* tradcpp.c (special_symbol): Improve test for definedness,
	though it is still not perfect.
	(do_define): Don't define illegal macro names.

2000-12-07  Aldy Hernandez  <aldyh@redhat.com>

	* config/mips/elf.h (ASM_OUTPUT_SECTION_NAME): emit @nobits
	if changing into .bss section.
	* config/mips/elf64.h: same.
	* config/mips/iris6.h: same.
	* config/mips/netbsd.h: same.
	* config/mips/openbsd.h: same.

2000-12-13  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppfiles.c (read_name_map): Return null if open () fails.
	(remap_filename): Simplify logic.  Add ICE if it doesn't work
	as expected. Perform secondary lookup attempt on base filename
	only.

Wed Dec 13 19:48:04 MET 2000  Jan hubicka  <jh@suse.cz>

	* flow.c (notice_stack_pointer_modification_1): Notice midifications
	using PRE_MODIFY and POST_MODIFY.

Wed Dec 13 17:25:32 MET 2000  Jan Hubicka  <jh@suse.cz>

	* genoutput.c (process_template): Add sanity checking for '@' templates.

2000-12-13  Bernd Schmidt  <bernds@redhat.co.uk>

	* simplify-rtx.c (cselib_finish): Free reg_values and used_regs
	varrays.

2000-12-12  Mike Stump  <mrs@wrs.com>

	* Makefile.in (distclean): Remove safe-ctype.c as well.

2000-12-12  Brad Lucier <lucier@math.purdue.edu>

	* tradcpp.c (do_error): Cast difference of pointers to int
	for error message.

2000-12-12  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/linux.h (HANDLE_PRAGMA_PACK_PUSH_POP): Move from here...
	* config/rs6000/sysv4.h (HANDLE_PRAGMA_PACK_PUSH_POP): ...to here.

2000-12-12  Jim Wilson  <wilson@redhat.com>

	* rtlanal.c (may_trap_p): Check operand modes of LE, LT, GE, and GT.

2000-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* configure.in: Simplify language enabling/disabling code.
	* configure: Rebuilt.
	* ch/config-lang.in (target_libs): Set.
	(build_by_default): Set to no.
	* cp/config-lang.in (target_libs): Set.
	* f/config-lang.in (target_libs): Set.
	* java/config-lang.in (target_libs): Set.
	* objc/config-lang.in (target_libs): Set.

2000-12-12  Neil Booth  <neil@daikokuya.demon.co.uk>

	* tradcpp.c (enum node_type): Add T_ERROR.
	(do_error): New function.
	(directive_table): Add #error handler.

2000-12-12  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* configure.in (HAVE_AS_DWARF2_DEBUG_LINE): Enable .file/.loc check
	for powerpc*-*-*.
	* configure: Regenerated.
	* config/rs6000/linux.h (HANDLE_PRAGMA_PACK_PUSH_POP): Define.
	* config/rs6000/rs6000.c (rs6000_unique_section): Use
	STRIP_NAME_ENCODING.

Mon Dec 11 13:51:09 2000  Jeffrey A Law  (law@cygnus.com)

	* pa.c (cmpib_comparison_operator): Remove GEU and LTU.
	* pa.h (PREDICATE_CODES, cmpib_comparison_operator): Corresponding
	changes.

2000-12-11  Bruce Korb  <bkorb@gnu.org>

	* fixinc/fixincl.tpl: initialize all fields for warnings
	* fixinc/fixincl.x: regenerate

2000-12-11  Neil Booth  <neilb@earthling.net>

	* tradcpp.h: For tradcpp, NUL is not whitespace.

2000-12-11  Neil Booth  <neilb@earthling.net>

	* fix-header.c (read_scan_file): Macro expansion is not a file buffer.

2000-12-05  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (compare_condition, compare_sign_p): New functions.
	(compare_diff_p, compare_eq_p): Call compare_condition.
	(out_tsthi, out_tstsi): Call compare_sign_p.
	(avr_progmem_p): Check for error_mark_node.

2000-12-11  Neil Booth  <neilb@earthling.net>

	* cpperror.c (print_location): New function.
	(print_containing_files): Simplify.
	(_cpp_begin_message): Simplify and use print_location.
	* cppfiles.c (stack_include_file): Update.
	(_cpp_pop_file_buffer): Update.
	* cpphash.h (struct cpp_buffer): New members
	include_stack_listed and type.
	* cpplib.c (_cpp_handle_directive): Buffer->inc is not null.
	(run_directive): Take buffer type.  cpp_push_buffer cannot fail.
	(_cpp_do__Pragma, cpp_define, _cpp_define_builtin, cpp_undef,
	handle_assertion): Update.
	(cpp_push_buffer): Take a buffer type and file name.
	(cpp_pop_buffer): Update.  Clear include_stack_listed.
	* cpplib.h (input_stack_listing_current): Remove.
	(enum cpp_buffer_type): New.
	(cpp_push_buffer): New prototype.
	* cppmacro.c (builtin_macro): Simplify; buffer cannot be null.
	* fix-header.c (read_scan_file): Update.

2000-12-10  Robert Lipe <robertlipe@usa.net>

	* install.texi (i*86-*-sco3.2v5*): Remove information duplicated
	in html version.

2000-12-10  Richard Henderson  <rth@redhat.com>

	* genrecog.c (find_operand): Handle 'V' format code.
	(find_matching_operand): New.
	(validate_pattern): Accept '=' for an in-out operand if there
	is another operand with a matching constraint.

	* config/i386/i386.md (andqi_ext_0_cc): Use matching constraint
	for op1 to op0.

2000-12-10  Richard Henderson  <rth@redhat.com>

	* genrecog.c (validate_pattern) [STRICT_LOW_PART]: Fix thinko.

2000-12-09  Richard Henderson  <rth@redhat.com>

	* genrecog.c (validate_pattern): Verify that ZERO_EXTRACT and
	STRICT_LOW_PART as SET_DEST have in-out constraints.

2000-12-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (check_function_format): Don't suggest adding format
	attributes to functions with no parameter to which to add them.

2000-12-09  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (arm_expand_prologue): Mark the generated
	insn not the set as being DWARF2_FRAME_RELATED_P.

2000-12-09  Laurynas Biveinis  <lauras@softhome.net>

	* Makefile.in: use $(build_exeext) for all build
	system executable targets.

2000-12-09  Laurynas Biveinis  <lauras@softhome.net>

	* install.texi: remove i[345]86-*-winnt3.5 section.
	* configur.bat: removed.
	* config/msdos: directory removed.

2000-12-09  Neil Booth  <neilb@earthling.net>

	* cppfiles.c (NEVER_REREAD, DO_NOT_REREAD): Move from cpphash.h.
	* cpphash.h (NEVER_REREAD, DO_NOT_REREAD, ABSOLUTE_PATH): Delete.
	* cpplex.c (parse_identifier): Improve diagnostic.
	(_cpp_lex_token): Return unconditionally at the end of a directive.
	* cpplib.c (read_flag): Verify legality of each flag.
	(end_directive): Resotre pfile->skipping before skip_rest_of_line.
	(do_line): Use the new read_flag.
	* cppmacro.c (struct cpp_macro, parse_arg, replace_args,
	check_macro_redefinition, parse_params): Rename var_args to
	variadic.

2000-12-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* .cvsignore: Add info files.

2000-12-08 Laurynas Biveinis <lauras@softhome.net>

	* config/winnt: Remove obsolete directory.
	* install.texi (Configurations): Remove obsolete documentation for
	Windows NT.

2000-12-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* configure.in: Don't define INSTALL_INFO.
	* configure: Regenerate.
	* Makefile.in (INSTALL_INFO): Remove.
	(info): Depend on info files in source directory.
	(cpp.info, gcc.info, c-tree.info): Build info files in source
	directory.
	(distclean): Don't remove info files.
	(maintainer-clean): Remove info files from source directory.
	(install-normal): Depend on install-info.
	(install-info): Install info files from source directory, if they
	exist.
	* texinfo.tex: Update to version 2000-11-09.08 from ftp.gnu.org.

2000-12-08  Alexandre Oliva  <aoliva@redhat.com>

	* lcm.c (optimize_mode_switching): Check whether an insn is a NOTE
	before taking its NOTE_LINE_NUMBER.

2000-12-08  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (load_indirect_jump): Add pool ranges.

	* extend.texi: Document ARM "interrupt" function attribute.
	Mention that the ARM also support the "naked" function
	attribute.

	* config/arm/arm-protos.h (arm_current_func_type): Add
	prototype.

	* config/arm/arm.h (EXCEPTION_LR_REGNUM): Define.
	(struct machine_function): Add 'func_type' field.
	Define bit values for 'func_type' field.
	(ARM_FUNC_TYPE): New macro.
	(IS_INTERRUPT): New macro.
	(IS_VOLATILE): New macro.
	(IS_NAKED): New macro.
	(IS_NESTED): New macro.
	(ARM_INITIAL_ELIMINATION_OFFSET): Use IS_VOLATILE.

	* config/arm/arm.c (isr_attribute_args): New Structure.  A
	list of "interrupt" function attribute modifiers.
	(arm_isr_value): New Function: Returns the type of the current
	interrupt function.
	(arm_compute_func_type): New Function: Computes the type of
	the current function.
	(arm_current_func_type): New Function: Returns the type of the
	current function.
	(use_return_insn): Use arm_current_func_type.
	(arm_valid_type_attribute_p): Accept "interrupt" function
	attribute.
	(arm_comp_type_attributes): Check "interrupt" attributes.
	(arm_valid_machine_decl): Accept "interrupt" function
	attribute.
	(arm_function_ok_for_sibcall): Do not allow interrupt
	functions to use sibcalls.
	(arm_naked_function_p): Delete.
	(print_multi_reg): Remove redundant parameter 'hat'.
	(arm_compute_save_reg_mask): New Function: Compute a bit mask
	of registers saved during the current function's prologue.
	(output_arm_return_instruction): Use arm_current_func_type.
	Generate return instruction when LR is not poppsed off the
	stack.
	(arm_volatile_func): Delete.
	(output_arm_prologue): Use arm_current_func_type and
	arm_compute_save_reg_mask.
	Note presernce of interrupt functions.
	(arm_output_epilogue): Use arm_current_func_type and
	arm_compute_save_reg_mask.
	(arm_expand_prologue): Use arm_current_func_type and
	arm_compute_save_reg_mask.
	(arm_init_machine_status): Initialize func_type field, if
	necessary.
	(thumb_expand_prologue): Use arm_current_func_type.
	(output_thumb_prologue): Use arm_current_func_type.

2000-12-08  Brad Lucier <lucier@math.purdue.edu>

	* tradcpp.c (do_include): Make pointer differences 64-bit clean.

Fri Dec  8 08:23:29 2000  J"orn Rennecke <amylaar@redhat.com>

	* fp-bit.c (_fpmul_parts): Use USItype variables as inputs
	for multiplies.

2000-12-07  Mike Stump  <mrs@wrs.com>

	* Makefile.in (distclean): Remove alloca.c hashtab.c.

2000-12-07  Zack Weinberg  <zack@wolery.stanford.edu>

	* Makefile.in (HOST_RTL): Add safe-ctype.o.
	(safe-ctype.o): New rule.
	* system.h: Include safe-ctype.h, not ctype.h.  No need to
	wrap ctype macros.

	* cpphash.h: Zap IStable and related macros.  Define is_* in
	terms of safe-ctype.h macros.
	* cppinit.c: Delete the IStable and all related code.

	* tradcpp.c: Delete is_idchar, is_idstart, is_hor_space, and
	is_space arrays.  Delete initialize_char_syntax.  Change all
	references to the above arrays to use macros instead.
	* tradcpp.h: Define is_idchar, is_idstart, is_space, and
	is_nvspace in terms of safe_ctype.h's macros.
	* tradcif.y: is_idchar, is_idstart are macros not arrays.

	* config/i370/i370.c, config/winnt/dirent.c,
	config/winnt/fixinc-nt.c, config/winnt/ld.c:
	Use uppercase ctype macros.  If we included ctype.h,
	include safe-ctype.h instead.

	* fixinc/fixfixes.c: Use uppercase ctype macros.  Don't test
	ISLOWER(c) before calling TOUPPER(c).
	* fixinc/fixincl.c (extract_quoted_files): Simplify out some gunk.
	* fixinc/gnu-regex.c: Include safe-ctype.h, not ctype.h.  No need to
	wrap ctype macros.  Don't test ISUPPER(x) before calling TOLOWER(x).

2000-12-07  DJ Delorie  <dj@redhat.com>

	* c-decl.c (grokdeclarator): preserve previous alignments when
	rebuilding array types.

2000-12-07  Neil Booth  <neilb@earthling.net>

	* cppfiles.c (struct include_file): Move from cpphash.h.
	(_cpp_never_reread): New function.
	(open_file, read_include_file): Use it.
	(stack_include_file): Set the buffer's sysp according to the
	path in which the file was found.
	(find_include_file): Don't set sysp.
	(cpp_make_system_header, actual_directory): Update.
	(_cpp_execute_include): Do #include_next lookup handling here,
	not in cpplib.c.  Use _cpp_never_reread.
	* cpphash.h (struct_include_file): Remove.
	(struct cpp_buffer): New member sysp.
	(CPP_IN_SYSTEM_HEADER, _cpp_execute_include): Update.
	(_cpp_never_reread): New.
	* cpplib.c (read_line_number): Rename read_flag.  Rework slightly.
	(end_directive): Clear line_extension flag.
	(_cpp_handle_directive): Set line_extension flag for #number.
	(do_include_next): Handle path lookup in _cpp_execute_include.
	(do_line): Cleanup to use read_flag.  Don't allow flags in #line.
	(_cpp_do_file_change): Update.
	(do_pragma_once): Use cpp_never_reread.  Clean up.
	* cpplib.h (struct lexer_state): New member line_extension.

2000-12-07  Richard Henderson  <rth@redhat.com>

	* flow.c (calculate_global_regs_live): Force the stack pointer live
	after reload as well.

2000-12-07  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.*(exeext): the variables are exeext, the
	substitution expression is build_exeext.

2000-12-07  Neil Booth  <neilb@earthling.net>

	* c-common.c (parse_in): Make a cpp_reader *.
	* cppfiles.c (_cpp_fake_include): Remove.
	* cpphash.h: Similarly.
	* cpplib.c (do_line): Don't call _cpp_fake_include.  A valid
	#line always creates a callback; FC_RENAME if there are no
	#line flags.
	* fix-header.c (read_scan_file): cpp_push_buffer cannot fail.
	The first EOF must be our get_char buffer.

2000-12-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (warn_format_security): New variable.
	(check_format_info): Warn about non-literal formats with no format
	arguments if either -Wformat-nonliteral or -Wformat-security is
	specified.
	(set_Wformat): Set warn_format_security for settings other than 1.
	* c-common.h (warn_format_security): Declare.
	* c-decl.c (c_decode_option): Decode -Wformat-security and
	-Wno-format-security.
	* invoke.texi: Document -Wformat-security.
	* toplev.c (documented_lang_options): Include -Wformat-security
	and -Wno-format-security.

2000-12-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (check_format_info): Warn for non-constant format
	strings with strftime formats if -Wformat-nonliteral.  Where the
	format can convert arguments, if the format is not a string
	literal and there are no arguments to the format, give a different
	warning message from the general non-string-literal case.

2000-12-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (format_wanted_type): Add reading_from_flag.
	(print_char_table): Mark %s and %S formats with flag "R".
	(check_format_info_main): Set up reading_from_flag appropriately.
	If aflag, always set writing_in_flag rather than relying on the
	format used being a scanf format and so having it set.
	(check_format_types): Check for formats reading through null
	pointers.

2000-12-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi (-Wformat): Document what format features are
	checked.

2000-12-06  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.h: Fix formatting.

2000-12-06      Joel Sherrill <joel@OARcorp.com>

	* config.gcc (a29k*-*-rtems*, arm*-*-rtems*, c4x-*-rtems*,
	h8300-*-rtems*, hppa1.1-*-rtems, *mips*-*-rtems*): New targets.
	* config.gcc (*-rtems*): Add support for gthr-rtems.h.
	* gthr-rtems.h, config/a29k/rtems.h, config/arm/rtems-elf.h,
	config/h8300/rtems.h, config/mips/rtems.h: New files.

2000-12-06  Mark Kettenis  <kettenis@gnu.org>

	* config.gcc: Reorganize handling of *-*-gnu*, to share target
	specific make details with Linux.  Update comments to clarify
	the distinction between GNU/Linux and GNU/Hurd.

Wed Dec  6 19:22:02 2000  Jeffrey A Law  (law@cygnus.com)

	* contrib.texi: Fix my email address.  Update Per's
	list of contributions.

2000-12-06  Rodney Brown  <RodneyBrown@mynd.com>

	* c-lex.c (cb_indent): Decorate `str' argument, unused on HP-UX.
	* collect2.c (scan_libraries): Remove unused `ch'.
	(COFF specific stuff): Prototype ldgetname.  Declare and prototype
	ldbtread and ldclose.

	* config/alpha/osf.h: Standarize copyright statement.
	* config/arc/arc.h: Likewise.
	* config/arm/elf.h config/arm/coff.h config/arm/aout.h: Likewise.
	* config/arm/arm.c config/arm/arm.h: Likewise.
	* config/elxsi/elxsi.h: Likewise.
	* config/i386/sco.h: Likewise.
	* config/m68k/crds.h config/m68k/hp320.h config/m68k/lynx.h: Likewise.
	* config/m68k/m68kv4.h config/m68k/next21.h: Likewise.
	* config/m68k/sun3.h: Likewise.
	* config/m88k/dgux.h config/m88k/dguxbcs.h: Likewise.
	* config/pdp11/2bsd.h config/pdp11/pdp11.h: Likewise.
	* config/romp/romp.h: Likewise.
	* config/rs6000/aix41.h: Likewise.
	* config/sparc/sysv4.h: Likewise.
	* config/we32k/we32k.c config/we32k/we32k.h: Likewise.
	* fixinc/gnu-regex.c fixinc/gnu-regex.h: Likewise.
	* cpplib.h cppexp.c cselib.h profile.c: Likewise.
	* longlong.h: Likewise.
	* libgcc2.c: Likewise.

2000-12-06 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* machmode.def: Use correct definition for BITSIZE on targets where
	BITS_PER_UNIT != 8.

2000-12-06  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.*: Reduce differences to (ultimately) reduce
	the number of them.

2000-12-06  J. David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c: Include expr.h before c-tree.h.
	(remove_useless_addtr_insns): Use reverse_condition_maybe_unordered
	instead of reverse_condition.
	(print_operand): Correct predicates for GT, GE, LT and LE.  Add
	predicates for LTGT, UNLE, UNLT, UNGE, UNGT, UNEQ, UNORDERED and
	ORDERED.
	(cmpib_comparison_operator): Add GEU and LTU codes.
	* pa.h (PREDICATE_CODES): Add codes for cmpib_comparison_operator.
	* pa.md (bltgt, bunle, bunlt, bunge, bungt, buneq, bunordered,
	bordered): New float conditional branch patterns.

Wed Dec  6 21:03:41 2000  J"orn Rennecke <amylaar@redhat.com>

	* final.c (final_addr_vec_align): Fix clipping to BIGGEST_ALIGNMENT.

2000-12-06  Sylvain Pion  <Sylvain.Pion@sophia.inria.fr>

	* cpplex.c (skip_escaped_newlines): Don't warn for spaces between
	backslash and newline, when inside a comment.

2000-12-06  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Use @table @samp instead of @itemize @minus for
	table of language standards.  Fix use of @pxref.  From Zack
	Weinberg.  Also exclude specs documentation from generated
	manpage, and create separate ENVIRONMENT section.

2000-12-06  Michael Matz  <matzmich@cs.tu-berlin.de>

	* gcse.c (compute_pre_data): Kill trapping expressions in
	destination blocks of abnormal edges.

2000-12-05  Richard Sandiford  <r.sandiford@redhat.com>

	* config/mn10300/mn10300.c (mn10300_print_reg_list): Added.
	(mn10300_get_live_callee_saved_regs): Likewise.
	(mn10300_gen_multiple_store): Likewise.
	(store_multiple_operation): Likewise.
	(expand_prologue): Use mn10300_gen_multiple_store().
	* config/mn10300/mn10300-protos.h (mn10300_print_reg_list): Added.
	(mn10300_get_live_callee_saved_regs): Likewise.
	(mn10300_gen_multiple_store): Likewise.
	(store_multiple_operation): Likewise.
	* config/mn10300/mn10300.md (store_movm): Use a MATCH_PARALLEL
	tied to store_multiple_operation().

Tue Dec  5 20:09:14 2000  Jeffrey A Law  (law@cygnus.com)

	* builtins.c (expand_builtin_setjmp_setup): Set
	current_function_has_nonlocal_label.

2000-12-05  Neil Booth  <neilb@earthling.net>

	* cppfiles.c (stack_include_file): Push zero-length buffers
	in case of failure.  Return void, as we don't fail any more.
	(read_include_file): Check for files we shouldn't re-read.
	Don't return an error code; errors are implied by marking the
	file NEVER_REREAD.
	(_cpp_execute_include): Move the recursion and in-macro checks
	here.  Update for stack_include_file not failing.
	* cpplib.c (cpp_push_buffer): Always succeed, since
	_cpp_execute_include performs the recursion check.  Tidy up.
	* cpplib.h (cpp_push_buffer): Update prototype.

2000-12-05  Alexandre Oliva  <aoliva@redhat.com>

	* sched-vis.c (visual_tbl_line_length): New variable.
	(get_visual_tbl_length): Set it.
	(visualize_stall_cycles): Don't let stalls overrun
	visual_tbl_line_length.

2000-12-05  Geoffrey Keating  <geoffk@redhat.com>

	* global.c (global_conflicts): Allow for a REG_UNUSED note
	with a different mode to the REG set in the insn.

2000-12-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (fixinc.sh): Pass $WARN_CFLAGS into fixinc dir.

	* fixinc/Makefile.in (FIXINC_DEFS): Add $(WARN_CFLAGS).

2000-12-05  Bruce Korb  <bkorb@gnu.org>

	* fixinc/mkfixinc.sh(*-gnu*): activate fixinc for GNU/Hurd and
	GNU/Linux.

2000-12-05  Richard Earnshaw  <rearnsha@arm.com>

	* fixinc/mkfixinc.sh: Run fixinc on netbsd.
	* fixinc/inclhack.def (machine/ansi.h): Run this rule on all files,
	to cope with aliased copies.
	* fixinc/fixincl.x: Regenerate.

2000-12-05  Bernd Schmidt  <bernds@redhat.co.uk>

	* sched-vis.c: Guard with #ifdef INSN_SCHEDULING.
	* sched-rgn.c: Likewise.
	(rgn_print_insn): Fix output.

2000-12-05  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.*: make these more consistent
	* fixinc/mkfixincl.sh: enable BeOS fixincludes

2000-12-05  Richard Henderson  <rth@redhat.com>

	* stmt.c (warn_if_unused_value): Move side effects test earlier.

2000-12-05  Alan Modra <alan@linuxcare.com.au>

	* bb-reorder.c (reorder_basic_blocks): Do check for EH edges even
	when using sjlj.

2000-12-05  Richard Henderson  <rth@redhat.com>

	* flow.c (calculate_global_regs_live): Only force stack pointer
	live before reload.  Force pic register live before reload.
	(insn_dead_p): Don't protect pic references from deletion.

2000-12-05  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Add support for using texi2pod.pl.  Don't use
	@multitable.

2000-12-04  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (arm_override_options): Test 'insn_flags' not
	'tune_flags' for XScale nature.
	Remove spurious test of HARD_FLOAT and XScale flags.

	* config/arm/arm.md (umulsidi3adddi): Restore "=&r" register
	contraint, accidentally changed during XScale contribution.

	* config/arm/lib1funcs.asm (interwork_call_via_, call_via_): Do
	not create these functions if the target architecture does not
	support Thumb instructions.

2000-12-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* ONEWS: New file with the current contents of NEWS up to EGCS
	1.1.
	* NEWS: Generate automatically from online release notes from EGCS
	1.0 to GCC 2.95.2, using ../contrib/gennews.

2000-12-04  Neil Booth  <neilb@earthling.net>

	* tradcif.y: Move lexptr to top of file.  Add rule to handle
	assertions in conditional expressions.
	* tradcpp.c (parse_answer): Assertions do not need to go to
	end of line in conditional directives.
	(parse_assertion): Get first character of identifiers correct.
	(test_assertion): New function.
	* tradcpp.h (test_assertion): New prototype.

2000-12-01  Rodney Brown  <RodneyBrown@mynd.com>

	* config.gcc: Fix typo for UnixWare 7.

2000-12-03  Phil Edwards  <pme@sources.redhat.com>

	* invoke.texi:  Replace `pedwarns' with clearer text.

2000-12-04  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.*(clean):  don't clean autogenerated files.
	(mainainer-clean): clean autogenerated files

2000-12-04  DJ Delorie  <dj@redhat.com>

	* md.texi: Add overview, clarify match_dup and define_expand.

2000-12-04  DJ Delorie  <dj@redhat.com>

	* print-tree.c (print_node): Target-specific builtins print
	numbers, not names.

2000-12-04  Jason Merrill  <jason@redhat.com>

	* stor-layout.c (int_mode_for_mode): Handle MODE_VECTOR_INT,
	MODE_VECTOR_FLOAT.

	* diagnostic.c (report_problematic_module): s/function/module/.

	* c-lex.h: Remove decl for check_newline.

2000-12-04  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.APOLLO: Remove obsolete file.

2000-12-04  Neil Booth  <neilb@earthling.net>

	* cppinternals.texi: New file.

2000-12-04  Neil Booth  <neilb@earthling.net>

	* cppfiles.c (cpp_make_system_header): Take 2 booleans,
	and operate on current buffer.
	(cpp_read_file): Rename _cpp_read_file.
	* cpplib.c (do_line, do_pragma_system_header): Update calls to
	cpp_make_system_header.
	* fix-header.c: Similarly.
	* cpphash.h (_cpp_read_file): Move from...
	* cpplib.h: ... here.
	* cppinit.c (do_includes, cpp_start_read): Update appropriately.

2000-12-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strspn, expand_builtin_strcspn):
	Handle another transformation.

2000-12-03  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Add support for StrongARM targets.
	* config/arm/t-strongarm-elf: New file.
	* config/arm/t-strongarm-coff: New file.
	* config/arm/t-strongarm-pe: New file.
	* config/arm/strongarm-pe.h: New file.

2000-12-03  Nick Clifton  <nickc@redhat.com>

	* NEWS: Mention XScale has been added.
	* config.gcc: Add support for XScale targets.
	* config/arm/arm.h: Add support for XScale processor.
	* config/arm/arm.c: Add support for XScale processor.
	* config/arm/arm.md: Add support for XScale processor.
	* config/arm/t-xscale-elf: New file.
	* config/arm/t-xscale-coff: New file.
	* config/arm/xscale-elf.h: New file.
	* config/arm/xscale-coff.h: New file.

2000-12-03  Richard Henderson  <rth@redhat.com>

	* bb-reorder.c (reorder_basic_blocks): Don't check for EH edges
	unless exception handling is enabled, and if not using sjlj.

	* builtins.c (expand_builtin_setjmp_setup): New.
	(expand_builtin_setjmp_receiver): New.
	(expand_builtin_setjmp): Split out _setup and _receiver functions.
	Move argument parsing in from ...
	(expand_builtin): ... here.
	* except.c (receive_exception_label): Branch around receiver
	unless new-style exceptions.  Call expand_builtin_setjmp_receiver.
	(start_dynamic_handler): Call expand_builtin_setjmp_setup.
	* expr.h: Update builtin setjmp decls.

2000-12-03  Bruce Korb  <bkorb@gcc.org>

	* fixinc/mkfixinc.sh(build machine): Sometimes, there is no canonical
	build machine name.  Default to the target.

2000-12-03  Laurynas Biveinis  <lauras@softhome.net>

	* Makefile.in: use $(build_canonical), not $(canonical_build).

2000-12-03  Bernd Schmidt  <bernds@redhat.co.uk>

	* Makefile.in (OBJS): Add sched-rgn.o.
	(sched-rgn.o): New rule.  * haifa-sched.c (sched_verbose): No
	longer static.
	(INSN_PRIORITY, INSN_COST, INSN_UNIT, INSN_REG_WEIGHT,
	INSN_BLOCKAGE, UNIT_BITS, BLOCKAGE_MASK, ENCODE_BLOCKAGE,
	UNIT_BLOCKED, BLOCKAGE_RANGE, MIN_BLOCKAGE_COST,
	MAX_BLOCKAGE_COST): Move to sched-int.h.
	(MAX_RGN_BLOCKS, MAX_RGN_INSNS, INSN_REF_COUNT, FED_BY_SPEC_LOAD,
	IS_LOAD_INSN, struct haifa_edge, edge_table, NEXT_IN, NEXT_OUT,
	FROM_BLOCK, TO_BLOCK, nr_edges, in_edges, out_edges, IN_EDGES,
	OUT_EDGES, edgelst, struct region, nr_regions, rgn_table,
	rgn_bb_table, block_to_bb, containing_rgn, RGN_NR_BLOCKS,
	RGN_BLOCKS, BLOCK_TO_BB, BB_TO_BLOCK, CONTAINING_RGN,
	debug_regions, find_single_block_region, find_rgns, too_large,
	init_regions, current_nr_blocks, current_blocks, bitset, bitlst,
	bitlst_table_last, bitlst_table_size, bitlst_table, bitset_member,
	extract_bitlst, bblst, struct candidate, candidate_table,
	bblst_table, bblst_size, bblst_last, IS_VALID, IS_SPECULATIVE,
	SRC_PROB, target_bb, split_edges, compute_trg_info,
	debug_candidate, debug_candidates, bbset, bbset_size, dom,
	IS_RGN_ENTRY, IS_DOMINATED, prob, GET_SRC_PROB, edgeset,
	rgn_nr_edges, rgn_edges, edgeset_size, edgeset_bitsize,
	EDGE_TO_BIT, edge_to_bit, pot_split, ancestor_edges,
	compute_dom_prob_ps, ABS_VALUE, INSN_PROBABILITY,
	IS_SPECULATIVE_INSN, INSN_BB, MIN_DIFF_PRIORITY, MIN_PROBABILITY,
	MIN_PROB_DIFF, check_live_1, update_live_1, check_live,
	update_live, set_spec_fed, is_pfree, find_conditional_protection,
	is_conditionally_protected, may_trap_exp, haifa_classify_insn,
	is_prisky, is_exception_free, add_branch_dependences,
	propagate_deps, compute_block_backward_dependences,
	debug_dependencies, is_cfg_nonregular, build_control_flow,
	new_edge, bb_deps, BITSET_UNION, BITSET_INTER, BITSET_DIFFER,
	BITSET_INVERT, BITSET_ADD, BITSET_REMOVE, debug_regions,
	UPDATE_LOOP_RELATIONS, INSN_TRAP_CLASS, WORST_CLASS, IS_REACHABLE,
	CONST_BASED_ADDRESS_P, free_pending_lists, sched_target_n_insns,
	target_n_insns, sched_n_insns, init_ready_list, deaths_in_region,
	can_schedule_ready_p, new_ready, schedule_more_p, rgn_print_insn,
	rgn_rank, region_sched_info): Move to sched-rgn.c.
	(debug_reg_vector): Delete useless function.
	(get_bb_head_tail): Likewise.
	(insn_issue_delay, insn_cost, ready_add, get_block_head_tail,
	no_real_insns_p, rm_line_notes, save_line_notes,
	restore_line_notes, rm_redundant_line_notes, sched_init): No
	longer static.
	(rm_line_notes, save_line_notes, restore_line_notes,
	schedule_block, set_priorities): Change argument to be a real
	basic block, not one of haifa's "bb"s.  All callers changed
	(rm_other_notes): Initialize note_list here, not in
	schedule_region.
	(sched_finish): New function, called from schedule_insn.  * *
	sched-int.h (INSN_PRIORITY, INSN_COST, INSN_UNIT, INSN_REG_WEIGHT,
	INSN_BLOCKAGE, UNIT_BITS, BLOCKAGE_MASK, ENCODE_BLOCKAGE,
	UNIT_BLOCKED, BLOCKAGE_RANGE, MIN_BLOCKAGE_COST,
	MAX_BLOCKAGE_COST): Moved here from haifa-sched.c.
	(get_block_head_tail, no_real_insns_p, rm_line_notes,
	save_line_notes, restore_line_notes, rm_redundant_line_notes,
	rm_other_notes, insn_issue_delay, set_priorities, schedule_block,
	sched_init, sched_finish, ready_add, insn_cost): Declare.

2000-12-03  Laurynas Biveinis  <lauras@softhome.net>
	    Bruce Korb  <bkorb@gnu.org>

	* Makefile.in: pass $(build_canonical) to mkfixinc.sh.
	* fixinc/mkfixinc.sh: accept build system name as an argument.
	Use it for choosing the fix build method.  Use the target for
	selecting special fix rules.

2000-12-03  Bernd Schmidt  <bernds@redhat.co.uk>

	* Makefile.in (OBJS): Add sched-deps.o.
	(sched-deps.o): New rule.
	* haifa-sched.c (struct deps, struct haifa_insn_data): Moved to
	sched-int.h.
	(INSN_DEPEND, INSN_LUID, CANT_MOVE, INSN_DEP_COUNT): Macros moved to
	sched-int.h.
	(SIZE_FOR_MODE): Delete unused macro.
	(reg_known_equiv_p, reg_known_value, reg_pending_clobbers,
	reg_pending_sets, reg_pending_sets_all, true_dependency_cache,
	anti_dependency_cache, output_dependency_cache,
	forward_dependency_cache): Variables moved to sched-deps.c.
	(add_dependence, remove_dependence, find_insn_list,
	find_insn_mem_list, add_insn_mem_dependence, flush_pending_lists,
	sched_analyze_insn, sched_analyze_1, sched_analyze_2,
	sched_analyze, group_leader, compute_forward_dependences,
	init_deps, free_deps, init_dependency_caches, free_dependency_caches):
	Functions moved to sched-deps.c.
	(schedule_region): Call init_deps_global and finish_deps_global
	instead of directly manipulating dependency data structures.
	* sched-deps.c: New file.
	(init_deps_global, finish_deps_global): New functions.
	* sched-int.h (struct haifa_insn_data, struct deps): Moved here from
	haifa-sched.c.
	(h_i_d): Declare.
	(INSN_DEPEND, INSN_LUID, CANT_MOVE, INSN_DEP_COUNT): Macros moved here
	from haifa-sched.c.

	* Makefile.in (OBJS): Add sched-vis.o.
	(sched-vis.o): New rule.
	* haifa-sched.c (get_unit_last_insn): New function.
	(sched_dump, insn_unit, actual_hazard_this_instance): No longer
	static.
	(schedule_block): Call visualize_alloc and visualize_free.  Delete
	spurious return statement.
	(init_target_units, insn_print_units, get_visual_tbl_length,
	init_block_visualization, print_block_visualization, safe_concat,
	visualize_scheduled_inns, visualize_no_unit, visualize_stall_cycles,
	print_exp, print_value, print_pattern, print_insn, target_units,
	MAX_VISUAL_LINES, INSN_LEN, n_visual_lines, visual_tbl,
	n_vis_no_unit, vis_no_unit): Move scheduling visualization
	functions/variables...
	* sched-vis.c: ...here.  New file.
	(visualize_alloc, visualize_free): New functions.
	(visualize_scheduled_insns, visualize_stall_cycles,
	print_block_visualization): Lose basic block argument.  All callers
	changed.
	(visualize_scheduled_insns): Use new function get_unit_last_insn.
	* sched-int.h (current_sched_info, sched_dump): Declare.
	(init_target_units, insn_print_units, init_block_visualization,
	print_block_visualization, visualize_scheduled_inns,
	visualize_no_unit, visualize_stall_cycles, visualize_alloc,
	visualize_free): Declare functions.

	* sched-int.h: New file.
	* Makefile.in (haifa-sched.o): Depend on it.
	* haifa-sched.c: Include it.
	(no_real_insns_p): New function.
	(current_sched_info): New static variable.
	(__inline, HAIFA_INLINE): Moved to sched-int.h.
	(get_block_head_tail): Minor cleanup.
	(init_ready_list, can_schedule_ready_p, new_ready, schedule_more_p,
	rgn_print_insn, rgn_rank): New functions, broken out of
	rank_for_schedule, schedule_insn and schedule_block, where they
	are now called through function pointers in current_sched_info.
	(queue_insn, schedule_insn, queue_to_ready, debug_ready_list,
	print_insn): To display uid and block number, call the print_insn
	function pointer in current_schedule_info.
	(region_sched_info): New static variable.
	(sched_target_n_insns, sched_n_insns, target_n_insns): New global
	variables, moved out of schedule_block.
	(schedule_block): Return void.  All callers changed.
	Move some of the setup code into schedule_region.  Get head/tail
	from current_sched_info, and update it when done.
	(schedule_region): Slightly rearranged, some code moved here from
	schedule_block.  Call no_real_insns_p to avoid doing work for a
	block that consists only of notes and labels.
	(schedule_insns): Initialize current_sched_info.

2000-12-03  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (funlike_invocation_p): Re-disable macros enabled
	by contexts drops AFTER argument pre-expansion, so that they
	remain enabled during argument pre-expansion.
	(_cpp_pop_context): Unconditionally re-enable a macro when
	dropping a context level.

2000-12-03  Manfred Hollstein  <manfredh@redhat.com>

	* arm/t-linux (MULTILIB_OPTIONS): Comment.
	(MULTILIB_DIRNAMES): Likewise.
	(EXTRA_MULTILIB_PARTS): Likewise.
	(LIBGCC): Likewise.
	(INSTALL_LIBGCC): Likewise.

2000-12-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strcat, expand_builtin_strncat,
	expand_builtin_strspn, expand_builtin_strcspn): New functions.
	(expand_builtin): Handle BUILT_IN_STRCAT, BUILT_IN_STRNCAT,
	BUILT_IN_STRSPN and BUILT_IN_STRCSPN.

	* builtins.def (BUILT_IN_STRCAT, BUILT_IN_STRNCAT,
	BUILT_IN_STRSPN, BUILT_IN_STRCSPN): New entries.

	* c-common.c (c_common_nodes_and_builtins): Declare builtin
	strcat, strncat, strspn and strcspn.
	(string_ftype_string_cstring): Renamed from `string_ftype_ptr_ptr'.

	* extend.texi (strcat, strcspn, strncat, strspn): Document new
	builtins.

2000-12-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strcmp): Use const*_rtx when
	expanding strcmp at compile-time.  Add another transformation.
	(expand_builtin_strncmp): Add more transformations.  Call
	expand_builtin_memcmp, not expand_builtin_strcmp, under
	appropriate conditions if HAVE_cmpstrsi.

2000-12-02  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (anddi3_internal[23]): Prefer rldic? over andis
	instruction.
	(cr logic): Really make operands sequential.

2000-12-02  Geoffrey Keating  <geoffk@redhat.com>

	* c-common.c (combine_strings): When the ISO C standard specifies
	the maximum length of a string, it doesn't include the trailing
	zero byte.

	* cpplib.c (do_ifdef): Add check_eol() call.
	(do_ifndef): Likewise.

2000-12-02  Daniel Berlin  <dberlin@redhat.com>
	    Bruce Korb  <bkorb@gnu.org>

	* fixinc/*: global substitute /__MSDOS__/SEPARATE_FIX_PROC/
	* fixinc/mkfixinc.sh: prepare to use Makefile.BEOS for *-*-beos*
	* fixinc/Makefile.DOS: define SEPARATE_FIX_PROC for build
	* fixinc/fixfix.c(wrap_fix): avoid wrapping files that
	use the "__need_" hackery.  It breaks them.
	* fixinc/fixincl.c(process - SEPARATE_FIX_PROC):
	Sometimes on DOS and BeOS the temp output file cannot be opened.
	Skip the file noisily.  Ought to be fixed instead.

2000-12-02  Bruce Korb  <bkorb@gnu.org>

	From: 2000-11-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixfixes.c (emit_gnu_type, format_write): Prototype.
	(format_write, char_macro_use_fix, char_macro_def_fix): Use gcc's
	custom uppercase ctype macros.
	* fixincl.c (do_version): Make static and add ATTRIBUTE_NORETURN.
	Use gcc's custom uppercase ctype macros.
	(main): Prototype.
	(machine_matches): Add static prototype and constify variable.
	(create_file, test_test, egrep_test): Add static prototype.
	(quoted_file_exists): Likewise, and constify parameters.
	(extract_quoted_files, internal_fix, start_fixer, fix_applies,
	write_replacement, test_for_changes): Add static prototype.
	(write_replacement, test_for_changes): Delete excess argument to
	`create_file'.
	* fixtests.c (test): Make static.
	* server.c (load_data, sig_handler, server_setup, find_shell): Add
	static prototype.
	(sig_handler): Mark parameter with ATTRIBUTE_UNUSED.

2000-12-02  Bruce Korb  <bkorb@gnu.org>

	* fixnc/mkfixinc.sh(msdosdjgpp): remove from fixincludes exception list
	(per Laurynas Biveinis  <lauras@softhome.net>)

2000-12-02  Richard Earnshaw  <rearnsha@arm.com>

	* arm.h (ARM_REGNO_OK_FOR_BASE_P, THUMB_REGNO_MODE_OK_FOR_BASE_P): New
	macros.
	(REGNO_MODE_OK_FOR_BASE_P): Define in terms of above.
	(REGNO_OK_FOR_FOR_BASE_P): Delete.
	(ARM_REG_OK_FOR_BASE_P, THUMB_REG_MODE_OK_FOR_BASE_P): New macros for
	both strict and non-strict uses.
	(REG_MODE_OK_FOR_BASE_P): Define in terms of above.
	(ARM_REG_OK_FOR_INDEX_P, THUMB_REG_OK_FOR_INDEX_P): New macros.
	(REG_OK_FOR_INDEX_P): Define in terms of above.
	(REG_OK_FOR_BASE_P): Delete.
	(REG_OK_FOR_PRE_POST_P): Delete.
	(ARM_BASE_REGISTER_RTX_P): Renamed from BASE_REGISTER_RTX_P.
	(ARM_INDEX_REGISTER_RTX_P): Renamed from INDEX_REGISTER_RTX_P.
	(ARM_GO_IF_LEGITIMATE_INDEX): Renamed from GO_IF_LEGITIMATE_INDEX.
	(THUMB_LEGITIMATE_OFFSET): Renamed from LEGITIMATE_OFFSET.
	(ARM_GO_IF_LEGITIMATE_ADDRESS): Adjust for name changes.  Use ARM
	specific variants rather than general ones.  Use ARM_REG_OK_FOR_BASE_P
	in pre/post increment cases.
	(THUMB_GO_IF_LEGITIMATE_ADDRESS): Similarly for Thumb.
	(ARM_LEGITIMIZE_ADDRESS): Similarly.
	(THUMB_LEGITIMIZE_RELOAD_ADDRESS): Similarly.
	* arm.c (legitimate_pic_address): Similarly.

2000-12-02  Neil Booth  <neilb@earthling.net>

	* tradcpp.c (struct answer, parse_assertion, parse_answer,
	canonicalize_text, find_answer): New.
	(do_assert, do_unassert): Provide appropriate function bodies.
	(union hashval): New member answers.

2000-11-23  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.md: Document UNSPEC usage.
	(*tablejump_rjmp, *tablejump_lib, *tablejump_enh, *tablejump):
	Make operand 0 input only, clobber it.  Use UNSPEC, not a bogus
	MEM for program memory word reference.  Do not add the label to
	the table index in each of the asm output templates, instead ...
	(casesi): ... do it in RTL.  Adjust to match the above change.

2000-12-02  Bernd Schmidt  <bernds@redhat.co.uk>

	* c-common.c (PTRDIFF_TYPE): Provide default here, ...
	* c-decl.c: ... not here.

	* haifa-sched.c (sched_dump): Renamed from dump.  All users changed.
	(old_max_uid): New variable.
	(compute_forward_dependences): Renamed from
	compute_block_forward_dependences; changed to accept block head and
	tail instead of block number.  Caller changed.
	(free_deps, init_dependency_caches, free_dependency_caches,
	init_regions, sched_init): New functions, split out from
	schedule_insns and compute_block_backward_dependences.

2000-12-02  Neil Booth  <neilb@earthling.net>

	* cppexp.c (parse_number): Update diagnostic test.

2000-12-02  Bernd Schmidt  <bernds@redhat.co.uk>

	* reload1.c (free_for_value_p): New function, frontend to
	reload_reg_free_for_value_p.  All callers of the latter now call
	this function with an additional mode argument.

2000-12-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* install.texi (Configurations): Remove obsolete documentation for
	hppa*-*-*.

2000-12-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* install.texi (Installation): Remove obsolete description for
	libstdc++ which is now an integral part of GCC.

2000-12-01  Jim Blandy  <jimb@redhat.com>

	* dbxout.c (dbxout_parms): Correctly describe parameters passed by
	invisible reference in registers, but then spilled to the stack.
	Remove code to emit a second stab for such parameters; it attempts
	to describe the value's location by introducing a synthetic C++
	`reference' type, and then saying the stack slot has that
	reference type.  This loses type information (breaking GDB's
	`ptype' command, among other things) just to describe a location
	which stabs can represent correctly in other ways.

2000-12-01  Alexandre Oliva  <aoliva@redhat.com>

	* final.c (output_addr_const) <PLUS>: Don't assume at least one
	operand is a CONST_INT.

	* config/sh/sh.c (reg_class_from_letter): Assign `k' to SIBCALL_REGS.
	(machine_dependent_reorg): Split all insns.
	* config/sh/sh.h (CONDITIONAL_REGISTER_USAGE): Compute
	reg_class_contents[SIBCALL_REGS].
	(reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS): Add SIBCALL_REGS.
	* config/sh/sh.md (calli_pcrel, call_pcrel, call_valuei_pcrel,
	call_value_pcrel, call, call_value, sibcall): Match even when
	not optimizing.
	(sibcalli_pcrel, sibcall_pcrel): Likewise.  Use constraint `k'
	for call address.
	(sibcalli): Likewise.

2000-12-01  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (warn_format, warn_format_y2k,
	warn_format_extra_args, warn_format_nonliteral): Define.
	(check_format_info): Check warn_format_nonliteral and
	warn_format_extra_args.
	(check_format_info_main): Check warn_format_y2k.
	(set_Wformat): New function.
	* c-common.h (warn_format_y2k, warn_format_extra_args,
	warn_format_nonliteral, set_Wformat): Declare.
	* c-decl.c (warn_format): Remove definition.
	(c_decode_option): Handle -Wformat-nonliteral,
	-Wno-format-extra-args and -Wno-format-y2k, and negated versions.
	Use set_Wformat.
	* invoke.texi: Document these new options and -Wformat=2.
	* toplev.c (documented_lang_options): Add these new options.

2000-12-01  Joseph S. Myers  <jsm28@cam.ac.uk>

	* builtins.def (BUILT_IN_IMAXABS): Add.
	* builtins.c (expand_builtin): Also abort on BUILT_IN_IMAXABS.
	* c-common.c (c_common_nodes_and_builtins): Create builtin
	functions __builtin_imaxabs, and plain imaxabs unless
	flag_no_nonansi_builtin outside C99 mode.
	(expand_tree_builtin): Handle BUILT_IN_IMAXABS.
	* extend.texi: Document builtin imaxabs.

2000-12-01  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c: Include "defaults.h".
	(WINT_TYPE, INTMAX_TYPE, UINTMAX_TYPE): Define.
	(c_common_nodes_and_builtins): Create string_type_node,
	const_string_type_node, wint_type_node, intmax_type_node,
	uintmax_type_node, default_function_type, ptrdiff_type_node and
	unsigned_ptrdiff_type_node.
	* c-common.h (identifier_global_value): Declare.
	* c-decl.c (WINT_TYPE, INTMAX_TYPE, UINTMAX_TYPE): Don't define.
	(init_decl_processing): Don't create string_type_node,
	const_string_type_node, wint_type_node, intmax_type_node,
	uintmax_type_node, default_function_type, ptrdiff_type_node and
	unsigned_ptrdiff_type_node.
	(identifier_global_value): New function.

2000-12-01  Neil Booth  <neilb@earthling.net>

	* cppinit.c (initialize): Forgotten prototype.
	* cpplex.c (_cpp_lex_token): Loop until not skipping.
	Always clear PREV_WHITE upon meeting a new line.
	* cpplib.c (end_directive): Set pfile->skipping after
	skip_rest_of_line.
	* cpplib.h (cpp_reader): Remove macro_pos.
	* cppmacro.c (cpp_get_line): Don't do anything special inside
	macros.
	(parse_arg): Add PREV_WHITE if a token appears after new lines.
	(funlike_invocation_p): Save and restore the output position
	over a successful check for a '('.
	(enter_macro_context): Delete uses of macro_pos.
	(cpp_get_token): Don't use pfile->skipping.

2000-12-01  Phil Edwards  <pme@sources.redhat.com>

	* diagnostic.c:  Fix typos in comments.
	* diagnostic.h:  Likewise.

2000-11-30  Phil Edwards  <pme@sources.redhat.com>

	* rtl.texi (Machine Modes):  Document BImode and OImode.

2000-12-01  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.c (default_compilers): Add suffixes .mi, .cp, .ii, .FOR and
	.FPP.

2000-12-01  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (grokdeclarator): If pedantic, warn about arrays with
	incomplete element type.
	(grokparms): Before checking for incomplete parameter type, check
	the type isn't error_mark_node.

2000-12-01  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (target_char_cast): New function.
	(expand_builtin_strchr): Use it.
	(expand_builtin_strrchr): Use it.
	(builtin_memset_read_str): New function.
	(expand_builtin_memset): Use target_char_cast.
	Try to optimize memset with second argument nonzero using
	store_by_pieces.

2000-11-30  Marek Michalkiewicz  <marekm@linux.org.pl>

	* install.texi (avr): Replace incomplete list of supported MCU
	types with a link to the current one ...
	* invoke.texi (AVR Options): ... here.  Update -mmcu= to list
	all supported MCU types.  Document -minit-stack= default.
	Document new options -mno-tablejump, -mtiny-stack.
	* md.texi (AVR family):  Fix typo in 'w' constraint letter
	description.  Document 'q'.  Update 'O'.

2000-12-01  Bernd Schmidt  <bernds@redhat.co.uk>

	* combine.c (cant_combine_insn_p): Only disallow insns involving
	hard regs if they are reg-reg moves.
	(try_combine, can_combine_p, combinable_i3pat): Delete old
	SMALL_REGISTER_CLASSES tests.

2000-12-01  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (shiftcosts): Don't get INTVAL before testing
	whether X is a CONST_INT.
	(addsubcosts): Likewise.

	* config/sh/sh.h (OUTPUT_ADDR_CONST_EXTRA): Use INTVAL instead of
	mis-used XINT.
	(ARG_POINTER_REGNUM): Set to AP_REG.

2000-11-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (fpu_switch0, fpu_switch1, movpsi, fpu_switch,
	splits): Only match on TARGET_SH4.

	* combine.c (try_combine): Disregard USEs when updating LOG_LINKS
	of subsequent insns.

2000-11-30  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (ASM_OUTPUT_MI_THUNK): Disable.
	* config/alpha/alpha32.h (ASM_OUTPUT_MI_THUNK): Likewise.

2000-11-30  Richard Henderson  <rth@redhat.com>

	* config/alpha/elf.h (ASM_OUTPUT_SECTION_NAME): Copy elfos.h defn.
	(DO_SELECT_SECTION): New.
	(SELECT_SECTION): Use it.
	(UNIQUE_SECTION_P): New.
	(UNIQUE_SECTION): New.

2000-11-30  Alexandre Oliva  <aoliva@redhat.com>

	* c-common.c (status_warning) [! ANSI_PROTOTYPES]: Load status
	from va_list before using it.

2000-11-30  Michael Matz  <matzmich@cs.tu-berlin.de>

	* flow.c (make_edge): Early out, if no flags to set.
	(calculate_global_regs_live): Clear out garbage only when necessary.

	* simplify-rtx.c (varray_type used_regs): New.
	(clear_table): Use it to only clear necessary items.
	(cselib_lookup, cselib_record_set): Remember newly set items.
	(cselib_update_varray_sizes, cselib_init): Initialize and grow
	used_regs.

	* local-alloc.c (update_equiv_regs): New local `cleared_regs'.
	Move clearing of dead regs out of insn-loop.

2000-11-30  Richard Henderson  <rth@redhat.com>

	* calls.c (expand_call): Emit queued insns before creating
	the tail recursion sequence.

2000-11-30  J. David Anglin  <dave.anglin@nrc.ca>
	    Bruce Korb  <bkorb@gnu.org>

	* fixinc/inclhack.def(): prevent dual double definition protection
	* fixinc/fixincl.x: regenerate

2000-11-29  Loren J. Rittle  <ljrittle@acm.org>

	* fixinc/Makefile.in (fixincl.x): Explicitly state the
	location of the generated file.

2000-11-30  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.FRESCO: Remove obsolete file.

2000-11-30  Mark Kettenis  <kettenis@gnu.org>

	* config/t-gnu (LIBGCC1, CROSS_LIBGCC1, CRTSTUFF_T_CFLAGS,
	TARGET_LIBGCC2_CFLAGS): Remove.  We now use the settings from
	config/t-linux for the Hurd.

2000-11-30  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/mn10200/udivmod.c, config/mn10200/divmod.c,
	config/mn10200/udivmodsi4.c: Moved from here.
	* config/udivmod.c, config/divmod.c, config/udivmodsi4.c: To here.
	* config/mn10200/t-mn10200 (LIB2FUNCS_EXTRA): Use the generic
	C division functions.
	* config/m68hc11/t-m68hc11-gas (LIB2FUNCS_EXTRA): Likewise.

Thu Nov 30 01:12:52 2000  Jeffrey A Law  (law@cygnus.com)

	* pa.md (conditional moves): Avoid holes in operand list.
	(mod, umod patterns): Similarly.
	(variable extract/shift patterns): Similarly.

2000-11-30  Neil Booth  <neilb@earthling.net>

	* objc/objc-act.c (lang_init, finish_file, maybe_objc_comptypes,
	maybe_objc_check_decl, build_objc_string_object,
	objc_declare_alias, objc_declare_class, build_message_expr,
	build_protocol_expr, build_selector_expr, build_encode_expr,
	get_class_ivars, start_class, start_protocol): Remove
	redundant code, assuming doing_objc_thang is true.

2000-11-29  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (restore_unscaled_index_insn_codes): Delete procedure.
	(record_unscaled_index_insn_codes): Likewise.
	(unscaled_index_insn_codes): Delete.
	(max_unscaled_index_insn_codes_uid): Delete.
	(output_function_prologue, output_function_epilogue, pa_reorg):
	Don't use the unscaled index insn hack.

	* pa.md: Remove hack from all index insns to reverse the operand
	order of frame and stack pointer references incorrectly created
	in the reload pass.

	* function.h (emit_status): Delete member regno_pointer_flag and
	rename regno_pointer_flag_length to regno_pointer_align_length.
	Delete define for REGNO_POINTER_FLAG.
	* integrate.h (inline_remap): Delete member regno_pointer_flag.
	Add member x_regno_reg_rtx.
	* rtl.h (rtx_def): Use frame_related bit to indicate register is
	a pointer in REG expressions.  Define REG_POINTER macro.
	* alias.c (find_base_value, find_base_term): Use REG_POINTER
	instead of REGNO_POINTER_FLAG.
	* combine.c (nonzero_bits, num_sign_bit_copies): Likewise.
	* emit-rtl.c (gen_reg_rtx): Use regno_pointer_align_length instead
	of regno_pointer_flag_length.  Remove code which refers to
	regno_pointer_flag.
	(mark_reg_pointer): Use REG_POINTER.
	(free_emit_status): Remove code which refers to regno_pointer_flag.
	(init_emit, mark_emit_status): Likewise.
	* flow.c (dump_flow_info): Likewise.
	* function.c (preserve_temp_slots): Likewise.
	* integrate.c (expand_inline_function, copy_rtx_and_substitute):
	Use x_regno_reg_rtx instead of regno_pointer_flag for function
	pointer determination in map.
	* loop.c (strength_reduce, maybe_eliminate_biv_1): Use REG_POINTER.
	* predict.c (estimate_probability): Likewise.
	* regclass.c (record_address_regs, reg_scan_mark_refs): Likewise.
	* unroll.c (unroll_loop): Use x_regno_reg_rtx instead of
	regno_pointer_flag for function pointer determination in map.
	* convex.h (RTX_COSTS): Don't test regno_pointer_flag and use
	REG_POINTER.
	* pa.c (hppa_legitimize_address, emit_move_sequence, basereg_operand):
	Use REG_POINTER.
	(restore_unscaled_index_insn_codes): Revise comment.

	* expr.c (do_compare_and_jump): Add missing TYPE_MODE in statement.

2000-11-30  Joseph S. Myers  <jsm28@cam.ac.uk>

	* extend.texi: Update documentation for attributes.

2000-11-29  David O'Brien  <obrien@FreeBSD.org>

	* config/alpha/elf.h (IDENT_ASM_OP): Protect the #define.
	(ASM_DECLARE_OBJECT_NAME): Same.
	(ASM_FILE_END): Same.
	(ASM_FINISH_DECLARE_OBJECT): Same.
	(ASM_IDENTIFY_GCC): Same.
	(ASM_IDENTIFY_LANGUAGE): Same.
	(ASM_OUTPUT_CONSTRUCTOR): Same.
	(ASM_OUTPUT_DEF): Same.
	(ASM_OUTPUT_DESTRUCTOR): Same.
	(ASM_OUTPUT_EXTERNAL_LIBCALL): Same.
	(ASM_OUTPUT_SECTION_NAME): Same.
	(ASM_WEAKEN_LABEL): Same.
	(BSS_SECTION_ASM_OP): Same.
	(COMMON_ASM_OP): Same.
	(CONST_SECTION_ASM_OP): Same.
	(CONST_SECTION_FUNCTION): Same.
	(CTORS_SECTION_ASM_OP): Same.
	(DTORS_SECTION_ASM_OP): Same.
	(ESCAPES): Same.
	(FINI_SECTION_ASM_OP): Same.
	(IDENT_ASM_OP): Same.
	(IDENT_ASM_OP): Same.
	(INIT_SECTION_ASM_OP): Same.
	(INT_ASM_OP): Same.
	(MAX_OFILE_ALIGNMENT): Same.
	(SBSS_SECTION_ASM_OP): Same.
	(SDATA_SECTION_ASM_OP): Same.
	(SECTION_FUNCTION_TEMPLATE): Same.
	(SELECT_SECTION): Same.
	(SE_CONST_SECTION): Same.
	(SIZE_ASM_OP): Same.
	(SKIP_ASM_OP): Same.
	(STRING_ASM_OP): Same.
	(STRING_LIMIT): Same.
	(TYPE_ASM_OP): Same.
	(TYPE_OPERAND_FMT): Same.

2000-11-29  Neil Booth  <neilb@earthling.net>

	* c-decl.c (c_decode_option): Don't handle -lang-objc.
	* objc/lang-options.h: Remove -lang-objc.
	* objc/lang-specs.h: Don't pass -lang-objc to cc1obj.
	* objc/objc-act.c (lang_init_options): Set c_language.

2000-11-29  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (can_store_by_pieces): Reinitialize max_size for reverse
	tests.

2000-11-29  Neil Booth  <neilb@earthling.net>

	* c-pragma.c (init_pragma): Update for parse_in type change.

2000-11-29  Laurynas Biveinis  <lauras@softhome.net>

	* configure.in: recognize DOS-style absolute paths.

2000-11-29  Jakub Jelinek  <jakub@redhat.com>

	* expr.h (store_by_pieces): Add prototype.
	(can_store_by_pieces): Likewise.
	* expr.c (struct store_by_pieces): Renamed from clear_by_pieces.
	(can_store_by_pieces): New.
	(store_by_pieces): New.
	(clear_by_pieces): New.
	(clear_by_pieces_1): New.
	(store_by_pieces_1): Renamed from clear_by_pieces, handle storing
	arbitrary compiler generated constants into memory block.
	(store_by_pieces_2): Renamed from clear_by_pieces_1, likewise.
	* builtins.c (c_readstr): New.
	(builtin_memcpy_read_str): New.
	(expand_builtin_memcpy): If src is string constant and
	emit_block_move would move it by pieces, compute integer constants
	from the string and store it into memory block instead.
	(builtin_strncpy_read_str): New.
	(expand_builtin_strncpy): If N is not constant zero and c_strlen does
	not return INTEGER_CST, don't optimize.
	If N is larger than strlen(src) + 1, try to copy the string
	including padding with store_by_pieces.
	(expand_builtin_strcmp): If both arguments have side effects, don't
	optimize.
	(expand_builtin_fputs): If STR has side effects, don't optimize.

2000-11-29  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (sibcall, sibcall_value, sibcall_insn, sibcall_value_insn):
	Add use of link register.

2000-11-29  Joseph S. Myers  <jsm28@cam.ac.uk>

	* extend.texi: Update documentation for default format attributes.

Tue Nov 28 21:56:45 2000  Jeffrey A Law  (law@cygnus.com)

	* pa/pa-64.h (ASM_OUTPUT_SECTION_NAME): Use a hash table, not
	a list, to keep track of the sections.

2000-11-28  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (pic_load_addr): Split into
	pic_load_addr_arm and pic_load_addr_thumb.

	* config/arm/arm.c (legitimize_pic_address): Generate either
	ARM or Thumb versions of pic_load_addr.
	(arm_finalize_pic): Generate either ARM or Thumb versions of
	pic_load_addr.

2000-11-28  Richard Henderson  <rth@redhat.com>

	* calls.c (expand_call): Defer const/pure NO_DEFER_POP until
	after sibcall do_pending_stack_adjust.

Wed Nov 29 00:08:23 2000  J"orn Rennecke <amylaar@redhat.com>

	* jump.c (delete_insn): Check that REG_LABEL note actually contains
	a CODE_LABEL.

2000-11-28  Neil Booth  <neilb@earthling.net>

	* c-common.h: Remove flag_digraphs.
	* c-decl.c: Remove flag_digraphs.
	(c_decode_option): Don't set it.
	* c-lex.c (init_c_lex): Don't do anything for digraphs.

2000-11-28  Richard Henderson  <rth@redhat.com>

	* c-parse.in (finish_parse): Update for parse_in type change.
	(_yylex): Likewise.

2000-11-28  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (cpp_scan_buffer_nooutput): Take a boolean
	indicating whether to scan all buffers on the stack or
	just one.
	* cppinit.c (do_includes): Update.
	* cppmain.c (main): Update.
	* cpplib.h: Update prototype.

2000-11-28  Richard Henderson  <rth@redhat.com>

	* genoutput.c (validate_insn_operands): New.
	(gen_insn): Call it.

	* config/alpha/alpha.md (divmodsi_internal): Renumber operands.
	(divmoddi_internal): Likewise.
	* config/arm/arm.md (andsi3_compare0_scratch): Likewise.
	* config/i960/i960.md (branch patterns): Likewise.
	* config/ia64/ia64.md (tbit_and_0): Likewise.
	(tbit_and_1, tbit_or_0, tbit_or_1): Likewise.
	* config/m68k/m68k.md (zero_extract memory patterns): Likewise.
	* config/mips/mips.md (divmodsi4_internal): Likewise.
	(divmoddi4_internal): Likewise.
	* config/rs6000/rs6000.md (call patterns): Likewise.
	* config/sh/sh.md (movsi_y): Likewise.
	* config/sparc/sparc.md: Comment out if 0 v8p shift pattern.

2000-11-28  Richard Henderson  <rth@redhat.com>

	* config.gcc: Kill residual pyramid support.

2000-11-28  Neil Booth  <neilb@earthling.net>

	* c-lex.h (parse_in): Change parse_in to a cpp_reader *.
	* c-decl.c (c_decode_option): Update to match.
	* c-lex.c (init_c_lex, yyparse): Update to match.
	* c-lang.c (lang_init_options): Use cpp_create_reader.
	* cppinit.c (cpp_init): Rename initialize.
	(cpp_reader_init): Rename cpp_create_reader.  Create the
	reader.  Initialize cpplib if appropriate.
	* cpplib.h (cpp_create_reader) New prototype.
	(cpp_init, cpp_reader_init): Delete prototypes.
	* cppmain.c (general_init, setup_callbacks): New functions.
	(main): Use them.
	* fix-header.c (scan_in): Change type to cpp_reader *.
	(read_scan_file): Update for new cpplib interface and scan_in type.

	* cp/decl.c (parse_in): Change to cpp_reader *.
	(lang_decode_option): Update.
	* cp/lex.c (lang_init_options): Use new cpplib interface.
	(init_cp_pragma, finish_parse, handle_pragma_implementation): Update.
	* cp/spew.c (read_token): Update.
	* objc/objc-act.c (lang_init_options): Update new cpplib interface.

2000-11-28  Jakub Jelinek  <jakub@redhat.com>

	* loop.c (load_mems): Avoid using next_label to find end_label. If
	jumping outside of the loop (other than loop end), don't hoist MEMs
	out of loop.

2000-11-28  Jan Hubicka  <jh@suse.cz>

	* calls.c (expand_call): Don't disable tail recursion based
	on the loop nest.

2000-11-28  Neil Booth  <neilb@earthling.net>

	* tradcpp.c (enum node_type): New hash types T_ASSERT, T_UNASSERT.
	(struct directive): Drop 4th argument from handlers.
	(do_define, do_line, do_include, do_undef, do_else, do_elif,
	do_endif): Similarly.
	(do_assert, do_unassert, do_ifdef, do_ifndef): New handlers.
	(do_ifxdef): Update as common handler of do_ifdef and do_ifndef.
	(make_definition, make_undef): Take a const char*.
	(make_assertion): New function.
	(struct directive_table): Update.
	(main): Handle -A command line argument.
	(handle_directive): Drop fourth handler argument.

2000-11-28  Bernd Schmidt  <bernds@redhat.co.uk>

	* simplify-rtx.c (cselib_record_sets): Ignore sets whose destination
	is anything but REG or MEM, but look inside STRICT_LOW_PART.

Tue Nov 28 09:53:50 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* system.h (IS_DIR_SEPARATOR): Use uppercase macro name.
	(IS_ABSOLUTE_PATHNAME): New macro.
	* gcc.c (find_a_file, process_command, do_spec_1, main): Use it.

2000-11-28  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.md (truncxfsf2_2): Fix predicate.

2000-11-27  Jim Wilson  <wilson@redhat.com>

	* reload1.c (reload): Use HOST_WIDE_INT for old_frame_size.

2000-11-27  Matthias Klose  <doko@cs.tu-berlin.de>

	* extend.texi (Nested Functions): Update URL of Usenix paper.

2000-11-27  Mark Mitchell  <mark@codesourcery.com>

	* function.c (free_after_compilation): Clear x_clobber_return_insn.

2000-11-27  Neil Booth  <neilb@earthling.net>

	* cppinit.c (cpp_reader_init): Remove handling of warn_paste
	command line options.
	(cpp_handle_option): Similarly.
	* cpplib.h (struct cpp_options): Remove warn_paste.
	* cppmacro.c (paste_tokens): Apart from assembler, make
	unpasteable token warning mandatory.

2000-11-27  Neil Booth  <neilb@earthling.net>

	* tradcpp.c (enum pending_dir_t, struct pending_dir): New.
	(main): Allocate a pending directive set of these.  Use it.
	Merge handling of -D and -U.  Update handling of pending
	directives.  Free the memory after use.

2000-11-27  Bernd Schmidt  <bernds@redhat.co.uk>

	* flow.c (entry_exit_blocks): Add entry for cond_local_set.
	(struct propagate_block_info): Add new member cond_local_set.
	(propagate_block): Accept new arg cond_local_set.  All callers
	changed.
	(init_propagate_block_info): Likewise.
	(calculate_global_regs_live): Allocate & free cond_local_set.  Always
	rescan if there's overlap between cond_local_set and new_live_at_end.
	(mark_set_1): Set bits either in cond_local_set or local_set, as
	appropriate.
	* basic-block.h (struct basic_block_def): New field cond_local_set.
	(propagate_block, init_propagate_block_info): Update prototypes.

Mon Nov 27 17:29:44 2000  kaz Kojima <kkojima@rr.iij4u.or.jp>

	* gcc/config/sh/sh.md (udivsi3_i4, udivsi3_i4_single): Clobber
	T register.

2000-11-27  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (select_dominance_cc_mode): Handle new way that combine
	canonicalizes conditional compares.
	(arm_select_cc_mode): Likewise.
	* arm.md: Garbage collect some dead code.
	(cmp_and, cmp_ior): New patterns.
	(splitter for conditional move with inverted false): Use cond_exec
	and handle unordered comparisons.

Mon Nov 27 17:22:56 MET 2000  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_force_to_memory, ix86_free_from_memory): New.
	* i386-protos.h (ix86_force_to_memory, ix86_free_from_memory): Declare
	* i386.md (float?i?f, int/fp operations): Rewrite spliters to use
	ix86_force_to_memory and ix86_free_from_memory.

2000-11-27  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (arm_adddi3, adddi_sesidi_di, adddi_zesidi_di, arm_addsi3,
	arm_subsi3_insn, anddi_zesidi_di, arm_andsi3_insn, anddi_notdi_di,
	anddi_notzesidi_di, anddi_notsesidi_di, arm_iorsi3,
	one_cmpldi2): Merge with splitters to create define_insn_and_split
	patterns.  Remove redundant splits.
	(peephole2 for add:SI of invalid immediate): New.
	(peephole2 for minus:SI of invalid immediate): New.
	(peephole2 for ior:SI of invalid immediate): New.
	(peephole for merge of move and compare): Convert ot peephole2.
	(addsf3, adddf3): Mark as commutative.

	* arm.md (thumb peephole for merging stack adjustments): Convert to
	peephole2.

2000-11-27  Bernd Schmidt  <bernds@redhat.co.uk>

	* haifa-sched.c (print_pattern): Prettier output for COND_EXEC.

	* reload1.c (reload_cse_simplify_set): Pass down mode to cselib_lookup.
	(reload_cse_simplify_operands): Do nothing about operands where both
	the operand and the match_operand fail to give us a mode.
	* simplify-rtx.c (wrap_constant): New function.
	(entry_and_rtx_equal_p): Except integer constants to come wrapped in a
	CONST describing the proper mode.
	(rtx_equal_for_cselib_p): Pass down modes to recursive calls of
	cselib_lookup.
	(cselib_lookup_mem): Call wrap_constant on the rtx that is passed to
	htab_find_slot_with_hash.
	(cselib_lookup): Likewise.

	Based on a patch from Geoff Keating <geoffk@redhat.com>:
	* loop.c (basic_induction_var): If a REG is set from something
	that is not a biv, then the REG is not a biv.  Even if it is
	earlier set from something that is a biv.

2000-11-27  Alexandre Oliva  <aoliva@redhat.com>

	* configure.in (extra_objs): Enclose extra_headers in quotes.
	* configure: Rebuilt.

2000-11-27  Neil Booth  <neilb@earthling.net>

	* c-lex.c (cb_enter_file, cb_leave_file, cb_rename_file):
	Combine into the new function cb_change_file.
	(init_c_lex): Update.
	* cppfiles.c (stack_include_file): Use _cpp_do_file_change.
	(cpp_syshdr_flags): Delete.
	* cpphash.h (_cpp_do_file_change): New prototype.
	Move struct cpp_buffer here from...
	* cpplib.h (struct cpp_buffer): ... here.
	(enum cpp_fc_reason, struct cpp_file_loc,
	struct_cpp_file_change, change_file): New.
	(enter_file, leave_file, rename_file, cpp_syshdr_flags): Delete.
	* cpplib.c (do_line): Update for new cb_change_file callback.
	(_cpp_do_file_change): New function.
	(_cpp_pop_buffer): Update to use it.
	* cppmain.c (move_printer): Delete.
	(main): Set up single callback cb_change_file.
	(cb_enter_file, cb_leave_file, cb_rename_file): Delete.
	(cb_change_file): New.
	* fix-header.c (cur_file, cb_change_file): New.
	(recognized_function, read_scan_file): Update.
	* scan-decls.c (scan_decls): Update.
	* scan.h (recognized_function): Update prototype.

2000-11-26  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (mark_tree_hashtable): New function.
	* tree.c (mark_tree_hashtable_entry): New function.
	(mark_tree_hashtable): Likewise.

2000-11-27  Michael Meissner  <meissner@redhat.com>

	* d30v-protos.h (srelational_si_operator): Correctly spell
	function.
	(urelational_si_operator): Ditto.
	(relational_si_operator): Ditto.
	(d30v_expand_prologue): Add prototype.
	(d30v_expand_epilogue): Ditto.

	* d30v.h (OPTIMIZATION_OPTIONS): Undo November 22nd change.

	* d30v.md (movcccc_*): Delete now unused patterns.
	(64 bit comparison splitters): Rewrite to use COND_EXEC instead of
	IF_THEN_ELSE.
	(define_cond_exec): Use 'b' to select branch flags.

2000-11-26  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strncmp, expand_builtin_strncpy): New
	functions.
	(expand_builtin): Handle BUILT_IN_STRNCPY and BUILT_IN_STRNCMP.

	* builtins.def (BUILT_IN_STRNCPY, BUILT_IN_STRNCMP): New entries.

	* c-common.c (c_common_nodes_and_builtins): Declare builtin
	strncpy and strncmp.

	* extend.texi (strncmp, strncpy): Document new builtins.

2000-11-26  Mark Mitchell  <mark@codesourcery.com>

	* config/elfos.h (ASM_OUTPUT_SECTION_NAME): Use a hash table, not
	a list, to keep track of the sections.
	* tm.texi (ASM_OUTPUT_SECTION_NAME): Document the fact that the
	parameter provided will always be a canonical string.

2000-11-26  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (cpp_scan_buffer_nooutput): Only scan the
	current buffer.

2000-11-26  Joseph S. Myers  <jsm28@cam.ac.uk>

	* makefile.vms: Remove EGCS references.

2000-11-26  Ulrich Drepper  <drepper@redhat.com>

	* dwarf2out.c (output_file_names): New function.  Compute minimal
	combination of directory and file name table and emit them.
	(output_line_info): Remove code to emit directory and file name
	table and call output_file_names instead.
	(file_info_cmp): Helper function to sort directory names.

2000-11-26  Neil Booth	<neilb@earthling.net>

	* cpplib.h (struct cpp_reader): Remove lang_asm.
	(struct cpp_options): Remove c89. New members lang,
	extended_numbers.
	* cppexp.c (parse_number): Use them.
	* cpphash.h (VALID_SIGN): Use them.
	* cppinit.c (set_lang, cpp_start_read): Update.
	* cpplex.c (parse_string, _cpp_lex_token): Update.
	* cpplib.c (_cpp_handle_directive): Update.
	* cppmacro.c (parse_args): Update.
	* cppmain.c (scan_buffer): Update.

Sun Nov 26 10:02:37 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* fold-const.c (fold, case CONVERT_EXPR): Always return tree of
	proper type.

2000-11-26  Neil Booth	<neilb@earthling.net>

	* Makefile.in: Remove MAYBE_CPPLIB and maybe_cpplib.
	* c-decl.c: Remove parse_in declaration.
	* c-lang.c: Similarly.
	* c-lex.c: Similarly.
	* c-parse.in: Similarly.
	* c-pragma.c: Similarly.
	* configure.in: Similarly.
	* cp/Make-lang.in: Similarly.
	* cp/spew.c: Similarly.
	* cp/decl2.c: Remove check for lang-c++ option.
	* cp/lang-specs.h: Remove -lang-c++ from cc1plus command line.
	* cp/lex.c (lang_init_options): With cpp_reader_init, default to C++.
	* c-lex.h: Add declaration of parse_in.
	* cppinit.c: Call set_lang after allocating pfile->pending.
	* configure: Regenerate.

2000-11-25  Zack Weinberg  <zack@wolery.stanford.edu>

	* combine.c (try_combine): Remove redundant test.

2000-11-25  Richard Henderson  <rth@redhat.com>

	* c-common.h (DECL_C_HARD_REGISTER): New.
	* c-decl.c (finish_decl): Set it for asm register variables.
	* c-semantics.c (emit_local_var): Test it when instantiating one.

2000-11-25  Richard Henderson  <rth@redhat.com>

	* c-decl.c (c_expand_body): Use DECL_SOURCE_LINE rather than
	lineno for the start of the function.

2000-11-25  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (file_table, file_table_allocated): Remove.
	(file_table_allocated): Remove.
	(struct file_table): New.
	(decl_file_table, line_file_table): New.
	(print_dwarf_line_table): Use them.
	(size_of_line_prolog): Likewise.
	(output_line_info): Likewise.
	(add_src_coords_attributes): Likewise.
	(gen_subprogram_die): Likewise.
	(gen_variable_die): Likewise.
	(dwarf2out_add_library_unit_info): Likewise.
	(dwarf2out_line): Likewise.
	(lookup_filename): Take a struct file_table argument.
	(init_file_table): New.
	(dwarf2out_init): Use it.

2000-11-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Update sequence points references.

2000-11-25  Neil Booth  <neilb@earthling.net>

	* c-common.c: Remove USE_CPPLIB conditional inclusions.
	* c-common.h: Similarly.
	* c-decl.c: Similarly.
	* c-lang.c: Similarly.
	* c-lex.c: Similarly.
	* c-parse.in: Similarly.
	* c-pragma.c: Similarly.
	* c-pragma.h: Similarly.
	* gcc.c: Similarly.
	* toplev.c: Similarly.
	* cp/cp-tree.h: Similarly.
	* cp/decl2.c: Similarly.
	* cp/lang-specs.h: Similarly.
	* cp/lex.c: Similarly.
	* cp/lex.h: Similarly.
	* cp/spew.c: Similarly.
	* java/lang-options.h: Similarly.
	* objc/lang-specs.h: Similarly.
	* objc/objc-act.c: Similarly.

	* configure.in: Remove configure option.
	* config.in: Regenerate.
	* configure: Regenerate.

2000-11-25  Richard Henderson  <rth@redhat.com>

	* haifa-sched.c (sched_analyze_1, sched_analyze_2, sched_analyze):
	Revert 2000-11-22 change.

2000-11-25  Bernd Schmidt  <bernds@redhat.co.uk>

	* config/i386/i386.h (FIXED_REGS): Make the three flags registers
	fixed.

2000-11-25  Philipp Thomas  <pthomas@suse.de>
	* configure.in (ALL_LINGUAS): Remove en_GB and add sv.
	* configure: Rebuilt.

2000-11-25  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (muldi3_v8plus): Remove H constraint.
	Handle CONST_INT as second argument.
	* config/sparc/sparc.c (set_extends): Remove first argument.
	Properly handle AND, CONST_INT and CONST_DOUBLE, handle IOR, XOR and
	MOV.
	(sparc_check_64): Abort if first argument is not REG.
	If it is DImode REG, look at the lower register of the register
	pair.

	* config/sparc/sparc.c (load_pic_register, restore_regs,
	output_return, sparc_v8plus_shift, sparc_function_profiler,
	sparc_function_block_profiler, sparc_block_profiler): Fix output
	formatting.

2000-11-25  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (TARGET_NONE): New.
	(TARGET_SWITCHES): For all variant-selecting switch, use
	TARGET_NONE to reset all other variant-selecting switch.  Added
	empty strings to avoid warnings.
	(TARGET_DEFAULT): Set to SH1_BIT.

	* Makefile.in ($(INTL_TARGETS)): Added $(CONFIG_H) for
	insn-codes.h.

	* gcc/config/sh/sh.md (sibcalli, sibcalli_pcrel): New insns.
	(sibcall_pcrel): New insn_and_split.
	(sibcall, sibcall_value, sibcall_epilogue): New expands.

	* config/sh/sh.md (GOTaddr2picreg, symGOT2reg, symGOTOFF2reg,
	symPLT_label2reg, call, call_value): Don't set
	current_function_uses_pic_offset_table.
	* config/sh/sh.h (CONDITIONAL_REGISTER_USAGE): Don't mark
	PIC_OFFSET_TABLE_REGNUM as call_used, so that calc_live_regs
	takes it into account.
	(FINALIZE_PIC): Delete, useless.
	(LEGITIMATE_CONSTANT_P): Delete, unused.
	* config/sh/sh.c (sh_expand_prologue): Don't use
	current_function_uses_pic_offset_table.  Don't special-case
	PIC_OFFSET_TABLE_REGNUM.  Initialize it if it's ever live and
	PIC is enabled.
	(sh_expand_epilogue, initial_elimination_offset): Don't
	special case PIC_OFFSET_TABLE_REGNUM.

2000-11-25  Alexandre Oliva  <aoliva@redhat.com>, NIIBE Yutaka  <gniibe@m17n.org>

	* config/sh/sh-protos.h (symbol_ref_operand): Declare.
	* config/sh/sh.md (UNSPEC_CALLER): New constant.
	(calli_pcrel, call_valuei_pcrel): Use PIC_REG.
	(call_pcrel, call_value_pcrel): New insn_and_splits.
	(call, call_value): Use them.
	(call_site): New expand.
	(sym_label2reg, symPLT_label2reg): Adjust to hold call_sites.
	* config/sh/sh.h (OUTPUT_ADDR_CONST_EXTRA) [UNSPEC_CALLER]:
	Output call_site label.
	(PREDICATE_CODES): Added symbol_ref_operand.
	* config/sh/sh.c (symbol_ref_operand): Define.
	* emit-rtl.c (try_split): Propagate CALL_INSN_FUNCTION_USAGE
	to CALL_INSNs in the split sequence.

2000-11-24  Nick Clifton  <nickc@redhat.com>

	* config.gcc (v850-*-*): Define c_target_objs and
	cxx_target_objs.

	* config/v850/t-v850: Define how to build v850-c.o

	* config/v850/v850.h (struct data_area_stack_element): Move
	definition here from v850.c.

	* config/v850v850.c: Include gcc.h to avoid compile time
	warning.
	(push_data_area): Move to v850-c.c.
	(pop_data_area): Move to v850-c.c.
	(mark_current_function_as_interrupt): Move to v850-c.c.
	(GHS_default_section_names): Allow to be exported.
	(GHS_current_section_names): Allow to be exported.
	(data_area_stack_elements): Allow to be exported.
	(ghs_pragma_section): Move to v850-c.c.
	(ghs_pragma_interrupt): Move to v850-c.c.
	(ghs_pragma_starttda): Move to v850-c.c.
	(ghs_pragma_startsda): Move to v850-c.c.
	(ghs_pragma_startzda): Move to v850-c.c.
	(ghs_pragma_endtda): Move to v850-c.c.
	(ghs_pragma_endsda): Move to v850-c.c.
	(ghs_pragma_endzda): Move to v850-c.c.

	* config/v850/v850-c.c: New file: Contains v850 specific
	pragma parsing functions.

2000-11-24  Nick Clifton  <nickc@redhat.com>

	* config.gcc (extra_objs): Remove duplicate description.
	(c_target_objs): New variable.  Contains target specific
	object files for the gcc C compiler only.
	(cxx_target_objs): New variable.  Contains target specific
	object files for the gxx C++ compiler only.

	* configure.in (c_target_objs): Substitute in the makefile.
	(cxx_target_objs): Substitute in the makefile.
	* configure: Regenerate.

	* Makefile.in (C_TARGET_OBJS): Define and initialize from
	c_target_objs.
	(CXX_TARGET_OBJS): Define and initialize from
	cxx_target_objs.
	(C_AND_OBJC_OBJS): Include C_TARGET_OBJS.

	* cp/Make-lang.in (CXX_C_OBJS): Include CXX_TARGET_OBJS).

	* tm.texi (REGISTER_TARGET_PRAGMAS): Add paragraph explaining
	about how the use of the 'c_lex' function requires the use of
	the target specific, language specific object files feature of
	the configuration mechanism.

Fri Nov 24 18:50:58 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* gcc.c (process_command): Use F_OK, not R_OK.

2000-11-24  Arno J. Klaassen  <arno@heho.snv.jussieu.fr>

	* flow.c (print_rtl_and_abort): Remove ANSIism.

Fri Nov 24 19:54:36 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (GENERAL_REGISTER_P,
	GENERAL_OR_AP_REGISTER_P, FP_REGISTER_P, XD_REGISTER_P,
	FP_OR_XD_REGISTER_P, FP_ANY_REGISTER_P): New macros.  Use them
	all over.
	(SPECIAL_REG): Renamed to SPECIAL_REGISTER_P.
	* config/sh/sh.c: Use new macros.
	* config/sh/sh.md: Likewise.

Fri Nov 24 19:46:16 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md: Clobber MACH_REG and MACL_REG in SImode,
	instead of just MACH_REG in DImode.  Always refer to FPSCR_REG
	in PSImode.

Fri Nov 24 22:37:41 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (out_tsthi,out_tstsi): Test simplification bug
	fixed.
	(machine_dependent_reorg): Wrong optimization based on
	NOTICE_UPDATE_CC removed.

Fri Nov 24 19:48:09 2000  J"orn Rennecke <amylaar@redhat.com>

	* jump.c (delete_computation): Re-instate deletion of feeding insn.
	(delete_insn): Look for REG_LABEL notes.
	(redirect_tablejump): Delete feeding insns.

2000-11-24  Bernd Schmidt  <bernds@redhat.co.uk>

	* config/i386/i386.md (call_pop_0, call_pop_1, call_value_pop_0,
	call_value_pop_1): Make sure operand numbers are contiguous.

	* fold-const.c (fold_range_test): Avoid crash if LHS or RHS is null.

	* reload1.c (conflicts_with_override): New function.
	(emit_input_reload_insns): Use it to tighten test for validity
	of substituting into output of previous insn.

	* haifa-sched.c (struct ready_list): New.
	(ready_lastpos, ready_add, ready_remove_first, ready_sort): New static
	functions.
	(schedule_insn): Replace args READY and N_READY with a pointer to a
	ready_list; return void.  Use the new functions to access the ready
	list.  All callers changed.
	(queue_to_ready, debug_ready_list): Likewise.
	(schedule_block): Initialize a ready_list structure.  Use new
	functions to access it.
	(max_priority): Remove unused variable.
	(schedule_insn): Don't set it.

	* c-common.c (verify_tree): Don't recurse into CONSTRUCTORs.

	* combine.c (cant_combine_insn_p): New function.
	(try_combine): Use it.

	* Makefile.in (c-common.o): Depend on $(OBSTACK_H).
	* c-common.c (c-obstack.c): Include "obstack.h".
	(struct reverse_tree): Delete.
	(reverse_list, reverse_max_depth): Delete.
	(build_reverse_tree, common_ancestor, modify_ok): Delete functions.
	(struct tlist, struct tlist_cache): New.
	(tlist_obstack, tlist_firstobj, warned_ids, save_expr_cache): New.
	(add_tlist, merge_tlist, verify_tree, warning_candidate_p,
	warn_for_collisions, warn_for_collisions_1, new_tlist): New
	static functions.
	(verify_sequence_points): Rewritten.
	* fold-const.c (fold): Don't lose possibly important sequence
	points when removing one arm of TRUTH_ORIF_EXPRs or TRUTH_ANDIF_EXPRs.

2000-11-24  Richard Sandiford  <rsandifo@redhat.com>

	* gcc/cse.c (cse_insn): Removed conversion of REG_EQUIV to REG_EQUAL
	when reversing a register-to-register copy.  Reversal now disabled
	when the previous instruction has a REG_EQUIV.

2000-11-24  Nathan Sidwell  <nathan@codesourcery.com>

	* c-parse.in (unary_expr): Move VA_ARG from here ...
	(primary): ... to here.

2000-11-23  Graham Stott  <grahams@redhat.com>

	* expr.c (store_constructor): If a field is non addressable and
	the target is a MEM use MEM_ALIAS_SET otherwise use get_alias_set.

2000-11-23  Bernd Schmidt  <bernds@redhat.co.uk>

	* flow.c (print_rtl_and_abort): New function.
	(verify_wide_reg, verify_local_live_at_start): Try to dump more
	information before aborting.

2000-11-23  Alexandre Oliva  <aoliva@redhat.com>

	* emit-rtl.c (gen_lowpart_common): Use word 0 if register mode
	is narrower than requested mode.
	(gen_highpart): Abort if register mode is narrower than
	requested mode.

2000-11-23  Graham Stott  <grahams@redhat.com>

	* cse.c (cse_insn): Initialize all regcost variables.
	Fix a typo add missing '='.
	Only compare costs if there is a replacement insn.

Thu Nov 23 04:33:33 2000  Alexandre Oliva  <aoliva@redhat.com>

	* final.c (output_addr_const) [LABEL_REF]: Simplify.
	[MINUS]: Enclose non-CONST_INTs in parentheses.
	[default]: Try OUTPUT_ADDR_CONST_EXTRA.
	* tm.texi (OUTPUT_ADDR_CONST_EXTRA): Document it.
	* varasm.c (decode_rtx_const) [CONST]: If it's not something
	PLUS or MINUS a CONST_INT, use the whole CONST with offset 0
	instead of abort()ing.
	* sh.c (output_pic_addr_const): Removed.  Fixed all callers.
	* sh.h (OUTPUT_ADDR_CONST_EXTRA): New.  Handle the UNSPECs
	formerly handled in output_pic_addr_const.
	* sh.md (sym_label2reg, symPLT_label2reg): Enclose UNSPEC
	operands of MINUS in CONSTs so that decode_rtx_const() will
	accept them.

Thu Nov 23 04:10:30 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (mova_const): New pattern.
	(GOTaddr2picreg): Use it.
	* config/sh/sh.c (broken_move): Match it.
	(mova_p): Don't match it.
	(machine_dependent_reorg): Adjust it.

Thu Nov 23 02:09:09 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (FIRST_GENERAL_REG, LAST_GENERAL_REG): New.
	Moved most register-number #defines...
	* config/sh/sh.md (define_constants): ... here.  Use macros to
	refer to registers and unspecs.
	* config/sh/sh.c: Likewise.

Thu Nov 23 01:01:32 2000  J"orn Rennecke <amylaar@redhat.com>

	* Makefile.in (HOST_CFLAGS): Add -DGENERATOR_FILE.
	(rtl.o, print-rtl.o, bitmap.o, obstack.o): Build with -DGENERATOR_FILE.
	(alloca.o, vfprintf.o, ggc-none.o, errors.o): Likewise.
	(splay-tree.o, hash.o): Likewise.
	GCONFIG_H: New.
	(rtl.o, print-rtl.o): Depend on $(GCONFIG_H) instead of $(CONFIG_H).
	(bitmap.o, obstack.o, vfprintf.o, ggc-none.o, errors.o): Likewise.
	(hashtab.o): Likewise.
	(gcov.o): Depend on $(CONFIG_H).
	* configure.in: #include insn-codes.h in tm.h.

2000-11-22  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (arm_encode_call_attribute): Make 'newstr' a
	const char * to avoid a compile time warning.

	* config/arm/arm.md (define_constants): Define symbolic names for
	the link register, last integer register and the fake CC register.
	Update patterns to use these symbolic names.

2000-11-22  Neil Booth  <neilb@earthling.net>

	* cpplex.c (trigraph_ok): Ensure we don't warn twice.
	* cpplib.h (struct cpp_buffer): New member last_Wtrigraphs.

2000-11-22  Richard Henderson  <rth@redhat.com>

	* haifa-sched.c (sched_analyze_1): Don't special-case calls
	for clobbering registers.
	(sched_analyze_2): Likewise.
	(sched_analyze): Zap reg_last_uses and reg_last_sets after calls.

2000-11-22  Chris Demetriou  <cgd@sibyte.com>
	    Neil Booth  <neilb@earthling.net>

	* gcc.c (validate_switches): Validate multiple switches named
	in '|' (or) expressions in specs.
	(handle_braces): If more than 1 alternative in a '|' spec
	matches, call do_spec1 just once.

2000-11-22  Michael Meissner  <meissner@redhat.com>

	* d30v.h (TARGET_SWITCHES): Add documentation strings.
	(TARGET_OPTIONS): Ditto.
	(OPTIMIZATION_OPTIONS): Temporarily turn off -frename-registers if
	-O3.

Wed Nov 22 06:40:56 2000  Jeffrey A Law  (law@cygnus.com)

	* pa.c (hppa_encode_label): Account for addition of encoding
	character when allocating persistent space for the new label
	name.

2000-11-22  Zack Weinberg  <zack@wolery.stanford.edu>

	* Makefile.in, config.gcc, configure.in: Expunge remaining
	traces of facility for running MD files through C preprocessor.

2000-11-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcov.texi: Add magic comments for texi2pod.pl.
	* Makefile.in: Add rules to generate and install gcov.1.
	* gcov.1: New (generated) file.

2000-11-21  Richard Henderson  <rth@redhat.com>

	* regrename.c (scan_rtx_reg): Terminate the chain rather than
	abort on mark_read with NO_REGS.

2000-11-21  Mike Stump  <mrs@wrs.com>

	* fixinc/fixtests.c (TEST_FOR_FIX_PROC_HEAD): Fix to allow
	compilation with older compilers, such as /bin/cc on SunOS.
	* fixinc/fixfixes.c (FIX_PROC_HEAD): Ditto.

2000-11-21  Richard Henderson  <rth@redhat.com>

	* varasm.c (record_constant): Pad the constructed
	constant_descriptor appropriately.

Wed Nov 22 00:52:55 2000  J"orn Rennecke <amylaar@redhat.com>

	* rtl.h (traverse_md_constants): Declare.
	(struct md_constant): Define.
	* Makefile.in (HOST_RTL): Add hashtab.o .
	(OBJS): Add hashtab.o .
	(hashtab.o): New rule.
	(rtl.o): Depends on HASHTAB_H.
	* rtl.c (hashtab.h): #include.
	(md_constants): New static variable.
	(def_hash, def_name_eq_p, read_constants): New static functions.
	(traverse_md_constants): New function.
	(read_name): Do constant expansion.
	(read_rtx): Recognize define_constants.
	* gencodes.c (print_md_constant): New function.
	(main): Emit #defines for all constant definitions encountered.
	* md.texi (Constant Definitions): New node.
	* gensupport.c (xcalloc): New function.

2000-11-21  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_split_tfmode_frobsign): New.
	* config/alpha/alpha-protos.h: Declare it.
	* config/alpha/alpha.md (abstf_internal): Use it.
	(negtf_internal): Likewise.
	(andnotdi3): Unstar the name.
	(movtf_internal): Add o/G alternative.

2000-11-21  Zack Weinberg  <zack@wolery.stanford.edu>

	* stringpool.c (stringpool_statistics): Also report number and
	percentage of entries which are identifiers.

2000-11-21  Diego Novillo  <dnovillo@redhat.com>

	* gcse.c (hoist_expr_reaches_here_p): Do not mark expr_bb as
	visited before visiting it.

2000-11-21  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h: Accept TARGET_CPU_arm9tdmi,
	TARGET_CPU_strongarm110 and TARGET_SPU_strongarm1100.

	* config.gcc: Accept --with-cpu=arm9 and --with-cpu=arm9tdmi.

2000-11-21  Richard Henderson  <rth@redhat.com>

	* c-common.c (c_unsafe_for_reeval): New function.
	(add_c_tree_codes): Register it.
	* c-common.h: Declare it.
	* tree.c (lang_unsafe_for_reeval): New hook.
	(unsafe_for_reeval): Call it.
	* tree.h: Declare it.

2000-11-21  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (i386_simplify_dwarf_addr): Simplify @GOT
	references as well.

2000-11-21  Neil Booth  <neilb@earthling.net>

	* do_includes: Revert to using cpp_read_file.

2000-11-21  Bernd Schmidt  <bernds@redhat.co.uk>

	* loop.c (consec_sets_giv): If the reg we're examining is anything
	but UNKNOWN_INDUCT, do nothing.
	Reset the reg's type to UNKNOWN_INDUCT before returning.

	Mostly from Vladimir Makarov (vmakarov@redhat.com)
	* ia64.md (attr itanium_class): Define insn types as described in
	Itanium docs.
	(all insn patterns): Use itanium_class, not type attributes.
	Occasionally split alternatives as necessary.
	(attr type): Compute from new attr itanium_class.

2000-11-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* tradcpp.c (output_line_command): Mark system headers as such in
	`line' commands.

2000-11-21  Jakub Jelinek  <jakub@redhat.com>

	* configure.in (HAVE_AS_DWARF2_DEBUG_LINE): SPARC has .file/.loc
	support in as as well.
	* configure: Regenerate.

2000-11-20  Richard Henderson  <rth@redhat.com>

	* c-lex.c (orig_filename): New variable.
	(init_c_lex): Set it.  Move call to cpp_start_read ...
	(yyparse): ... here.  New function.
	* c-parse.in (yyparse_1): Rename the parser entry point.
	* c-tree.h: Declare it.

2000-11-21  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (do_compare_and_jump): If op0 was replaced by promoted
	integer constant, use type of op1 for comparison.

2000-11-20  Stan Shebs  <shebs@apple.com>

	* config/rs6000/xm-darwin.h: New file, Darwin host definitions.
	* config/rs6000/x-darwin: New file, Darwin host fragment.
	* config.gcc (powerpc-*-darwin*): New host.
	* system.h (HAVE_DESIGNATED_INITIALIZERS):  Allow this to be
	overridden by a config file.

2000-11-20  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (paste_tokens): Rename from paste_payloads.
	Change token type after pasting spellings.
	(paste_all_tokens): Use it.
	* gcc.dg/cpp/paste2.c: Update test.
	* objc/execute/paste.m: New test.

2000-11-20  Richard Henderson  <rth@redhat.com>

	* dwarf.h (FMT_CODE): Adjust argument order; fix mapping to
	dwarf_subscr_data_formats bits.
	* dwarfout.c (simple_type_size_in_bits): Handle a type with
	no computed size as size zero.
	(field_byte_offset): Likewise.
	(subscript_data_attribute): Handle a range with no upper bound.

2000-11-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gansidecl.h (const): Check __STDC__ before undef'ing `const'.

2000-11-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (build_conditional_expr): When merging type
	qualifiers for conditional expressions between a pointer and a
	pointer to a void type, merge the qualifiers on the target types
	rather than the pointer type.  Remove obsolete conditioned out
	code.

2000-11-20  Neil Booth  <neilb@earthling.net>

	* c-lang.c (lang_init_options): Update call to
	cpp_reader_init.
	* cppmain.c (main): Similarly.
	* fix-header.c (read_scan_file): Similarly.
	* cp/lex.c (lang_init_options): Similarly.
	* objc/objc-act.c (lang_init_options): Similarly.
	* cppexp.c (parse_number): Only warn for unextended C89.
	* cppinit.c (set_lang): New function.
	(cpp_reader_init): Take a LANG argument and pass it to set_lang.
	(COMMAND_LINE_OPTIONS): New option std=c++98.
	(cpp_handle_option): Use set_lang.
	* cpplex.c (_cpp_lex_token): Warn pedantically if not C99.
	* cppib.h (enum_c_lang): New enumeration.  Update comments.

2000-11-20  Will Cohen  <wcohen@redhat.com>

	* calls.c (expand_call): Clear target only when target is in
	hard register and current_function_check_memory_usage is set.

2000-11-20  Bernd Schmidt  <bernds@redhat.co.uk>

	* toplev.c (rest_of_compilation): Run optimize_mode_switching even
	if not optimizing.
	* sh.c (emit_sf_insn, emit_df_insn): Just call emit_insn.

2000-11-19  Richard Henderson  <rth@redhat.com>

	* crtstuff.c (force_to_data): Use array size 1 not 0.

	* dwarf2out.c (simple_type_size_in_bits): Handle a type with
	no computed size as size zero.
	(field_byte_offset): Likewise.

2000-11-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config.gcc: Fix another typo.

2000-11-19  Richard Henderson  <rth@redhat.com>

	* c-decl.c (grokdeclarator): Support flexible array members.
	Use open-ended ranges for these and zero-length arrays.
	* c-typeck.c (push_init_level): Validate the context of
	initialization of a zero-length array.
	* tree.c (int_fits_type_p): Be prepared for missing bounds.
	* varasm.c (array_size_for_constructor): New.
	(output_constructor): Use it for arrays of unspecified length.
	* extend.texi (Zero Length): Mention C99 flexible array members.
	Document initialization in a top-level struct as valid.

2000-11-19  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config.gcc, invoke.texi: Fix errors in spelling of "deprecated".

	* alias.c (mems_in_disjoint_alias_sets_p): Do use alias sets in
	stdarg and varargs functions.

2000-11-19  Zack Weinberg  <zack@wolery.stanford.edu>

	* gcc.c (process_command): Define 'j' variable when
	MODIFY_TARGET_NAME is defined.

2000-11-19  Richard Henderson  <rth@redhat.com>

	* stor-layout.c (variable_size): Only put SAVE_EXPRs on pending_sizes.

2000-11-19  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000/rs6000.c (rs6000_encode_section_info): Fix string length
	calculation and allocation.

2000-11-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (c_getstr): Constify variable.
	* gmon-sol2.c (_mcleanup): Comment out #endif labels.
	* conflict.c (const_conflict_graph_arc): New typedef.
	(arc_hash, arc_eq): Avoid needlessly casting away const-ness.
	* cppmacro.c (builtin_macro): Likewise.
	* dwarf2out.c (output_comp_unit): Constify variable.
	* fix-header.c (v_fatal): Add ATTRIBUTE_PRINTF.
	* protoize.c (IS_SAME_PATH_CHAR): Use TOUPPER, not toupper.
	* ssa.c (ssa_rename_from_hash_function): Avoid needlessly casting
	away const-ness.
	* tradcpp.c (rescan, do_line, macroexpand, macarg): Use
	ISALNUM/ISDIGIT/ISPRINT, not isalnum/isdigit/isprint.
	* varasm.c (const_str_htab_hash, const_str_htab_eq,
	compare_constant_1, record_constant_1): Constify.

2000-11-18  Richard Henderson  <rth@redhat.com>

	* c-decl.c (grokdeclarator): Special case the creation of an
	index for a zero-length array.
	* tree.c (build_index_type): Revert Oct 20 change.

2000-11-18  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr-protos.h (avr_output_addr_vec_elt): Prototype.
	* config/avr/avr.c (jump_tables_size): New variable.
	(function_prologue): Initialize it as 0.
	(function_epilogue): Add it to function_size.
	(avr_output_addr_vec_elt): New function.  Count words in jump
	tables in jump_tables_size.  Move code ...
	* config/avr/avr.h (ASM_OUTPUT_ADDR_VEC_ELT): ... from here.
	Call avr_output_addr_vec_elt instead.
	* config/avr/avr.md (tablejump): Remove disabled define_expand.

2000-11-18  Mark Mitchell  <mark@codesourcery.com>

	* configure.in: Make --enable-new-gxx-abi the default.
	* configure: Likewise.

2000-11-18  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (tradcpp.o, tradcif.o): Depend on tradcpp.h.

	* tradcif.y: Include tradcpp.h.  Constify.  Make functions static.
	Move extern function declarations to tradcpp.h.

	* tradcpp.c: Likewise.

	* tradcpp.h: New file.

2000-11-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (check_for_loop_decls): New function.
	* c-parse.in (for_init_stmt): New.
	(select_or_iter_stmt): Use for_init_stmt.
	* c-tree.h (check_for_loop_decls): New declaration.

2000-11-18  Neil Booth  <neilb@earthling.net>

	* cppinit.c: Update comments.
	(cpp_reader_init): Make -imacro and -include use the standard
	#include "" search path.
	(do_includes): New function.

2000-11-18  Ben Elliston  <bje@redhat.com>

	* config/sh/crt1.asm (start_l): Move PC-relative move instruction
	out of a branch delay slot.

2000-11-17  Richard Henderson  <rth@redhat.com>

	* config/alpha/elf.h (PREFERRED_DEBUGGING_TYPE): Set to DWARF2_DEBUG.
	(ASM_SPEC): Disable and enable .mdebug based on -gstabs.
	(ASM_FILE_START): Only write out ecoff .file directive if
	emitting mdebug debugging.

2000-11-17  Richard Henderson  <rth@redhat.com>

	* configure.in (HAVE_AS_DWARF2_DEBUG_LINE): New.  Detect
	whether as accepts .file/.loc and produces dwarf2 line info.
	* dwarf2out.c (DWARF2_ASM_LINE_DEBUG_INFO): Default on if
	the assembler supports it.
	* config.in, configure: Regenerate.

2000-11-17  Richard Henderson  <rth@redhat.com>

	* fixinc/mkfixinc.sh: Don't disable fixincludes for any linux*.

2000-11-17  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.c (emit_insn_group_barriers, case CALL_INSN):
	Don't clear need_barrier is next_insn is a CALL_INSN, or has
	instruction type B or UNKNOWN.

2000-11-17  Neil Booth  <neilb@earthling.net>

	* cpperror.c (print_file_and_line): Don't display line number if 0.

2000-11-17  Zack Weinberg  <zack@wolery.stanford.edu>

	* ggc.h: Delete ggc_add_string_root and ggc_mark_string.  Add
	digit_vector and digit_string.
	* stringpool.c (digit_vector): New.
	(ggc_alloc_string): Use digit_string.

	* stmt.c (digit_strings): Delete.
	(init_stmt): Do not initialize digit_strings.
	(expand_asm_operands): Use ggc.h's digit_string macro.
	* toplev.c (mark_file_stack): Delete.
	(compile_file): Don't call init_tree_codes.
	(main): No need to make the file stack a GC root.
	* tree.c (init_tree_codes): Delete.
	* tree.h (init_tree_codes): Delete.

	* c-lex.c: Don't include ggc.h.
	(mark_splay_tree_node, mark_splay_tree): Delete.
	(init_c_lex): No need to ggc_strdup string constant.  Don't add
	file_info_tree to GGC roots.
	(cb_enter_file, cb_rename_file): No need to ggc_strdup
	ip->nominal_fname.

	* Makefile.in (c-lex.o): No longer depends on $(GGC_H).

	* dbxout.c (dbxout_init),
	dwarf2out.c (dwarf2out_line),
	ggc-common.c (ggc_mark_rtx_children, ggc_mark_trees),
	varasm.c (mark_const_hash_entry, mark_pool_constant, init_varasm_once),
	xcoffout.c (xcoffout_source_file),
	i386.c (load_pic_register):
	Delete call(s) to ggc_add_string_root and/or ggc_mark_string.

	* except.c (create_rethrow_ref),
	profile.c (init_edge_profiler),
	toplev.c (compile_file),
	varasm.c (named_section, assemble_static_space,
	assemble_trampoline_template, output_constant_def, force_const_mem),
	i386.c (load_pic_register),
	ia64.c (ia64_encode_section_info),
	rs6000.c (rs6000_emit_load_toc_table, create_TOC_reference,
	rs6000_emit_prologue, rs6000_emit_epilogue),
	rs6000.md (load_toc_aix_si, load_toc_aix_di):
	Change ggc_alloc_string (var, -1) to ggc_strdup (var).

	* profile.c (output_func_start_profiler),
	tree.c (make_node),
	i386.c (load_pic_register): No need to ggc_strdup string constant.

2000-11-17  Hans-Peter Nilsson  <hp@axis.com>

	* Makefile.in (config.status): Depend on config.gcc.
	* configure.in <for machine in $build $host $target>: Move
	contents of loop into config.gcc, removing autoconf quoting.
	Fix changequote bug for alpha*-*-vxworks*.
	* configure: Regenerate.
	* config.gcc: New.

2000-11-16  Zack Weinberg  <zack@wolery.stanford.edu>

	* c-parse.in (if_prefix): Find the filename and line number at
	$-2 and $-1 respectively.
	* diagnostic.c (error_recursion): Add missing newline, use
	fputs, translate string.

2000-11-16  Zack Weinberg  <zack@wolery.stanford.edu>

	* stringpool.c: New file.
	* ggc-common.c (ggc_mark_string_ptr, ggc_add_string_root): Delete.
	(ggc_alloc_string): Now in stringpool.o.
	* ggc-page.c, ggc-simple.c: Do not define or allocate empty_string.
	* ggc.h: Delete prototype of ggc_add_string_root.  #define
	ggc_add_string_root and ggc_mark_string to nothing.  Prototype
	init_stringpool and stringpool_statistics.
	(ggc_alloc_string): Returns a const char *.
	* tree.c (hash_table, do_identifier_warnings): Delete.
	(init_obstacks): Don't initialize the identifier hash table.
	(get_identifier, maybe_get_identifier, start_identifier_warnings,
	set_identifier_size): Now in stringpool.c.
	* tree.h (struct tree_string): Constify pointer field.
	(approx_sqrt): Prototype.

	* Makefile.in (stringpool.o): Add rule, mention in OBJS.

	* toplev.c (approx_sqrt): New function.
	(compile_file): Call stringpool_statistics if mem_report is on.
	(main): Call init_stringpool.

	* builtins.c (c_strlen), c-decl.c (finish_decl), c-lex.c
	(process_directive), c-typeck.c (constructor_asmspec, struct
	initializer_stack, start_init), except.c (create_rethrow_ref),
	stmt.c (digit_strings), toplev.c (decode_f_option), tree.c
	(built_in_filename), varasm,c (in_named_name,
	assemble_static_space, struct constant_descriptor, struct
	deferred_string, struct pool_constant, force_const_mem),
	i386.c (pic_label_name, global_offset_table_name), rs6000.c
	(rs6000_emit_prologue, rs6000_emit_epilogue) : Constify a char *.

	* c-common.c (combine_strings): Combine strings in scratch
	buffer, then pass to build_string.
	* optabs.c (init_libfuncs), profile.c (init_edge_profiler,
	output_func_start_profiler), stmt.c (init_stmt), alpha.c
	(alpha_need_linkage), arm.c (arm_encode_call_attribute),
	i386.c (load_pic_register), ia64.c (ia64_encode_section_info),
	rs6000.c (rs6000_encode_section_info): Create string in
	scratch buffer, then pass to ggc_alloc_string.

	* stmt.c (expand_asm_operands): If we must adjust the
	constraint strings, do so by creating a new one, not by
	modifying the old one in place.  Constify some char *s.
	* config/pa/pa.c (hppa_encode_label): Drop unnecessary second
	argument.  Create string in scratch buffer, then pass to
	ggc_alloc_string.
	* config/pa/pa-protos.h: Update prototype.
	* config/pa/elf.h, config/pa/pa.h, config/pa/som.h:
	hppa_encode_label takes only one argument.

2000-11-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mcore.c (mcore_expand_prolog): Call xmalloc/xrealloc, not
	malloc/realloc.

	* cpplib.c (glue_header_name): Likewise.

	* fixincl.c (run_compiles, start_fixer): Likewise.

	* fixlib.c (load_file_data): Likewise.

	* mkdeps.c (munge): Likewise.

2000-11-17  Hans-Peter Nilsson  <hp@axis.com>

	* defaults.h [EH_FRAME_SECTION_ASM_OP] (EH_FRAME_SECTION): Remove
	trailing ';'.  Fix formatting.

2000-11-16  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.h (MASK_INLINE_DIV_LAT, MASK_INLINE_DIV_THR):
	Shift masks left by one to avoid conflict.

	* config/ia64/ia64.c (ia64_encode_section_info): Disallow decls with
	DECL_EXTERNAL set.

2000-11-16  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (output_arm_prologue): Note nested functions.
	(arm_expand_prologue): For nested functions preserve the
	static chain register during stack frame creation.

	* config/arm/arm.h (STATIC_CHAIN_REGNUM): Change to 12.
	(ARM_INITIAL_FRAME_ELIMINATION_OFFSET): For a nested function
	with a stack frame there is a 4 byte gap between the arg
	pointer and the hard frame pointer (used to preserve the
	static chain register during stack frame creation).

2000-11-16  DJ Delorie  <dj@redhat.com>

	* rtl.c (read_rtx): Provide suitable names for unnamed
	define_insn and define_insn_and_split patterns, based on file
	and line numbers.

2000-11-15  Neil Booth  <neilb@earthling.net>

	* cpplib.c (start_directive, end_directive): New functions.
	(_cpp_handle_directive, run_directive): Use them.
	(_cpp_handle_directive): Don't -Wtraditional on indented
	null directives.
	(_cpp_push_buffer): Don't re-clear was_skipping.
	* cpplib.h (struct cpp_reader): New member la_saved.
	* cppmacro.c (cpp_get_token): Don't interpret _Pragma in
	directives.

	gcc.dg/cpp/_Pragma1.c: Update.
	gcc.dg/cpp/_Pragma2.c: New test.

2000-11-15  Mark Mitchell  <mark@codesourcery.com>

	* toplev.c (wrapup_global_declarations): Don't write out
	artificial static variables that aren't needed.

2000-11-15  Bernd Schmidt  <bernds@redhat.co.uk>

	* ia64.c (struct group): New structure.
	(last_group): New static array.
	(group_idx): New static variable.
	(emit_group_barrier_after, errata_find_address_regs, errata_emit_nops):
	New static functions.
	(emit_insn_group_barriers): Initialize and keep track of group_idx
	and last_group.
	Call errata_emit_nops if TARGET_B_STEP or TARGET_A_STEP.
	Replace all calls to emit_insn_after that emit a group barrier to use
	emit_group_barrier_after.
	* ia64.h (MASK_B_STEP): New.
	(other MASK_XXX macros): Renumbered.
	(TARGET_B_STEP): New.
	(TARGET_SWITCHES): Add -mb-step.

2000-11-15  Fred Fish  <fnf@be.com>

	* fixinc/mkfixinc.sh (fixincludes): Add *-*-beos* to list of
	machines for which fixincludes is not needed.
	* config/i386/x-beos (STMP_FIXPROTO): Don't run fixproto.

2000-11-15  Jason Merrill  <jason@redhat.com>

	* diagnostic.c (finish_abort): New fn.
	(fancy_abort, error_recursion): Use it.
	* toplev.c (crash_signal): Likewise.
	* diagnostic.h: Declare it.

2000-11-13  Andrew Haley  <aph@redhat.com>

	* tree.c (build_type_no_quals): New function.
	* tree.h (build_type_no_quals): Declare.
	* c-common.c (c_get_alias_set): When considering type
	compatibility for pointer types, ignore cv-qualifiers anywhere in
	a pointer chain.

2000-11-15  Graham Stott  <grahams@redhat.com>

	* regrename.c (scan_rtx_rtx): Skip to the next chain on
	encountering a terminated chain.

2000-11-14  Mark Mitchell  <mark@codesourcery.com>

	* configure.in: Move check for V3 above check for C++ header-file
	directory.
	* configure: Regenerated.

2000-11-14  DJ Delorie  <dj@redhat.com>

	* config/v850/v850.c: Remove obstacks.

Tue Nov 14 21:54:31 2000  Marek Michalkiewicz  <marekm@linux.org.pl> & Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (avr_case_values_threshold): New.
	(avr_override_options): Set it depending on options, make it large
	when not optimizing to work around "unable to generate reloads".

	* config/avr/avr.h (TARGET_SWITCHES): Add -mno-tablejump option.
	(EXTRA_SECTION_FUNCTIONS): Make the .progmem.gcc_sw_table section
	executable if not AVR_MEGA.  Make sure jump tables are word-aligned.
	(JUMP_TABLES_IN_TEXT_SECTION): Define as 0, not 1.
	(ASM_OUTPUT_ADDR_VEC_ELT): Optimize, use "rjmp" if not AVR_MEGA.
	(avr_case_values_threshold): Declare as extern int.
	(CASE_VALUES_THRESHOLD): Define as avr_case_values_threshold.

	* config/avr/avr.md (tablejump): Removed.
	(*tablejump_rjmp): New for jump tables made from "rjmp" instructions.
	(*tablejump_lib, *tablejump_enh, *tablejump): Change to expect the
	index in the table, not multiplied by 2.
	(casesi): Change to match the above insns.  Always enable.

	* config/avr/libgcc.S (__tablejump__): Rename to __tablejump2__.
	Change to expect the word address of the table, multiply it by 2
	here and not in the caller.  Change "adiw" to faster "inc".

2000-11-14  Neil Booth  <neilb@earthling.net>

	* cppexp.c (parse_defined): Call cpp_get_token not
	_cpp_get_token.
	(lex): Similarly.
	* cpplex.c (cpp_output_line): Similarly.
	* cpplib.c (glue_header_name, do_line, do_ident,
	parse_answer, parse_assertion): Similarly.
	(_cpp_handle_diretive): Don't save to lookaheads
	when processing directives.
	* cppmacro.c (parse_arg, expand_arg): Call cpp_get_token not
	_cpp_get_token.
	(funlike_invocation_p): Don't save to lookaheads
	when pre-expanding arguments.
	(_cpp_get_token): Delete.
	(cpp_get_token): Merge contents of _cpp_get_token.

2000-11-14  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (expand_builtin_setjmp): Set
	current_function_calls_setjmp.
	(expand_builtin_longjmp): Set current_function_calls_longjmp.

	* config/sparc/sparc.md (builtin_setjmp_setup): New expand.
	(do_builtin_setjmp_setup): New insn.

Tue Nov 14 12:34:56 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.c (get_unwidened): Use host_integerp and tree_low_cst.
	(int_fits_type_p): For variable bounds, call force_fit_type.

2000-11-14  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (struct deferred_string): New structure.
	(const_str_htab): New variable.
	(STRHASH): New macro.
	(mark_const_str_htab_1, mark_const_str_htab, const_str_htab_hash,
	constr_str_htab_eq, const_str_htab_del): New functions.
	(output_constant_def): Add DEFER argument, defer string
	constants until mark_constant_pool time if requested.
	(mark_constant_pool): Walk the insn chain even if const_str_htab is
	not empty.
	(mark_constants): If a SYMBOL_REF for deferred string is found,
	output it and remove from hash table.
	(output_addressed_constants): Set DEFER to 0 in call to
	output_constant_def.
	* rtl.h (STRING_POOL_ADDRESS_P): Define.
	(output_constant_def): Adjust prototype.
	* expr.c (expand_expr): Set DEFER to 1 in call to output_constant_def.

2000-11-14  Chandrakala Chavva  <cchavva@redhat.com>

	* optabs.c (expand_complex_ab):: Use overflow-trapping optabs for
	signed types if flag_trapv.

2000-11-14  Zack Weinberg  <zack@wolery.stanford.edu>

	* tradcpp.c, tradcif.y: Update FSF mailing address, delete
	reference to GPLv1.

2000-11-14  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.h (CTI_C_SIZE_TYPE): Update comment.

2000-11-14  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (struct varasm_status): Change x_const_rtx_sym_hash_table
	to array of pool_constnat pointers.
	(struct pool_constant): Add next_sym and label members.
	(struct pool_sym): Remove.
	(init_varasm_status): Change pool_sym into pool_constant.
	(mark_pool_constant): Mark pc->label string as well.
	(mark_pool_sym_hash_table): Remove.
	(mark_varasm_status): Remove it from caller as well.
	(free_varasm_status): Don't free pool_sym structures.
	(force_const_mem): Don't allocate pool_sym structure, instead
	fill pool->label and chain it into rtx_sym hash table.
	(find_pool_constant, mark_constant_pool): Use pool_constant instead
	of pool_sym.

2000-11-14  Jakub Jelinek  <jakub@redhat.com>

	* reload1.c (emit_input_reload_insns): Honor forcing of constants
	into memory by PREFERRED_RELOAD_CLASS NO_REGS.

2000-11-14  Michael Matz  <matzmich@cs.tu-berlin.de>

	* dominance.c: New file.
	* Makefile.in (OBJS): Add dominance.o.

	* flow.c (compute_flow_dominators): Remove.
	(compute_immediate_dominators): Remove.
	(compute_immediate_postdominators): Remove.
	* basic-block.h: Remove their prototypes.
	(calculate_dominance_info): Add prototype.

	* dce.c (eliminate_dead_code): Change calls to above functions.
	Don't compute dominators but only immediate dominators.
	* flow.c (flow_loops_find): Change callers.
	* gcse.c (compute_code_hoist_data): Likewise.
	* haifa-sched.c (schedule_insns): Likewise.
	* ifcvt.c (if_convert): Likewise.
	* ssa.c (convert_to_ssa): Likewise, and only compute immediate
	dominators.

2000-11-14  Richard Henderson  <rth@redhat.com>

	* stmt.c (warn_if_unused_value): Don't warn if the expression
	has side effects.

	* c-typeck.c (c_sizeof): Fold result to c_size_type_node.
	(c_sizeof_nowarn, c_alignof, c_alignof_expr): Likewise.

2000-11-13  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* loop.c (basic_induction_var): Revert accidental checkin.

2000-11-13  Hans-Peter Nilsson  <hp@axis.com>

	* c-lex.c (cb_leave_file): Harmonize conditions and order of
	statements to those of process_directive for (action == act_pop).

	* collect2.c (main): Pass on -B options from COLLECT_GCC_OPTIONS.

	* local-alloc.c (equiv_init_movable_p): References to CC0 are not
	movable.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (stmts_and_decls): Deprecate use of label at end of
	compound statement.

2000-11-13  Neil Booth  <neilb@earthling.net>

	* cpplex.c (_cpp_lex_token): CPP_COMMENT and true CPP_EOF
	cases return without MI check.
	* cpplib.c (do_diagnostic): Take boolean of whether to
	print the directive name.
	(do_error, do_warning): Update.
	(do_pragma_dependency): Use it.
	* cpplib.h (VARARGS_FIRST): Delete.
	(struct cpp_token): Delete integer.
	* cppmacro.c (enter_macro_context): Move disabled check
	to _cpp_get_token.
	(_cpp_get_token): Simplify into a single loop.

2000-11-13  Richard Earnshaw  <rearnsha@arm.com>

	* configure.in:  Use 'test -f' not '[ -e'.
	* configure: Regenerated.

2000-11-13  DJ Delorie  <dj@redhat.com>

	* config/mn10300/mn10300.md (store_movm): Note which registers are
	really used or clobbered.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (ends_in_label): Remove from %union and %type.
	(decls, stmts, lineno_stmt_or_labels, xstmts,
	lineno_stmt_or_label, stmt_or_label): Remove.
	(stmts_and_decls, lineno_stmt_decl_or_labels_ending_stmt,
	lineno_stmt_decl_or_labels_ending_decl,
	lineno_stmt_decl_or_labels_ending_label,
	lineno_stmt_decl_or_labels_ending_error,
	lineno_stmt_decl_or_labels, compstmt_contents_nonempty,
	lineno_stmt, lineno_label): New.
	(compstmt_nostart): Use compstmt_contents_nonempty.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (boolean_increment): New function.
	* c-common.h (enum c_tree_index): Add CTI_C_BOOL_TYPE,
	CTI_C_BOOL_TRUE and CTI_C_BOOL_FALSE.
	(c_bool_type_node, c_bool_true_node, c_bool_false_node): Define.
	(boolean_increment): Declare.
	* c-convert.c (convert): Allow for BOOLEAN_TYPE.
	* c-decl.c (init_decl_processing): Create boolean nodes.
	(finish_struct): Allow for _Bool bitfields.
	* c-parse.in (reswords): Add _Bool.
	(rid_to_yy): Allow for RID_BOOL.
	* c-typeck.c (default_conversion): Make booleans promote to int.
	(convert_arguments, build_unary_op, build_modify_expr,
	convert_for_assignment): Allow for booleans.
	* ginclude/stdbool.h: Make conforming to C99.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (c99_block_start, c99_block_end,
	c99_block_lineno_labeled_stmt): New.
	(simple_if, do_stmt_start): Use c99_block_lineno_labeled_stmt.
	(stmt): Split off selection and iteration statements into...
	(select_or_iter_stmt): New.  Use c99_block_lineno_labeled_stmt.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi (-Wtrigraphs, -fdump-translation-unit, -save-temps,
	-time): Update.

2000-11-13  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (mulsidi3adddi, umulsidi3adddi): Revert previous change.
	Rewrite to avoid use of match_dup.  Don't try to tie registers that
	are not in the same mode.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Update lists of languages and suffixes supported.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* configure.in: Take toplevel configure arguments from the
	environment to create configargs.h and substitute
	gcc_config_arguments, taking account of any existing configargs.h
	if reconfiguring.
	* configure: Regenerate.
	* gccbug.in: Include toplevel configure arguments in gccbug.

2000-11-13  Richard Earnshaw  <rearnsha@arm.com>

	* varasm.c (struct constant_descriptor): Put CONTENTS inside a
	union to make it well-aligned.  Update all uses.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (initelt): Give appropriate pedantic warnings,
	depending on flag_isoc99, for non-ISO syntax and for C99 syntax
	outside C99 mode.
	(designator): If pedantic, pedwarn for a designator specifying a
	range of elements.
	* c-typeck.c (set_init_index, set_init_label): Don't pedwarn for
	these cases.
	* extend.texi: Document the C99 syntax as the preferred syntax,
	and the pre-2.5 syntax as obsolete.  Mention use of designator
	lists for nested subobjects.

2000-11-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* diagnostic.c (vbuild_message_string, output_do_printf, vnotice):
	Add ATTRIBUTE_PRINTF.
	* tradcpp.c (v_message, warning, error, fatal, error_with_line):
	Add ATTRIBUTE_PRINTF*.

2000-11-12  Mark Mitchell  <mark@codesourcery.com>

	* function.c (assign_parms): When calling put_var_into_stack, make
	sure that there are no hidden pending sequences.

2000-11-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin): Handle BUILT_IN_INDEX and
	BUILT_IN_RINDEX.  Add missing checks for BUILT_IN_STRCHR and
	BUILT_IN_STRRCHR.

	* builtins.def (BUILT_IN_INDEX, BUILT_IN_RINDEX): New entries.

	* c-common.c (c_common_nodes_and_builtins): Declare index and
	rindex when nonansi builtins are allowed.

	* extend.texi (index, rindex): Document new builtins.

2000-11-12  Mark Mitchell  <mark@codesourcery.com>

	* configure.in: Turn on libstdc++ V3 by default.
	* configure: Regenerated.

	* fixinc/mkfixinc.sh: Use the ordinary fixincludes on Solaris.

2000-11-12  Jakub Jelinek  <jakub@redhat.com>

	* reload1.c (set_label_offsets): Go inside of PARALLELs.

2000-11-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Clean up option summary.

2000-11-12  Nick Clifton  <nickc@redhat.com>

	* config/mcore/mcore.c: Fix comment formating, and adjust sequence
	of #include headers.

2000-11-12  Marc Espie <espie@openbsd.org>

	* configure.in: Fix filds test.
	* configure: Regen.

2000-11-12  Mark Mitchell  <mark@codesourcery.com>

	* jump.c (delete_computation): Don't assume that just because an
	instruction sets a register, that register is dead.

2000-11-12  Neil Booth  <neilb@earthling.net>

	* cppexp.c: Don't worry about pfile->skipping.
	* cpplib.c (struct if_stack): Make was_skipping unsigned char.
	(cpp_handle_directive): Save pfile->skipping in struct cpp_buffer
	for handled directives.
	(skip_rest_of_line): Use _cpp_lex_token after popping contexts
	and releasing lookaheads.
	(do_ifdef, do_ifndef, do_if): Use buffer->was_skipping.
	(do_else, do_elif, push_conditional): Update logic.
	(do_endif): Set buffer->was_skipping rather than pfile->skipping.
	(unwind_if_stack): Inline into cpp_pop_buffer.
	(cpp_push_buffer): Clear ifs->was_skipping for cpp_handle_directive.
	* cpplex.c (_cpp_lex_token): Clear skipping on EOF.  Handle
	multiple-include optimisation.
	* cpplib.h (struct cpp_buffer): New member was_skipping.
	* cppmacro.c (_cpp_get_token): Loop whilst pfile->skipping.  This
	works because skipping == 0 in directives.
	(_cpp_release_lookahead): Renamed from release_lookahead.
	(cpp_get_token): No need to check skipping as _cpp_get_token does
	this for us.  No need to handle MI optimisation.

Sat Nov 11 21:14:02 2000  Mark P Mitchell  <mark@codesourcery.com>

	* fixinc/inclhack.def (sunos_matherr_decl): Bypass matherr
	declarations that use `__MATH_EXCEPTION' in their prototypes, too.
	* fixinc/fixincl.x: Regenerated.

2000-11-11  Bruce Korb  <bkorb@gnu.org>

	* fixinc/inclhack.def (avoid_bool_type): avoid commenting out #endif
	(avoid_wchar_t_type): ditto
	* fixinc/fixinc.irix: obsoleted

2000-11-11  Zack Weinberg  <zack@wolery.stanford.edu>

	* configure.in: Don't add $outputs to all_lang_makefiles.  Add
	$srcdir/$s/Makefile.in if it exists.
	* configure: Regenerate.

Sat Nov 11 18:41:20 2000  Mark P Mitchell  <mark@codesourcery.com>

	* fixinc/mkfixinc.sh: Use the ordinary fixincludes on IRIX.

2000-11-11  Jason Merrill  <jason@redhat.com>

	* function.c (assign_parms): If TREE_ADDRESSABLE is set, try to
	give the parm a register and then call put_var_into_stack.
	* stmt.c (expand_decl): Likewise.

2000-11-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi: Adjust wording.

2000-11-11  Mark Mitchell  <mark@codesourcery.com>

	* fixinc/inclhack.def (avoid_wchar_t_type): New fix.
	* fininc/fixincl.x: Regenerated.

2000-11-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Correct spelling of -foptimize-register-move.

2000-11-11  Neil Booth  <neilb@earthling.net>

	Remove CPP_PLACEMARKERs.

	* cppexp.c (lex): Don't handle CPP_PLACEMARKER.
	* cpplex.c (_cpp_lex_token): Rename skip_newlines to next_bol
	* cpplib.c (skip_rest_of_line, check_eol, cpp_push_buffer):
		   Similarly.
	* cpplib.h: Remove CPP_PLACEMARKER.
	(struct lexer_state): Rename skip_newlines to next_bol.
	* cppmacro.c (stringify_arg): Don't handle CPP_PLACEMARKER.
	Simplify prev_white handling as a result.
	(paste_all_tokens): Don't worry about CPP_PLACEMARKERs.
	(parse_arg): Empty arguments are now empty, not CPP_PLACEMARKERs.
	(parse_args): Similarly.  Update argument count tests.
	(enter_macro_context): Return 2 to indicate an empty macro.
	(replace_args): Don't bother pre-expanding an empty argument.
	Handle placemarkers and ## extension during pre-expansion.
	(cpp_get_token): Handle empty macro expansions.  Don't worry
	about CPP_PLACEMARKERs.
	(_cpp_create_definition): Empty macros are now empty.
	(cpp_macro_definition): Don't special case empty macros.
	* scan-decls.c: Don't bother with CPP_PLACEMARKERs.
	* c-lex.c: Similarly.

2000-11-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi, invoke.texi: Add new section discussing language
	standards; link to it where appropriate; refer to ISO C instead of
	ANSI C.

2000-11-11  Alexandre Oliva  <aoliva@redhat.com>

	* builtins.c (std_expand_builtin_va_start): Take PARM_BOUNDARY
	into account.

	* config/sh/sh.h (MODES_TIEABLE_P): Don't tie SFmode to other FP
	modes.

2000-11-10  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi, gcov.texi: Update dates and version numbers.

2000-11-10  Zack Weinberg  <zack@wolery.stanford.edu>

	* configure.in: Remove AC_PROG_LEX and AC_PROG_YACC.  Look for
	flex and bison, specifically, first in a unified build and
	then installed on the system.
	* Makefile.in: Set BISON to @BISON@, FLEX to @FLEX@.  Rename
	LEXFLAGS to FLEXFLAGS.  Adjust ORDINARY_FLAGS_TO_PASS to
	match.

	(collect2.o, gcc.o, prefix.o, toplev.o, alloca.o, intl.o,
	cppdefault.o): Remove pointless sed munging of source file
	name.

2000-11-10  Bernd Schmidt  <bernds@redhat.co.uk>

	* reload.c (find_reloads_address_1, case POST_MODIFY): Use RELOAD_OTHER
	for address reloads.  Push replacements for REG_INC notes.
	(regno_clobbered_p): New arg SETS.  Examine SETs if it's nonzero.  All
	callers changed.
	* reload1.c (choose_reload_regs): Registers set in the insn can't be
	used for RELOAD_OTHER reloads.

2000-11-10  Mark Mitchell  <mark@codesourcery.com>

	* c-dump.h: New file.

2000-11-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c (check_float_value): Use memcpy, not bcopy.
	* arm.c (output_move_double): Likewise.
	* arm.md: Likewise.
	* m88k.c (legitimize_operand): Likewise.
	* m88k.h (ORDER_REGS_FOR_LOCAL_ALLOC): Likewise.
	* m88k.md: Likewise.
	* mips.c (override_options): Likewise.
	* mips.md: Likewise.
	* romp.c (output_fpops): Likewise.
	* rs6000.c (rs6000_override_options): Likewise.
	* sh.md: Likewise.
	* vax.c (check_float_value): Likewise.

	* emit-rtl.c (copy_rtx_if_shared, init_emit_once): Likewise.
	* expmed.c (synth_mult): Likewise.
	* final.c (add_bb_string): Likewise.
	* genattr.c (main): Likewise.
	* genattrtab.c (attr_string, simplify_cond, copy_rtx_unchanging):
	Likewise.
	* jump.c (thread_jumps): Likewise.
	* prefix.c (save_string): Likewise.
	* real.h (REAL_VALUE_FROM_CONST_DOUBLE): Likewise.
	* regclass.c (init_reg_sets, init_reg_sets_1): Likewise.
	* reload1.c (reload, eliminate_regs): Likewise.

2000-11-10  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi (Service): Update to reflect current practice and
	location of the GNU service directory.

2000-11-09  Bernd Schmidt  <bernds@redhat.co.uk>

	* regrename.c (build_def_use): Mark contents of REG_INC notes as
	needing replacement.

	* config/ia64/ia64.md (extendsfdf2, extendsftf2, extenddftf2): Emit
	a no-op move if regs are equal.
	* toplev.c (rest_of_compilation): Do the noop moves elimination pass
	when calling jump after post-reload splitting.

2000-11-09  Jan van Male  <jan.vanmale@fenk.wau.nl>

	* c-tree.texi: Fix typos.
	* extend.texi: Likewise
	* gcov.texi: Likewise
	* rtl.texi: Likewise
	* tm.texi: Likewise

2000-11-09  Hans-Peter Nilsson  <hp@axis.com>

	* c-lex.c [! NO_IMPLICIT_EXTERN_C] (cb_enter_file): Check
	in_system_header and flags[1] before dereferencing flags[2].

2000-11-09  Matthew Hiller <hiller@redhat.com>

	* reload1.c (reload_combine): Fixed calculation of
	first_index_reg, last_index_reg.

2000-11-09  Mark Mitchell  <mark@codesourcery.com>

	* c-dump.c (dequeue_and_dump): Dump function bodies.

	* Makefile.in (C_AND_OBJC_OBJS): Add c-dump.o.
	(c-dump.o): New target.
	* c-common.h (flag_dump_translation_unit): New variable.
	(C_TYPE_QUALS): New macro.
	(strip_array_types): New function.
	(DECL_C_BIT_FIELD): New macro.
	(SET_DECL_C_BIT_FIELD): Likewise.
	(CLEAR_DECL_C_BIT_FIELD): Likewise.
	(dump_info_p): New typedef.
	(dump_tree_fn): Likewise.
	(lang_dump_tree): New variable.
	(dump_node_to_file): New function.
	* c-common.c (flag_dump_translation_unit): Define it.
	(strip_array_types): New function.
	* c-decl.c (c_decode_option): Handle -fdump-translation-unit.
	* c-lang.c (finish_file): Call dump_node_to_file if
	flag_dump_translation_unit.
	* c-semantics.c (mark_rtl_for_local_static): Fix typo in comment.
	* c-tree.h (DECL_C_BIT_FIELD): Remove declaration.
	* c-dump.c: New file.

2000-11-09  Christopher Faylor <cgf@cygnus.com>

	* config/i386/cygwin.h: Add mingw startfile prefix.

2000-11-09  Richard Henderson  <rth@redhat.com>

	* flow.c (invalidate_mems_from_set): Split out from ...
	(mark_set_1): ... here.
	(try_pre_increment_1): Use it.  Use propagate_block_delete_insn
	instead of turning insn into a NOTE_INSN_DELETED.

2000-11-10  Joseph S. Myers  <jsm28@cam.ac.uk>

	* extend.texi, invoke.texi: Move documentation of builtin versions
	of C library functions to one place and update.

2000-11-09  Richard Henderson  <rth@redhat.com>

	* fold-const.c (fold): Compare TYPE_MAIN_VARIANT rather than
	the types themselves to discover type equivalence.

2000-11-09  Mike Stump  <mrs@wrs.com>

	* Makefile.in (distclean): Remove a few extra leftovers.

2000-11-09  Richard Henderson  <rth@redhat.com>

	* recog.c (validate_replace_rtx_1): Consider subregs when
	replacing a register with a constant inside a sign/zero_extend.

	* config/alpha/linux.h (HANDLE_PRAGMA_PACK_PUSH_POP): Define.

2000-11-09  Geoffrey Keating  <geoffk@redhat.com>

	* c-decl.c (finish_struct): When a structure is completed,
	check all its variant types for completeness.

2000-11-09  Neil Booth  <neilb@earthling.net>

	* cpphash.c: Move cpp_defined here from cpplib.c.
	* cpplib.c: Update comments, move cpp_defined to cpphash.c.
	* cpplex.c (_cpp_lex_token): Don't leave the lexer at EOL.
	* cppmacro.c (cpp_get_token): Update comments, no need now
	to catch the CPP_EOF meaning EOL case.

2000-11-08  Geoffrey Keating  <geoffk@redhat.com>

	* config/sparc/sparc.c (sparc_va_arg): When the required alignment
	is more than that provided, copy to a temporary.

2000-11-09  Alexandre Oliva  <aoliva@redhat.com>

	* mklibgcc.in (EXTRA_MULTILIB_PARTS): Prevent `make' from
	interpreting $out as a macro assignment.
	* Makefile.in (T_TARGET): New auxiliary macro and target.
	(all): Add a target right in the beginning, so that we don't build
	T_TARGET by default.

2000-11-09  Graham Stott  <grahams@redhat.com>

	* config/i386/i386.md (mmx_pinsrw): Output operands in correct
	order for -mintel-syntax.  Remove comment now that the operand
	order has been checked.
	(mmx_pextrw): Likewise.
	(mmx_pshufw): Likewise.

2000-11-09  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (c_strlen): Use TREE_STRING_LENGTH - 1 for max.
	(c_getstr): New function.
	(expand_builtin_strstr): Do nothing if -fcheck-memory-usage.
	If both arguments are constant string, optimize out.
	(expand_builtin_strchr, expand_builtin_strrchr): New functions.
	(expand_builtin_strpbrk): Use c_getstr, do nothing if
	-fcheck-memory-usage.
	(expand_builtin_fputs): Likewise.
	(expand_builtin_strcmp): Add MODE argument.
	Use even if !HAVE_cmpstrsi.
	Optimize the case when both arguments are constant strings.
	(expand_builtin): Adjust expand_builtin_strcmp caller.
	Call expand_builtin_strchr and expand_builtin_strrchr.
	* c-common.c (c_common_nodes_and_builtins): Add strchr and strrchr
	builtins.
	* builtins.def (BUILT_IN_STRRCHR): Add.

2000-11-08  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* fixinc/gnu-regex.c: Rename EGCS LOCAL markers to GCC LOCAL.

2000-11-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* calls.c (expand_call, emit_library_call_value_1), collect2.c
	(scan_prog_file), config/a29k/a29k.c (print_operand),
	config/sparc/sparc.c (order_regs_for_local_alloc): Use memcpy ()
	instead of bcopy ().
	* real.h: Use memcmp () instead of bcmp ().
	* config/m88k/m88k.c (m88k_layout_frame), config/sh/sh.c
	(split_branches), config/sparc/sparc.c (ultra_flush_pipeline,
	ultrasparc_sched_init, ultrasparc_sched_reorder),
	config/sparc/sparc.h (CONDITIONAL_REGISTER_USAGE): Use memset ()
	instead of bzero ().
	* config/vax/xm-xms.h (FILE_NAME_NONDIRECTORY): Use strrchr ()
	instead of rindex ().
	* configure.in: Don't check for bzero, bcmp, index or rindex.
	* configure, config.in: Regenerate.
	* system.h: Don't include declarations for bzero, bcmp, index or
	rindex.
	* config/i386/xm-beos.h, config/rs6000/xm-beos.h: Don't define
	bzero, bcmp, index or rindex.

Wed Nov  8 21:58:20 2000  Christopher Faylor <cgf@cygnus.com>

	* config/i386/cygwin.h: Add -no-win32 switch.  Separate -mno-cygwin
	include and library paths from -mcygwin case.  Parameterize some
	declarations to avoid warnings.  Use standard locations for include and
	lib dirs.

2000-11-08  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (mulsidi3adddi): Change output operand
	constraint from "=&" to "+&".
	(umulsidi3adddi): Change output operand	constraint from "=&" to
	"+&".

2000-11-08  Richard Henderson  <rth@redhat.com>

	* flow.c (init_propagate_block_info): Protect the rtx stored in
	mem_set_list from modification by find_auto_inc.
	(mark_set_1): Likewise.

2000-11-08  Neil Booth  <neilb@earthling.net>

	Move directive handling into the lexer itself.

	* cpplex.c (_cpp_lex_token): Handle directives directly.
	In the case of a directive interrupting a function-like
	macro invocation, use extra_char since read_ahead is
	used to store the '#'.  Return a CPP_EOF in this case.
	* cppmacro.c (parse_arg): No need to handle CPP_DHASH any more.
	(cpp_get_token): Don't handle directives here.
	* cpplib.h: Remove CPP_DHASH token type.

Wed Nov  8 21:53:41 MET 2000  Jan Hubicka  <jh@suse.cz>

	* regmove.c (combine_stack_adjustments_for_blocks): Recognize pushes
	formed using PRE_MODIFY too.

2000-11-08  Mark Mitchell  <mark@codesourcery.com>

	* c-tree.texi (VAR_DECL): Describe representation of GCC's
	extension for placing variables in particular registers.

	* c-tree.texi (FUNCTION_TYPE): Clarify TYPE_ARG_TYPES for
	unprototyped C functions with no parameters.

2000-11-08  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.h (ASM_OUTPUT_MI_THUNK): Cast DELTA to int
	before passing to fprintf.

2000-11-08  Jakub Jelinek  <jakub@redhat.com>

	* function.c (expand_function_start): Cast GET_MODE_SIZE to
	HOST_WIDE_INT before negating it.

2000-11-08  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (expand_expr) [ADDR_EXPR]: Handle when op0 is RETURN_DECL
	passed in multiple non-contiguous locations.

2000-11-08  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.gnat: Remove file.

2000-11-08  Alexandre Oliva  <aoliva@redhat.com>

	* mklibgcc.in (EXTRA_MULTILIB_PARTS): Generate multilib parts
	in-place.

2000-11-07  Richard Henderson  <rth@redhat.com>

	* dwarfout.c (INSN_LABEL_FMT): Remove.
	(output_label_die): Use ASM_GENERATE_INTERNAL_LABEL.
	(dwarfout_label): Remove.
	* dwarfout.h: Remove it's prototype.
	* dwarf2out.c (INSN_LABEL_FMT): Remove.
	(gen_label_die): Use ASM_GENERATE_INTERNAL_LABEL.
	(dwarf2out_label): Remove.
	* dwarf2out.h: Remove it's prototype.
	* final.c (final_scan_insn): Don't call dwarf[2]out_label.

2000-11-07  Richard Henderson  <rth@redhat.com>

	* config/ia64/fde-glibc.c (find_fde_for_dso): Do a binary
	search on the unwind region section.

	* config/ia64/ia64.md (movbi): Add r/r alternative.
	(cmovdi_internal_astep): Describe all combinations of register
	classes for sources & destinations; remove matching constraints.
	(cmovdi_internal): Likewise.

	* gcc.c (default_compilers) [@cpp-output]: Add -fpreprocessed.

2000-11-07  Richard Henderson  <rth@redhat.com>

	* c-lang.c (start_cdtor, finish_cdtor): New functions.
	(finish_file): Use them in building constructor/destructor functions.

	* config/alpha/alpha.h (HAS_INIT_SECTION, LD_INIT_SWITCH,
	LD_FINI_SWITCH): Move ...
	* config/alpha/osf.h: ... here.
	* config/alpha/alpha-interix.h: Don't undef them.

2000-11-07  Jeffrey Oldham  <oldham@oz.codesourcery.com>

	* config/mips/t-iris6 (FPBIT): New.  Added so that __unorddf2 is
	included in libgcc.a.
	(DPBIT): Likewise.
	(dp-bit.c): Likewise.
	(fp-bit.c): Likewise.

2000-11-07  Nick Clifton  <nickc@redhat.com>

	* config/m88k/m88k.h (GLOBAL_ASM_OP): Add missing tab.
	(INTERNAL_ASM_OP): Add missing tab.

2000-11-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* alias.c (init_alias_analysis), calls.c (expand_call,
	emit_library_call_value_1), combine.c (init_reg_last_arrays),
	cse.c (new_basic_block), dbxout.c (dbxout_type), diagnostic.c
	(init_output_buffer, set_diagnostic_context), dwarf2out.c
	(equate_decl_number_to_die, build_abbrev_table), emit-rtl.c
	(init_emit_once), fold-const.c (mul_double, div_and_round_double),
	function.c (assign_parms), gcse.c (compute_can_copy,
	alloc_gcse_mem, alloc_reg_set_mem, record_one_set,
	compute_hash_table, compute_set_hash_table,
	compute_expr_hash_table), genattrtab.c (optimize_attrs), global.c
	(global_alloc, global_conflicts), haifa-sched.c (compute_trg_info,
	clear_units, schedule_block), integrate.c (initialize_for_inline,
	expand_inline_function), jump.c (thread_jumps), local-alloc.c
	(local_alloc), loop.c (combine_movables, count_loop_regs_set,
	load_mems_and_recount_loop_regs_set), print-tree.c (debug_tree),
	regclass.c (init_reg_sets, init_reg_sets_1, regclass,
	record_reg_classes, allocate_reg_info), reload.c
	(get_secondary_mem, remove_address_replacements, find_reloads),
	reload1.c (reload, set_initial_label_offsets, finish_spills,
	reload_as_needed, choose_reload_regs_init,
	reload_cse_simplify_operands), reorg.c (dbr_schedule), sbitmap.c
	(sbitmap_zero), simplify-rtx.c (simplify_plus_minus), ssa.c
	(rename_registers), stmt.c (expand_end_case), unroll.c
	(unroll_loop), varray.c (varray_grow), objc/objc-act.c: Use memset
	() instead of bzero ().

2000-11-07  Neil Booth  <neilb@earthling.net>

	* cp/lang-specs.h: Fix -save-temps specs under USE_CPPLIB.

2000-11-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c (combine_strings): Only warn about long strings for C.

Tue Nov  7 19:44:30 2000  J"orn Rennecke <amylaar@redhat.com>

	* combine.c (distribute_notes): Fix typo in last change.

2000-11-07  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.md (movdi_internal32+1): Use
	operand_subreg_force rather than gen_rtx_SUBREG.
	(movdi_internal32+2): Likewise.

2000-11-07  Philip Blundell  <philb@gnu.org>

	* configure.in (arm*-*-linuxaout*): Obsolete, deleted.
	* config/arm/linux-aout.h: Likewise.
	* configure: Regenerate.

2000-11-07  Philipp Thomas  <pthomas@suse.de>

	* ABOUT-GCC-NLS: Remove the patch for gettext as it has been
	accepted my the gettext maintainer.

2000-11-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strpbrk): New function.
	(expand_builtin): Handle BUILT_IN_STRPBRK.

	* builtins.def (BUILT_IN_STRPBRK): New entry.

	* c-common.c (c_common_nodes_and_builtins): Declare builtin
	strpbrk.

2000-11-07  David O'Brien  <obrien@dragon.nuxi.com>

	* config/alpha/freebsd.h: New file -- FreeBSD/alpha architecture file.
	* POTFILES.in: Add config/alpha/freebsd.h
	* configure.in: Add alpha*-freebsd support.
	* configure: Regenerate.

2000-11-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* tree.c (build_common_tree_nodes_2): Make va_list_type_node be a
	copy of ptr_type_node rather than ptr_type_node itself.

Tue Nov  7 06:29:24 2000  J"orn Rennecke <amylaar@redhat.com>

	* combine.c (recog_for_combine): Allocate uninitialized vector with
	rtvec_alloc.
	* recog.c (apply_change_group): Likewise.

Tue Nov  7 06:24:02 2000  J"orn Rennecke <amylaar@redhat.com>

	* flow.c (verify_local_live_at_start): Back out last change.
	* combine.c (distribute_notes): When parts of a hard reg are
	neither set nor referenced in PLACE, search backwards for a
	place to put a REG_UNUSED note; if none found, ask for flow
	info refresh.

Mon Nov  6 20:08:13 2000  J"orn Rennecke <amylaar@redhat.com>

	* reload1.c (eliminate_regs_in_insn): Allow a set to be a PARALLEL
	with (clobber (match_scratch...)).

2000-11-06  Neil Booth  <neilb@earthling.net>

	* c-lex.c (init_c_lex): If cpp_start_read fails, exit with
	error status.

2000-11-06  Neil Booth  <neilb@earthling.net>

	* tradcpp.c (special_symbol): Assign an null string rather
	than writing to an unallocated buffer.

2000-11-06  Neil Booth  <neilb@earthling.net>

	* cpplex.c (_cpp_equiv_tokens): Check arg_no in the
	CPP_MACRO_ARG case.

2000-11-06  Neil Booth  <neilb@earthling.net>

	* c-lex.c (c_lex): Replace tok.val.aux with tok.val.c or
	tok.val.arg_no as appropriate.
	* cppexp.c (lex): Similarly.
	* cpplex.c (_cpp_lex_token, cpp_spell_token, cpp_output_token,
	cpp_equiv_tokens, cpp_can_paste, cpp_avoid_paste): Similarly.
	* cppmacro.c (stringify_arg, replace_args, lex_expansion_token,
	cpp_macro_definition): Similarly.
	* cpplib.h (struct cpp_token): Replace aux with c and arg_no.

2000-11-06  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (adddi3): If operands[2] is 4096 and
	operands[1] is constant, calculate the sum and generate movdi.
	(addsi3): Similarly.  Use SImode in call to arith_4096_operand.
	(subsi3): Use SImode in call to arith_4096_operand.

2000-11-06  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.h (ASM_OUTPUT_MI_THUNK): On sparc64 we need to
	adjust %o1, not %o0 if the return type is large structure.

2000-11-06  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (smulsi3_highpart_v8plus, ashldi3_v8plus+1,
	update_return, flush, flushdi, ffssi2, ffsdi2): Fix output formatting.

Sat Sep 23 19:10:20 2000  Denis Chertykov  <denisc@overta.ru> & Marek Michalkiewicz  <marekm@linux.org.pl>

	* expmed.c (expand_divmod): For signed divide by 2, prefer
	a branch and fewer shifts if branches are very cheap.

2000-11-05  Joseph S. Myers  <jsm28@cam.ac.uk>

	* Makefile.in: Remove all targets related to building
	distributions and diffs, or INSTALL.
	* INSTALL, install1.texi: Remove.
	* configure.in: Remove mention of distdir.
	* configure: Regenerate.
	* objc/Make-lang.in: Remove mention of distdir.

2000-11-04  Neil Booth  <neilb@earthling.net>

	* cpp.texi: Update for _Pragma.

2000-11-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi (Contributing): Update URL for projects web page.

2000-11-04  Neil Booth  <neilb@earthling.net>

	* cpplex.c (parse_string): Don't allow multiline strings in
	#include family directives.

2000-11-04  Neil Booth  <neilb@earthling.net>

	* cpplib.c (do_line): Only warn pedantically if not reading
	preprocessed input.

2000-11-04  Alexandre Oliva  <aoliva@redhat.com>

	* calls.c (emit_call_1) [sibcall_pop]: Use n_popped instead of
	RETURN_POPS_ARGS().

2000-11-03  Zack Weinberg  <zack@wolery.stanford.edu>

	* builtins.c (expand_builtin_strlen): Remove unused mode
	argument.
	* gcc.c (process_command): Remove unused variable.
	* fold-const.c: Include expr.h.
	* recog.c: Include reload.h.
	* Makefile.in (recog.o, fold-const.o): Update deps.

2000-11-02  Geoffrey Keating  <geoffk@cygnus.com>

	* fixinc/gnu-regex.c: Change 'CYGNUS LOCAL' to 'EGCS LOCAL'.

Fri Nov  3 13:41:04 2000  Mark P Mitchell  <mark@codesourcery.com>

	* config/mips/iris6.h (SUBTARGET_CC1_SPEC): Remove -static
	handling.
	(STARTFILE_SPEC): Likewise.
	(LINK_SPEC): Likewise.

2000-11-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (fold-const.o): Depend on $(GGC_H), not ggc.h.
	(toplev.o): Likewise for $(LOOP_H)/loop.h and $(REGS_H)/regs.h.
	(simplify-rtx.o): Likewise for $(GGC_H)/ggc.h.

2000-11-03  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (duplicate_decls, copy_lang_decl), dwarfout.c
	(dwarfout_line), gcc.c (main, save_string), tree.c (init_obstacks,
	perm_calloc, get_identifier, maybe_get_identifier,
	real_value_from_int_cst, simple_cst_equal), varasm.c
	(assemble_name, assemble_real, immed_real_const_1,
	compare_constant_1, decode_rtx_const, output_constant_pool): Use
	strrchr () instead of rindex ().  Use memcmp () instead of bcmp
	().  Use memcpy () instead of bcopy ().  Use memset () instead of
	bzero ().

2000-11-03  Nathan Sidwell  <nathan@codesourcery.com>

	* cppfiles.c (open_file): If already read, then don't reopen.
	Immediately close an empty file.

2000-11-01  Bernd Schmidt  <bernds@redhat.co.uk>

	* expr.h (fold_builtin): Move declaration...
	* tree.h (fold_builtin): ... here.

Fri Nov  3 05:41:07 2000  J"orn Rennecke <amylaar@redhat.com>

	* flow.c (verify_local_live_at_start): Allow hard regs to die.

2000-11-02  Neil Booth  <neilb@earthling.net>

config:
	* a29k/a29k.h, a29k/unix.h, a29k/vx29k.h,
	alpha/alpha-interix.h, alpha/alpha.h, alpha/linux.h,
	alpha/openbsd.h, alpha/osf.h, alpha/vms.h, alpha/vxworks.h,
	alpha/win-nt.h, arc/arc.h, arm/arm.h, arm/conix-elf.h,
	arm/linux-aout.h, arm/linux-elf.h, arm/netbsd.h, arm/riscix.h,
	arm/riscix1-1.h, arm/semiaof.h, arm/unknown-elf-oabi.h, arm/vxarm.h,
	c4x/rtems.h, clipper/clix.h, convex/convex.h, d30v/d30v.h,
	elxsi/elxsi.h, fr30/fr30.h, h8300/h8300.h, i370/linux.h, i370/mvs.h,
	i370/oe.h, i386/386bsd.h, i386/aix386ng.h, i386/beos-elf.h,
	i386/bsd386.h, i386/crtdll.h, i386/cygwin.h, i386/dgux.h,
	i386/djgpp-rtems.h, i386/djgpp.h, i386/freebsd-aout.h, i386/freebsd.h,
	i386/gnu.h, i386/i386-interix.h, i386/i386.h, i386/linux-aout.h,
	i386/linux-oldld.h, i386/linux.h, i386/lynx-ng.h, i386/lynx.h,
	i386/mach.h, i386/mingw32.h, i386/moss.h, i386/netbsd.h,
	i386/netware.h, i386/next.h, i386/openbsd.h, i386/osf1elf.h,
	i386/osfelf.h, i386/osfrose.h, i386/ptx4-i.h, i386/rtems.h,
	i386/rtemself.h, i386/sco.h, i386/sco4.h, i386/sco4dbx.h, i386/sco5.h,
	i386/scodbx.h, i386/sequent.h, i386/sol2.h, i386/sun.h, i386/sysv3.h,
	i386/sysv4.h, i386/uwin.h, i386/vsta.h, i386/vxi386.h, i386/win-nt.h,
	i386/win32.h, i860/fx2800.h, i860/i860.h, i860/mach.h, i860/sysv3.h,
	i860/sysv4.h, i960/i960.h, i960/rtems.h, i960/vx960-coff.h,
	ia64/ia64.h, ia64/linux.h, m32r/m32r.h, m68k/3b1.h, m68k/3b1g.h,
	m68k/a-ux.h, m68k/altos3068.h, m68k/amix.h, m68k/apollo68.h,
	m68k/crds.h, m68k/ctix.h, m68k/dpx2.h, m68k/hp2bsd.h, m68k/hp320.h,
	m68k/hp3bsd.h, m68k/hp3bsd44.h, m68k/isi.h, m68k/linux-aout.h,
	m68k/linux.h, m68k/lynx-ng.h, m68k/lynx.h, m68k/m68kemb.h,
	m68k/m68kv4.h, m68k/mot3300.h, m68k/netbsd.h, m68k/news.h,
	m68k/next.h, m68k/openbsd.h, m68k/pbb.h, m68k/plexus.h, m68k/rtems.h,
	m68k/rtemself.h, m68k/sun2.h, m68k/sun3.h, m68k/sun3mach.h,
	m68k/tower-as.h, m68k/tower.h, m68k/vxm68k.h, m88k/dgux.h,
	m88k/dolph.h, m88k/luna.h, m88k/m88k-aout.h, m88k/m88k-coff.h,
	m88k/openbsd.h, m88k/sysv3.h, m88k/sysv4.h, mips/bsd-4.h,
	mips/bsd-5.h, mips/dec-bsd.h, mips/dec-osf1.h, mips/gnu.h,
	mips/iris3.h, mips/iris5.h, mips/iris6.h, mips/linux.h, mips/mips.h,
	mips/netbsd.h, mips/news4.h, mips/news5.h, mips/nws3250v4.h,
	mips/openbsd.h, mips/osfrose.h, mips/rtems64.h, mips/sni-svr4.h,
	mips/svr3-4.h, mips/svr3-5.h, mips/svr4-4.h, mips/svr4-5.h,
	mips/ultrix.h, ns32k/encore.h, ns32k/merlin.h, ns32k/netbsd.h,
	ns32k/ns32k.h, ns32k/pc532-mach.h, ns32k/pc532.h, ns32k/sequent.h,
	ns32k/tek6000.h, ns32k/tek6100.h, ns32k/tek6200.h, pa/pa-hiux.h,
	pa/pa-hpux.h, pa/pa-hpux7.h, pa/pa-linux.h, pa/pa-osf.h,
	pa/pa-pro-end.h, pa/pa.h, pa/rtems.h, pj/linux.h, pj/pj.h,
	romp/romp.h, rs6000/aix.h, rs6000/aix31.h, rs6000/aix41.h,
	rs6000/aix43.h, rs6000/beos.h, rs6000/eabi.h, rs6000/eabisim.h,
	rs6000/linux.h, rs6000/lynx.h, rs6000/mach.h, rs6000/rtems.h,
	rs6000/sysv4.h, rs6000/vxppc.h, sh/elf.h, sh/linux.h, sh/rtems.h,
	sh/rtemself.h, sh/sh.h, sparc/aout.h, sparc/elf.h, sparc/linux-aout.h,
	sparc/linux.h, sparc/linux64.h, sparc/lite.h, sparc/litecoff.h,
	sparc/liteelf.h, sparc/lynx-ng.h, sparc/lynx.h, sparc/netbsd.h,
	sparc/openbsd.h, sparc/pbd.h, sparc/rtems.h, sparc/rtemself.h,
	sparc/sol2-sld-64.h, sparc/sol2.h, sparc/sp64-aout.h,
	sparc/sp64-elf.h, sparc/sp86x-aout.h, sparc/sp86x-elf.h,
	sparc/sparc.h, sparc/sysv4.h, sparc/vxsim.h, sparc/vxsparc.h,
	v850/rtems.h, vax/netbsd.h, vax/openbsd.h, vax/ultrix.h, vax/vax.h,
	vax/vaxv.h, vax/vms.h, we32k/we32k.h

	Replace -A() with -A=, the new assertion syntax.

Thu Nov  2 21:52:35 2000  J"orn Rennecke <amylaar@redhat.com>

	* combine.c (distribute_notes): Use rtx_equal_p to check elim_i2 /
	elim_i1.
	In REG_DEAD handling: When handling parts of multi-hard-reg hard
	registers, increment the loop counter by the size of the parts;
	use recursion to handle individual parts.

2000-11-02  Neil Booth  <neilb@earthling.net>

	* configure.in: Make integrated CPP the default.
	* configure: Regenerate.

Thu Nov  2 19:20:12 2000  J"orn Rennecke <amylaar@redhat.com>

	* reload.c (find_equiv_reg): Test all hard registers for membership
	in the requested class.

2000-11-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* collect2.c (main, write_c_file_stat), gcc.c (translate_options,
	process_command, main), gcov.c (open_files, output_data), tlink.c
	(frob_extension, scan_linker_output), toplev.c
	(file_name_nondirectory): Use strchr () and strrchr () instead of
	index () and rindex ().

2000-11-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (get_flag_spec, check_format_info_main,
	check_format_types): Use strchr () instead of index ().  Compare
	against error_mark_node instead of comparing the TREE_CODE against
	ERROR_MARK.

2000-11-02  Zack Weinberg <zackw@Stanford.EDU>

	Integrated CPP.

	* c-lex.c (init_c_lex): Update cpp_start_read call.
	(cb_ident): Update for new callback prototype.
	(cb_def_pragma): Update for new cpp_get_token prototype.
	(c_lex): Similarly.  Use cpp_get_line.

	* c-parse.in (finish_parse): Update for new cpp_finish
	prototype.

	* cp/lex.c (finish_parse): Similarly.

2000-11-01  Geoff Keating  <geoffk@cygnus.com>

	* machmode.def: Add V16QImode.

2000-11-01  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (loc_descriptor_from_tree): Check for null result
	from rtl_for_decl_location.
	(add_location_or_const_value_attribute): Likewise.

2000-11-01  Neil Booth  <neilb@earthling.net>

	* cpplib.c (run_directive): Use correct line number for output
	of _Pragma.  Remember any in-progress directive.

	* gcc.dg/cpp/vararg2.c, gcc.dg/cpp/_Pragm1.c: New tests.

2000-11-01  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_start_null_loop): Set continue_label.

2000-11-01  Bernd Schmidt  <bernds@redhat.co.uk>

	* builtins.c (fold_builtin_constant_p, fold_builtin): New functions.
	(expand_builtin_constant_p): Move parts of the code into
	fold_builtin_constant_p.
	(expand_builtin_strlen): Move parts of the code into fold_builtin.
	* expr.h (fold_builtin): Declare.
	* fold-const.c (fold): Handle builtin calls.

	* c-typeck.c (build_function_call): Call fold on the CALL_EXPR.

2000-11-01  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_start_null_loop): New.
	(expand_end_null_loop): New.
	* c-semantics.c (genrtl_do_stmt): Use them.
	* tree.h: Declare them.

2000-11-01  Richard Henderson  <rth@redhat.com>

	* cppmain.c (scan_buffer): Don't avoid paste for assembly.

2000-11-01  Neil Booth  <neilb@earthling.net>

	* c-parse.in (_yylex): Remove CPP_BACKSLASH case.
	* cp/spew.c: Similarly.
	* cpplex.c (_cpp_lex_token): Backslashes are now CPP_OTHER.
	* cppmacro.c (stringify_arg): Similarly.
	* cpplib.h (CPP_BACKSLASH): Delete.

2000-10-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_strstr): New function.
	(expand_builtin): Handle BUILT_IN_STRSTR and BUILT_IN_STRCHR.

	* builtins.def (BUILT_IN_STRSTR, BUILT_IN_STRCHR): New entries.

	* c-common.c (c_common_nodes_and_builtins): Declare builtin strstr
	and builtin strchr.

2000-10-31  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (fcmov_comparison_operator): Check for
	CCFPmode or CCFPUmode instead of CCmode.
	(ix86_expand_fp_movcc): Call ix86_expand_setcc for most
	unordered operations as well.

2000-10-31  Richard Henderson  <rth@redhat.com>

	* c-semantics.c (genrtl_do_stmt): Use integer_zerop instead
	of integer_zero_node.

2000-10-31  Richard Henderson  <rth@redhat.com>

	* c-semantics.c (genrtl_do_stmt): Special case do/while(0).

2000-10-31  Nick Clifton  <nickc@redhat.com>

	* config/arm/unknown-elf.h (UNIQUE_SECTION_P): Do not allow
	-fdata-sections to override the section attribute of a DECL.

2000-10-31  Chris Demetriou  <cgd@sibyte.com>

	* libgcc2.c (__shtab): Remove __shtab variable.
	* libgcc-std.ver (GCC_3.0): Remove __shtab from symbol list.
	* Makefile.in (LIB2FUNCS): Remove _shtab from list of library
	members.

2000-10-31  Jim Wilson  <wilson@redhat.com>

	* defaults.h (ASM_OUTPUT_DEBUG_LABEL): New.
	* tm.texi (ASM_OUTPUT_DEBUG_LABEL): Document.
	* dwarf2out.c (dwarf2out_begin_block): Use ASM_OUTPUT_DEBUG_LABEL
	instead of ASM_OUTPUT_INTERNAL_LABEL.
	(dwarf2out_end_block, dwarf2out_label): Likewise.
	* final.c (final_scan_insn, case NOTE_INSN_DELETED_LABEL): Likewise
	* config/ia64/ia64.h (ASM_OUTPUT_DEBUG_LABEL): Define.

2000-10-31  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (struct dw_loc_descr_struct): Add dw_loc_addr.
	(size_of_locs): Set it.
	(output_loc_operands): Use it to compute branch displacement.
	(int_loc_descriptor): New.
	(mem_loc_descriptor): Dereference memory in the proper size.
	Use DW_OP_plus_uconst when possible.  Use int_loc_descriptor.
	(loc_descriptor_from_tree): New.
	(rtl_for_decl_location): Break out from ...
	(add_location_or_const_value_attribute): ... here.
	(add_bound_info): Use loc_descriptor_from_tree.

2000-10-31  Neil Booth  <neilb@earthling.net>

	* cpp.texi: Update for new command line assertion syntax.
	* cpplib.c (cpp_define): Simplify a bit.
	(cpp_assert, cpp_unassert): Use handle_assertion.
	(handle_assertion): New function; accept new command line
	syntax with '='.
	* testsuite/gcc.dg/cpp/assert3.c: New tests.

2000-10-31  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (STDC_0_IN_SYSTEM_HEADERS): Define to 0 if
	undefined.  Remove #ifdef check.
	* config/i386/sol2.h, config/rs6000/sol2.h, config/sparc/sol2.h:
	Define STDC_0_IN_SYSTEM_HEADERS to 1.

2000-10-31  Jan Hubicka  <jh@suse.cz>
	    Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.h: Clarify CCNOmode description in comment.
	(EXTRA_CC_MODES): Remove CCRCmode.
	* config/i386/i386.c (ix86_comparison_operator): Remove CCRCmode.
	(put_condition_code, ix86_match_ccmode): Likewise.
	(ix86_cc_mode): Likewise.  Fix comment.
	(ix86_expand_strlensi_unroll_1): *rc patterns are gone.
	* config/i386/i386.md: Add unspec 12 description.
	(adddi3 split): Use unspec 12 instead of CCRCmode.
	(addsi3_carry_rc): Remove.
	(addsi3_cc, addqi3_cc): New patterns.
	(addsi_3): Swap operands, match CCZmode.
	(addsi_4): Rewritten.
	(addsi_5): Renamed from addsi_6.
	(addsi_6): Removed.
	(addhi_3): Swap operands, match CCZmode.
	(addhi_4): Rewritten.
	(addhi_5): Renamed from addhi_6.
	(addhi_6): Removed.
	(addqi_3): Swap operands, match CCZmode.
	(addqi_4): Rewritten.
	(addqi_5): Renamed from addqi_6.  Use =q constraint for clobber.
	(subsi3_carry_rc): Removed.
	(iorqi_3): Use =q constraint for clobber.
	(xorqi_cc_2): Likewise.
	(negdi2_1 split): Don't use CCRCmode, use ltu instead of gtu.
	(x86_movsicc_0_m1_rc): Removed.
	(cmp?i peepholes): Remove neg.  Use CCGCmode instead of CCRCmode.

2000-10-31  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (build_unary_op): If pedantic, pedwarn for increment
	and decrement of complex types.

2000-10-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_fputs): When deleting NOP calls to
	builtin fputs, ensure we still evaluate the stream in case it
	has side-effects.

2000-10-31  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (do_store_flag): Pass operand_mode instead of GET_MODE (op0)
	to expand_shift.

Tue Oct 31 15:33:27 2000  J"orn Rennecke <amylaar@redhat.com>

	* sh-protos.h (reg_no_subreg_operand, emit_fpscr_use): Don't declare.
	(fp_extended_operand, emit_fpscr_use): Likewise.
	* sh.c (reg_no_subreg_operand, fp_extended_operand): Delete functions.
	(fpul_operand): New function.
	* sh.h (PREDICATE_CODES): Remove reg_no_subreg_operand and
	fp_extended_operand.  Add fpul_operand.
	* sh.md (mulsf3, mulsf3_i4): Use fp_arith_reg_operand for "f" operands.
	(mulsf3_ie, macsf3, cmpgtsf_t, cmpeqsf_t, ieee_ccmpeqsf_t): Likewise.
	(cmpgtsf_t_i4, cmpeqsf_t_i4, ieee_ccmpeqsf_t_4, negsf2): Likewise.
	(negsf2_i, sqrtsf2, sqrtsf2_i, abssf2, abssf2_i, adddf3): Likewise.
	(adddf3_i, subdf3, subdf3_i, muldf3, muldf3_i, divdf3): Likewise.
	(divdf3_i): Likewise.
	(floatsisf2): Likewise.  Use fpul_operand for 'y' operand.
	(floatsisf2_i4, floatsisf2_ie, fix_truncsfsi2): Likewise.
	(fix_truncsfsi2_i4, fixsfsi, floatsidf2, floatsidf2_i): Likewise.
	(fix_truncdfsi2, fix_truncdfsi2_i, extendsfdf2): Likewise.
	(extendsfdf2_i4, truncdfsf2, truncdfsf2_i4): Likewise.

2000-10-31  Bernd Schmidt  <bernds@redhat.co.uk>

	* config/i386/i386.c (ix86_init_builtins): Correct return type
	building v4hi_ftype_v4hi_int_int tree node.
	(ix86_expand_builtin): Use correct operand numbers 0 and 1.
	Copy operand 0 into a Pmode register, don't generate a MEM rtx.

	* config/i386/i386.md (sse_movntdi): Use mmx register constraint
	for operand 1.
	(mmx__uavgv8qi3): Correct insn mnemonic.
	(mmx_psadbw): Correct insn mnemonic.  Use V8QI mode for operands 1 and 2.
	(mmx_punpckhwd): Correct insn mnemonic.
	(mmx_punpckhdq): Likewise.
	(mmx_punpcklwd): Likewise.
	(mmx_punpckldq): Likewise.
	(prefetch): Use immediare_operand and 'n' constraint for operand 1.
	Renumber case labels to match the _mm_prefetch constants defined in
	xmmintrin.h.

	* recog.c (split_all_insns): Don't try to call cleanup_subreg_operands
	if the splitter didn't emit new insns.
	Make sure we call cleanup_subreg_operands even when splitting the last
	insn in a basic block.

	* invoke.texi (Debugging Options): Describe -do.
	* toplev.c (enum_dump_file_index): New entry DFI_postreload.
	(dump_file): Likewise.
	(rest_of_compilation): Split .greg dump into .greg and .postreload.

2000-10-30  Neil Booth  <neilb@earthling.net>

	* cppfiles.c (stack_include_file): Check for stacked contexts
	here.
	* cpphash.h (_cpp_do__Pragma): New prototype.
	* cppinit.c (cpp_reader_init): Add _Pragma keyword to hash table.

	* cpplex.c (skip_escaped_newlines): Only process trigraphs and
	escaped newlines if !(buffer->from_stage3).
	(_cpp_lex_token): Warn about missing newlines iff
	!buffer->from_stage3.

	* cpplib.c (get__Pragma_string, destringize,
	_cpp_do__Pragma): New functions.
	(run_directive): Set output_line for _Pragma to avoid line
	markers in output.  Set from_stage3 and prevent macro expansion
	for _Pragma and command-line options.  Check buffer exhaustion.
	(cpp_push_buffer): Don't check for stacked macro contexts, as
	this is perfectly legitimate for _Pragma.  Move the check to
	stack_include_file instead. Set from_stage3 iff buffer is
	preprocessed input.

	* cpplib.h (struct cpp_buffer): Make warned_cplusplus_comments
	unsigned. New boolean from_stage3.
	(struct spec_nodes): Add n__Pragma.

	* cppmacro.c (enter_macro_context): Flip sense of return value.
	(_cpp_get_token): Handle _Pragma operator.

2000-10-30  Phil Edwards  <pme@sources.redhat.com>

	* gcc.texi:  The C++ standard isn't "draft" anymore.

2000-10-30  Mark Mitchell  <mark@codesourcery.com>

	* cppmacro.c (builtin_macro): Use NT_VOID, not T_VOID.

2000-10-29  Neil Booth  <neilb@earthling.net>

	* cpplib.c (skip_rest_of_line):  Use _cpp_get_token.

2000-10-29  Joseph S. Myers  <jsm28@cam.ac.uk>

	* toplev.c, flags.h, fold-const.c, real.c, rtl.c,
	fixinc/inclhack.def: Change comments mentioning C9X to refer to
	C99 instead.

	* invoke.texi: Document that -V will only work for very similar
	versions of driver and compiler.

2000-10-29  Neil Booth  <neilb@earthling.net>

	* cppmacro.c (_cpp_create_definition): Optimize the case of
	a macro defined to itself.

2000-10-29  Neil Booth  <neilb@earthling.net>

	* cpplex.c (save_comment): Don't store new lines in C++ comments.

2000-10-29  Michael Hayes  <mhayes@redhat.com>

	* integrate.c (copy_insn_list): Copy the unchanging flag for calls.

2000-10-28  Geoffrey Keating  <geoffk@cygnus.com>

	* cpphash.c (cpp_forall_identifiers): Add context variable
	for callback routine.
	* cppmain.c (dump_macro): Update to match cpp_forall_identifiers
	change.
	(main): Call cpp_forall_identifiers with null context.
	* cpplib.h (cpp_forall_identifiers): Update prototype.

	* cppmain.c: Make `parse_in' and `print' static.

2000-10-28  Alan Modra <alan@linuxcare.com.au>

	* c-decl.c (finish_function): Clear c_function_name_declared_p.

2000-10-28  Richard Henderson  <rth@redhat.com>

	* regrename.c (scan_rtx_address): Frob action, not class,
	when trying to disable optimization.

2000-10-28  Mark Mitchell  <mark@codesourcery.com>

	* c-semantics.c (make_rtl_for_local_static): Don't clobber
	DECL_ASSEMBLER_NAME.

2000-10-28  Joseph S. Myers  <jsm28@cam.ac.uk>

	* configure.in: Determine and substitute gcc_version_full.
	* configure: Regenerate.
	* gccbug.in: Use it to give full version.  Don't allow
	confidential PRs.

2000-10-28  Richard Henderson  <rth@redhat.com>

	* recog.c (split_all_insns): Run cleanup_subreg_operands
	after reload.

	* regrename.c (regrename_optimize): Verify that all registers of
	a multiple register mode are available.
	(scan_rtx_address): Accept the mode of the address; all callers
	changed.

	* cpplib.c (run_directive): Fix prototype.

2000-10-28  Bernd Schmidt  <bernds@redhat.co.uk>

	* reload.c (find_reloads): Distinguish "wins" so that we know whether
	a given operand won because of a matching constraint or not; then use
	that information to compute goal_alternative_matched properly.
	* reload1.c (choose_reload_regs): Never set reload_override_in for an
	optional reload.

	* config/ia64/ia64.h (RTX_COSTS): A few more entries, and a more
	accurate value for MULT.
	* config/ia64/ia64.c (ia64_print_operand): Require probability to be
	2% or > 98% before using static branch prediction bits.

2000-10-28  Neil Booth  <neilb@earthling.net>

	New macro expander.

	* cpplib.c (struct answer): New.
	(struct if_stack): Use cpp_lexer_pos rather than line and col.
	Rename cmacro mi_cmacro.
	(struct directive, KANDR, STDC89, EXTENSION, COND, IF_COND, INCL,
	IN_I): New directive and flags.
	(skip_rest_of_line, check_eol, run_directive, glue_header_name,
	parse_answer, parse_assertion, find_answer): New functions.
	(parse_ifdef, detect_if_not_defined, validate_else): Remove.
	(lex_macro_node): New function to replace parse_ifdef and
	get_define_node.

	(_cpp_handle_directive): New function, combines _cpp_check_directive
	and _cpp_check_linemarker.

	(do_define, do_undef, parse_include, do_include, do_import,
	do_include_next, read_line_number, do_line, do_ident, do_pragma,
	do_pragma_once, do_pragma_poison, do_pragma_dependency):
	Update for new token getting interface.

	(do_ifdef, do_ifndef, do_if, do_else, do_endif, push_conditional)
	: Update for new multiple-include optimisation technique.
	(do_elif): Don't forget to invalidate controlling macros.

	(unwind_if_stack, cpp_defined, cpp_push_buffer, cpp_pop_buffer): Update.
	(parse_assertion, parse_answer, find_answer, _cpp_test_assertion):
	Functions to handle assertions with the new token interface.
	(do_assert, do_unassert): Use them.

	(cpp_define, _cpp_define_builtin, cpp_undef, cpp_assert, cpp_unassert):
	Use run_directive.

	(_cpp_init_stacks): Register directive names.  Don't register special
	nodes.

	* cpperror.c (print_containing_files, _cpp_begin_message): Update to
	new position recording regime.
	(cpp_ice, cpp_fatal, cpp_error, cpp_error_with_line, cpp_warning,
	cpp_warning_with_line, cpp_pedwarn, cpp_pedwarn_with_line,
	cpp_pedwarn_with_file_and_line): Update for _cpp_begin_message changes.
	(cpp_type2name): Move to cpplex.c.

	* cppexp.c (parse_charconst): spec_nodes is no longer a pointer.
	(parse_defined): Update to handle new multiple include optimisation
	method.  Remove poisoned identifier warning.
	(parse_assertion, TYPE_NAME): Delete.
	(lex): Update for multiple include optimisation, removal of
	CPP_DEFINED, to use _cpp_test_assertion for assertions and
	cpp_token_as_text.
	(_cpp_parse_expr): Update for MI optimisation, and to use op_as_text.
	(op_as_text): New function, to wrap cpp_token_as_text.

	* cppfiles.c (stack_include_file, _cpp_pop_file_buffer):
	Update for MI optimisation.
	(_cpp_execute_include): Take a token rather than 3 arguments.  Fix
	segfault on diagnostic.
	(_cpp_compare_file_date): Take a token rather than 3 args.
	(cpp_read_file): Work correctly for zero-length files.

	* cpphash.c (_cpp_init_macros, _cpp_cleanup_macros): Rename
	_cpp_init_hashtable and _cpp_cleanup_hashtable.
	(cpp_lookup): Place identifiers at front of identifier pool
	for _cpp_lookup_with_hash.
	(_cpp_lookup_with_hash): Require identifiers to be at the front of
	the identifier pool.  Commit the memory if not already in the
	hash table.

	* cppinit.c (cpp_reader_init): Move cpp_init_completed test to top.
	Initialize various members of cpp_reader, memory pools, and the
	special nodes.
	(cpp_printer_init): Delete.
	(cpp_cleanup): Update.
	(struct builtin, builtin_array, initialize_builtins): Update for new
	hashnode definition and builtin handling.
	(cpp_start_read, cpp_finish): Don't take or initialize a
	printer.  Update.

	* cpplib.h (cpp_printer, cpp_toklist, CPP_DEFINED, BOL,
	PASTED, VAR_ARGS, BEG_OF_FILE, IN_DIRECTIVE, KNOWN_DIRECTIVE,
	T_VOID, T_SPECLINE, T_DATE, T_FILE, T_BASE_FILE, T_INCLUDE_LEVEL,
	T_TIME, T_STDC, T_OPERATOR, T_POISON, T_MACRO, T_ASSERTION): Delete.
	(struct cpp_pool, struct cpp_macro, struct cpp_lexer_pos,
	struct cpp_lookahead, CPP_DHASH, enum mi_state, enum mi_ind,
	NO_EXPAND, VARARGS_FIRST, struct cpp_token_with_pos,
	struct toklist, struct cpp_context, struct specnodes,
	TOKEN_LOOKAHEAD, TOKEN_BUFFSIZE, NODE_OPERATOR, NODE_POISONED,
	NODE_BUILTIN, NODE_DIAGNOSTIC, NT_VOID, NT_MACRO, NT_ASSERTION,
	enum builtin_type, cpp_can_paste): New.
	(struct cpp_token): Delete line and col members.
	(struct cpp_buffer): New member output_lineno.
	(struct lexer_state): Delete indented, in_lex_line, seen_dot.
	Add va_args_ok, poisoned_ok, prevent_expansion, parsing_args.
	(struct cpp_reader): New members lexer_pos, macro_pos, directive_pos,
	ident_pool, temp_string_pool, macro_pool, argument_pool, string_pool,
	base_context, context, directive, mi_state, mi_if_not_defined,
	mi_lexed, mi_cmacro, mi_ind_cmacro, la_read, la_write, la_unused,
	mlstring_pos, macro_buffer, macro_buffer_len.
	Delete members mls_line, mls_column, token_list, potential_control_macro,
	temp_tokens, temp_cap, temp_alloced, temp_used, first_directive_token,
	context_cap, cur_context, no_expand_level, paste_level, contexts, args,
	save_parameter_spellings, need_newline, .
	Change type of date, time and spec_nodes members.
	Change prototypes for include and ident callbacks.
	(struct cpp_hashnode): Change type of name.  Remove union members
	expansion and code.  Add members macro, operator and builtin.

	(cpp_token_len, cpp_token_as_text, cpp_spell_token, cpp_start_read,
	cpp_finish, cpp_avoid_paste, cpp_get_token, cpp_get_line,
	cpp_get_output_line, cpp_macro_definition, cpp_start_lookahead,
	cpp_stop_lookahead): New prototypes.
	(cpp_printer_init, cpp_dump_definition): Delete prototypes.

	(U_CHAR, U, ustrcmp, ustrncmp, ustrlen, uxstrdup, ustrchr, ufputs):
	Move from cpphash.h.

	* cpphash.h (U_CHAR, U, ustrcmp, ustrncmp, ustrlen, uxstrdup, ustrchr,
	ufputs): Move to cpplib.h.
	(enum spell_type, struct token_spelling, _cpp_token_spellings, TOKEN_SPELL,
	TOKEN_NAME, struct answer, FREE_ANSWER, KANDR, STDC89, EXTENSION,
	COND, EXPAND, INCL, COMMENTS, IN_I, struct directive, directive_handler,
	struct spec_nodes, _cpp_digraph_spellings, _cpp_free_temp_tokens,
	_cpp_init_input_buffer, _cpp_grow_token_buffer, _cpp_init_toklist,
	_cpp_clear_toklist, _cpp_expand_token_space, _cpp_expand_name_space,
	_cpp_equiv_tokens, _cpp_equiv_toklists, _cpp_process_directive,
	_cpp_run_directive, _cpp_get_line, _cpp_get_raw_token, _cpp_glue_header_name,
	_cpp_can_paste, _cpp_check_directive, _cpp_check_linemarker,
	_cpp_parse_assertion, _cpp_find_answer): Delete.
	(VALID_SIGN, ALIGN, POOL_FRONT, POOL_LIMIT, POOL_BASE, POOL_SIZE,
	POOL_USED, POOL_COMMIT, struct cpp_chunk, _cpp_lex_token, _cpp_init_pool,
	_cpp_free_pool, _cpp_pool_reserve, _cpp_pool_alloc, _cpp_next_chunk,
	_cpp_lock_pool, _cpp_unlock_pool, _cpp_test_assertion,
	_cpp_handle_directive, DSC): New.
	(struct include_file): New member defined.

	(DO_NOT_REREAD, _cpp_begin_message, _cpp_execute_include,
	_cpp_compare_file_date): Update.
	(_cpp_pop_context, _cpp_get_token, _cpp_free_lookaheads, _cpp_push_token): New.
	(_cpp_init_macros, _cpp_cleanup_macros): Rename to _cpp_init_hashtable,
	_cpp_cleanup_hashtable.

	* Makefile.in: Remove cppoutput.c.

	* cppoutput.c: Delete

	* fixheader.c (read_scan_file): Update for new cpp_get_token
	prototype.
	(recognized_function): New argument LINE.

	* scan-decls.c (skip_to_closing_brace, scan_decls): Update for
	new cpp_get_token prototype.

	* scan.h (recognized_function): Update prototype.

	* po/POTFILES.in: Remove cppoutput.c.

2000-10-27  Mark Mitchell  <mark@codesourcery.com>

	* c-typeck.c (check_init_type_bitfields): Remove.
	(constructor_incremental): Likewise.
	(struct constructor_stack): Remove incremental bit.
	(struct initializer_stack): Likewise.
	(start_init): Don't play with constructor_incremental.
	(finish_init): Likewise.
	(really_start_incremental_init): Likewise.
	(push_init_level): Likewise.
	(pop_init_level): Likewise.
	(output_init_level): Likewise.
	(output_pending_init_elements): Likewise.

2000-10-21  Mike Coleman  <mcoleman2@kc.rr.com>

	* c-pragma.c (handle_pragma_pack): Initialize align to -1.
	Improve error messages.  Correct parsing of
	#pragma pack(pop [,id]).  Do not check the user-supplied
	alignment if we're popping.

	* gcc.dg/pack-test-1.c: New test case.
	* gcc.dg/pack-test-2.c: New test case.
	* gcc.dg/pack-test-1.h: New file.

2000-10-27  Neil Booth  <neilb@earthling.net>

	* cpp.texi: Update.

2000-10-27  Kelley Cook <kelley.cook@home.com>

	* invoke.texi: Document -mintel-syntax

2000-10-27  Richard Henderson  <rth@redhat.com>

	* invoke.texi: Document -frename-registers.  Add it to -O3.
	* toplev.c (rest_of_compilation): Run regrename before ifcvt2.
	(enum dump_file_index, dump_file): Update order.
	(main): Set flag_rename_registers at -O3.

2000-10-27  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (enum reg_class): Add PV_REG.
	(REG_CLASS_NAMES, REG_CLASS_CONTENTS, REGNO_REG_CLASS): Update.
	(REG_CLASS_FROM_LETTER): Assign it to 'c'.
	* config/alpha/alpha.md (call_osf_1): Use it.
	(call_value_osf_1): Likewise.

	* config/ia64/ia64.c: Revert 10-23 patch.
	(ia64_hard_regno_rename_ok): New.
	* config/ia64/ia64-protos.h: Declare it.
	* config/ia64/ia64.h (HARD_REGNO_RENAME_OK): Use it.

2000-10-27  Bernd Schmidt  <bernds@redhat.co.uk>
	    Richard Henderson  <rth@redhat.com>

	* regrename.c: Rewrite to handle multi-register modes and
	cond_exec instructions.
	* Makefile.in (regrename.o): Update dependencies.
	* recog.h (struct operand_alternative): Add is_address.
	* recog.c (preprocess_constraints) [case 'p']: Set it.

2000-10-27  Zack Weinberg  <zack@wolery.stanford.edu>

	* configure.in: If not NO_MINUS_C_MINUS_O, substitute
	OUTPUT_OPTION with '-o $@'.  Make zlibdir, zlibinc relative to
	top level.  Kill oldstyle_subdirs.  Do not include
	$srcdir/$s/Makefile.in in all_lang_makefiles, but do include
	$outputs.  Do not run configure.lang from config.status.
	Rearrange warning-flag logic to correspond to what the
	makefile wants.  Put special vax stage1 options in
	@stage1_flags@ not @stage1_warn_cflags@.  Don't do anything
	with extra_c_objs, extra_cxx_objs, or extra_cpp_objs.
	(--enable-c-cpplib): AC_SUBST(maybe_cpplib) with "libcpp.a" if
	switch is given, nothing otherwise.
	* configure.lang: Delete.

	* Makefile.in: Expunge all traces of extra_c_objs,
	extra_cxx_objs, and extra_cpp_objs.  Set MAYBE_CPPLIB from
	@maybe_cpplib@. Add $(MAYBE_CPPLIB) to C_AND_OBJC_OBJS.  Set
	warning options via a three level scheme so that -pedantic and
	-Wtraditional are not used for non-C front ends: LOOSE_WARN,
	STRICT1_WARN, STRICT2_WARN -> $(@D)-warn, GCC_WARN_CFLAGS ->
	WARN_CFLAGS.  Distinguish STAGE1_CFLAGS from BOOT_CFLAGS.
	Add -I$(@D) and -I$(srcdir)/$(@D) to INCLUDES.
	Set OUTPUT_OPTION, ZLIB, ZLIBINC.  Do not set P,
	LANG_FLAGS_TO_PASS.  Add OUTPUT_OPTION to all object-file
	generation rules.  Wrap all rules that change the current
	directory in parentheses; pmake doesn't spawn a new shell for
	each command.  Expunge all references to $(P).  When one
	command depends on another and they're run all at once, use &&
	to separate them, not ;.  Add libgcc_s$(SHLIB_EXT) to files
	deleted on make clean.  Force OUTPUT_OPTION='-o $@' in stage2
	and beyond.

	* objc/Make-lang.in: Wrap all rules that change the current
	directory in parentheses.  Expunge all references to $(P).
	When one command depends on another and they're run all at
	once, use && to separate them, not ;.  Add OUTPUT_OPTION to
	all object-file generation rules.  Delete obsolete variables.
	* objc/Makefile.in: Delete.

2000-10-27  Jakub Jelinek  <jakub@redhat.com>

	* calls.c (expand_call): If sibcall_failure is set during pass 1,
	clear tail_call_insns as well.

2000-10-27  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm-protos.h (arm_function_ok_for_sibcall): Add
	prototype.

2000-10-26  Richard Henderson  <rth@redhat.com>

	* calls.c (expand_call): Supress sibcall if we have a
	BLKmode return in registers.

2000-10-26  Bernd Schmidt  <bernds@redhat.co.uk>

	* ia64.h (PREFERRED_RELOAD_CLASS): Force floating point constants
	into memory.

2000-10-26  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.c (make_node, case 't'): Set alignment to that of
	char_type_node.
	* expr.c (move_by_pieces_ninsns): Abort if some length remains.

2000-10-25  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (site.exp): Define HAVE_LIBSTDCXX_V3.
	* configure.in (enable-libstdcxx-v3): Arrange to have
	HAVE_LIBSTDCXX_V3 substituted into the output files.

2000-10-25  Richard Henderson  <rth@redhat.com>

	* recog.c (constrain_operands): Initialize which_alternative
	before no alternatives early exit.

	* cse.c (find_comparison_args): Check that we can reverse a
	comparison if needed before accepting the substitution.

	* reload.c (find_reloads_address_part): Kill rtx obstack hackery.

	* simplify-rtx.c (simplify_relational_operation): Sign extend
	low words before sign extending to high words.

2000-10-25  Nick Clifton  <nickc@redhat.com>

	* config/mcore/mcore.c: Include config.h before system.h.

2000-10-25  Ray Essick  <essick@ddna.labs.mot.com>

	* config/mcore/mcore.md (return): Force function epilogue to
	always be generated to work around epilogue suppression bug in
	M*Core backend.

2000-10-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (grokdeclarator): Move warning for qualified void
	return types with -pedantic to when the function type is
	constructed.  At -W, warn in general for qualified function return
	types, except for volatile void.
	* invoke.texi: Document this new warning at -W.

2000-10-25  Neil Booth  <neilb@earthling.net>

	* cpp.texi: Update with implementation-defined behavior and
	internal limits.

2000-10-25  Jakub Jelinek  <jakub@redhat.com>

	* stor-layout.c (layout_type): If TYPE_ALIAS_SET was already set on the
	incomplete type force it into alias set 0.

Wed Oct 25 01:02:44 EDT 2000  John Wehle  (john@feith.com)

	* alias.c: Include basic-block.h.
	(loop_p): New function.
	(mark_constant_function): Use it.
	* Makefile.in (alias.o): Update dependencies.

2000-10-24  Aldy Hernandez  <aldyh@redhat.com>

	* config/mn10300/mn10300.c (secondary_reload_class): Treat pseudos
	like memory.

2000-10-24  Jim Wilson  <wilson@cygnus.com>

	* expmed.c (store_bit_field): Move integer pun code down after
	code that calls emit_move_insn for entire register move.
	* stor-layout.c (compute_record_mode): Revert Mar 25, Aug 18, and
	Oct 20 changes.  Only store mode in TYPE_MODE if RECORD_TYPE.

2000-10-24  Richard Henderson  <rth@cygnus.com>

	* rtlanal.c (rtx_unstable_p, rtx_varies_p): Don't consider pic
	register stable if PIC_OFFSET_TABLE_REG_CALL_CLOBBERED.

2000-10-24  Aldy Hernandez  <aldyh@redhat.com>

	* gcse.c (cprop_insn): do not propagate constants into jump_insn
	for machines with CC0 more than once.

2000-10-24  Richard Henderson <rth@cygnus.com>, Aldy <aldyh@cygnus.com>

	* config/mn10300/mn10300.h (PREFERRED_RELOAD_CLASS): Treat
	pseudos just like memory.

2000-10-24  Alexandre Oliva  <aoliva@redhat.com>

	* combine.c (distribute_notes): Discard REG_LIBCALL and REG_RETVAL
	when deleting libcall sequence collapsed to a single instruction.

2000-10-24  Andrew Haley  <aph@cygnus.co.uk>

	* expr.c (do_store_flag): Don't crash if either side of a
	comparison is error_mark_node.

2000-10-24  Jakub Jelinek  <jakub@redhat.com>

	* sibcall.c (purge_mem_unchanging_flag): New function.
	(optimize_sibling_and_tail_recursive_calls): Call it.

2000-10-24  Philipp Thomas  <pthomas@suse.de>

	* Makefile.in (check-po): New target for doing checks in the po
	subdir if all languages configured.
	(CHECK_TARGETS): Add @CHECK_PO@, replaced with check-po via
	configure if NLS is enabled.
	* configure.in: If NLS is enabled, substitute CHECK_PO by check-po,
	otherwise leave empty.
	* configure: Regenerate.

2000-10-23  Diego Novillo  <dnovillo@cygnus.com>

	* i386.c (print_operand): Handle new 'A' formatting code.
	387 opcodes need suffixes even with -mintel-syntax.
	Check for explicit size override (codes 'b', 'w' and 'k').
	(print_operand_address): Check if register prefix is needed when
	emitting `ds' segment override.
	* i386.h: Add comment about new 'A' formatting code.
	* i386.md (jump and call patterns): Emit absolute references using %A.

2000-10-23  Richard Henderson  <rth@cygnus.com>

	* config/ia64/ia64.c (ia64_expand_prologue): Mark extra
	output registers as fixed.
	(ia64_function_epilogue): Undo output fixation.

2000-10-23  Richard Henderson  <rth@cygnus.com>

	* config/alpha/alpha.md: Add names for all unnamed insns; use
	define_insn_and_split in some obvious places.
	(lda): Remove.
	(zero_extendqihi2): Use an expander w/ nonimmediate_operand for BWX.
	(zero_extendqisi2, zero_extendqidi2): Likewise.
	(zero_extendhisi2, zero_extendhidi2): Likewise.
	(abs splitters): Fix match_scratch operand number.
	(bcc_reverse): Swap pc & label instead of non-canonical compare.

2000-10-23  Jim Wilson  <wilson@cygnus.com>

	* ia64.c (ia64_print_operand, case 'r'): Correct comment.  Handle
	CONST_INT.
	* ia64.md (cmpsi_adjusted): Use %r3.
	(cmpdi_adjusted): Likewise.

2000-10-23  Diego Novillo  <dnovillo@cygnus.com>

	* config/i386/att.h (ASM_FILE_START): Define.

2000-10-23  Diego Novillo  <dnovillo@cygnus.com>

	* config/i386/linux.h (ASM_FILE_START): Define.

Wed Oct 18 11:16:40 2000  Donald Lindsay  <dlindsay@cygnus.com>

	* gcc/configure.in: m68k-coff tm_file should not have libgloss.h,
	since this (only) drags in a crt0.o reference that the .ld files
	also introduce.

2000-10-23  Geoff Keating  <geoffk@cygnus.com>

	* reload1.c (reload_reg_reaches_end_p): A RELOAD_OTHER can
	overwrite the value in a RELOAD_FOR_INPUT and other kinds of
	reloads just like an RELOAD_FOR_OUTPUT would.

	* local-alloc.c (update_equiv_regs): Add an abort().  When
	deleting or moving insns, update reg_equiv[regno].init_insns.

2000-10-23  Mark Mitchell  <mark@codesourcery.com>

	* c-tree.texi: Improve documentation for IF_STMTs and related
	conditional statements.

2000-10-22  Mark Mitchell  <mark@codesourcery.com>

	* expr.c (do_preexpand_calls): Remove.
	(same_from_p): Don't use CALL_EXPR_RTL.
	(expand_expr): Don't call preexpand_calls, or use CALL_EXPR_RTL.
	(preexpand_calls): Remove.
	* tree.c (first_rtl_op): Remove CALL_EXPR case.
	(unsave_expr_1): Likewise.
	* tree.def (CALL_EXPR): Give it only two slots.
	* tree.h (CALL_EXPR_RTL): Remove.

2000-10-21  Chandrakala Chavva   <cchavva@redhat.com>

	* libgcc-std.ver (__addvsi3, __addvdi3,  __subvsi3, __subvdi3,
	__mulvsi3, __negvsi2, __negvdi2, __absvsi2, __absvdi2, __mulvdi3):
	New functions.

2000-10-22  Alexandre Oliva  <aoliva@redhat.com>

	* calls.c (combine_pending_stack_adjustment_and_call): Don't
	adjust stack when unadjusted_alignment ends up as zero.

2000-10-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* fixinc/genfixes: Remove EGCS reference.
	* install.texi: Remove EGCS reference.
	* INSTALL: Regenerate.

2000-10-22  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (TYPE_IS_SIZETYPE): Add more documentation.

2000-10-21  Joseph S. Myers  <jsm28@cam.ac.uk>

	* diagnostic.c: Remove EGCS reference in comment.

Sat Oct 21 08:24:25 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* loop.c (strength_reduce): Fix error in last change.

2000-10-20  David Edelsohn  <edelsohn@gnu.org>

	* Makefile.in (SHLIB_NM_FLAGS): New.
	(libgcc.mk): Pass it.
	* mklibgcc.in (libgcc.map): Use it.

	* rs6000/t-aix43 (SHLIB_EXT, SHLIB_LINK, SHLIB_LIBS,
	SHLIB_MKMAP, SHLIB_MAPFILES, SHLIB_NM_FLAGS): New.

2000-10-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips.h (REG_CLASS_FROM_LETTER): Cast array arg to unsigned char.

	* sparc.c (load_pic_register): Delete unused varaible.

	* libgcc2.c (__addvsi3): Delete unused variable.

	* libgcc2.h (__absvsi2, __absvdi2, __addvsi3, __addvdi3,
	__subvsi3, __subvdi3, __mulvsi3, __mulvdi3, __negvsi2,
	__negvdi2): Prototype.

	* ssa.c (apply_delayed_renames): Avoid undefined operation.

	* toplev.c (display_target_options): Make static to match
	prototype.  Delete empty declaration.

2000-10-20  Tom Tromey  <tromey@cygnus.com>

	* cppspec.c (DEFAULT_WORD_SWITCH_TAKES_ARG): Added -MF and -MT.
	* gcc.c (DEFAULT_WORD_SWITCH_TAKES_ARG): Added -MF and -MT.

Fri Oct 20 17:05:49 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case SAVE_EXPR): Set RTX_UNCHANGING_P on
	returned MEM.
	(expand_expr_unaligned, case ARRAY_REF): Check that index is
	a constant before comparing it; use tree_low_cst.
	* tree.c (save_expr): Set TREE_READONLY.
	(substitute_expr): Return inside of NON_LVALUE_EXPR.
	(build, build1): Set TREE_READONLY if all operands are.
	(build_index_type): If upper bound is a negative number, lower
	bound is zero and sizetype is unsigned, use upper bound of one and
	lower of zero.

2000-10-20  David Edelsohn  <edelsohn@gnu.org>

	* gcc.c (process_command, main): Use "because" instead of
	"since" in error messages.

Fri Oct 20 13:33:16 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (compute_record_mode): Use tree_low_cst.
	Don't use mode of field for record unless sizes are the same.
	(layout_type, case ARRAY_TYPE): Remove special bounds handling
	previously added for Ada; also change to using host_integerp
	and tree_low_cst.

	* loop.c (strength_reduce): Show when new register made for
	giv is known to be a pointer and its aligment if so and known.
	(loop_dump_aux): Show VERBOSE parameter unused.

	* gcse.c (set_hash_table_size): Now unsigned.
	* sdbout.c (template_name_p): Add "const" to avoid warnings.
	(sdbout_record_type_name, plain_type_1, sdbout_symbol): Likewise.
	(sdbout_one_type, sdbout_parms, sdbout_reg_parms): Likewise.
	(sdbout_end_epilogue): Remove variable NAME.
	* system.h (getopt): Add default definition.
	* config/alpha/alpha.c (print_operand): Don't continue processing
	after issuing error.
	(summarize_insn): Avoid use of UL in constant.

	* function.c (locate_and_pad_parm): Use host_integerp and tree_low_cst.

	* fold-const.c (force_fit_type): Unsigned values can overflow
	if they are sizetype.
	(int_const_binop): Don't use cache if overflows.

2000-10-20  Richard Henderson  <rth@cygnus.com>

	* function.c (locate_and_pad_parm): Zero alignment_pad.

	* regrename.c (rr_replace_reg): Rewrite to use recog_data to
	perform substitutions, and apply_change_group to see if it worked.

Fri Oct 20 13:33:16 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* dwarf2out.c (add_bound_info): Also ignore COND_EXPR.

	* combine.c (struct undo): Change int to unsigned int.
	(do_SUBST_INT): Args are unsigned int.
	(make_extraction, force_to_mode): Use proper type when forming mask.
	(make_field_assignment): Likewise.

2000-10-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (check_format_info_recurse): Extract string constant
	initializers from non-volatile constant arrays and check them as
	formats.
	* c-typeck.c (decl_constant_value): Don't check pedantic or check
	for DECL_MODE (decl) != BLKmode.
	(decl_constant_value_for_broken_optimization): New function which
	includes these checks.
	(default_conversion, convert_for_assignment, digest_init): Use
	decl_constant_value_for_broken_optimization instead of
	decl_constant_value.

2000-10-20  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (DECL_ALIGN_UNIT): New macro.

2000-10-14  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr-protos.h (avr_output_bld): New.
	(out_shift_with_cnt): Add t_len argument.
	* config/avr/avr.c (avr_num_arg_regs): Remove -mpack-args.
	(output_movqi, output_movhi, output_movsisf): Optimize loading
	any constant with exactly one bit set to NO_LD_REGS.
	(out_shift_with_cnt): Optimize output code for size or speed,
	depending on optimize_size.  Handle small shift counts as well
	(if not hand-optimized in ?sh??i3_out).  Shifts can be done
	with or without a scratch register, with help of __tmp_reg__
	or __zero_reg__ if necessary.  Add T_LEN argument to pass the
	length of TEMPLATE in words, return total insn length in *LEN.
	(ashlqi3_out, ashrqi3_out, lshrqi3_out): Change all calls to
	out_shift_with_cnt to work with the above change.
	(ashlhi3_out, ashlsi3_out, ashrhi3_out, ashrsi3_out, lshrhi3_out,
	lshrsi3_out): Likewise.  Optimize more known shift count cases.
	Remove cases already well optimized in out_shift_with_cnt.
	(avr_output_bld): New function.
	* config/avr/avr.h (MASK_PACK_ARGS, TARGET_PACK_ARGS): Remove.
	(TARGET_SWITCHES): Remove -mpack-args backward compatibility.
	* config/avr/avr.md (*reload_inqi, *reload_inhi, *reload_insi):
	Add reload_completed to insn condition - only for peepholes.
	(ashlqi3, ashrqi3, lshrqi3): Correct insn length for shift counts
	in a register or memory.
	(ashlhi3, ashlsi3, ashrhi3, ashrsi3, lshrhi3, lshrsi3): Likewise.
	Do not require a scratch register.
	(*ashlhi3_const, *ashlsi3_const, *ashrhi3_const, *ashrsi3_const,
	*lshrhi3_const, *lshrsi3_const): New insns and matching peepholes.
	Optimize shifts by known count using a scratch register, but only
	if one is still available after register allocation.

2000-10-20  J. David Anglin  <dave@hiauly1.hia.nrc.ca>

	* t-vax: New file.  Don't build modules from libgcc1.c.

Fri Oct 20 00:57:00 EDT 2000  John Wehle  (john@feith.com)

	* alias.c: (mark_constant_function): Don't check pure functions.
	Initialize and end alias analysis.
	(nonlocal_mentioned_p): Rename from nonlocal_reference_p.
	Don't make a special exception for recursion.  Handle
	UNSPEC_VOLATILE.  Don't assume ASM_OPERANDS is non-local
	unless it's volatile.

	* local-alloc.c (equivalence): New structure.
	(reg_equiv): Define.
	(contains_replace_regs): Remove array and use
	field in reg_equiv.
	(memref_referenced_p): Likewise.
	(no_equiv): Likewise.
	(update_equiv_regs): Likewise.

	(equiv_init_varies_p,
	equiv_init_movable_p): New functions.
	(update_equiv_regs): Use them.  Use rtx_varies_p
	instead of function_invariant_p.  Process insns
	from end to beginning.  Allow a REG_EQUIV insn
	within the same loop as a use to be moved, also
	allow it to be moved out of a loop.  Update
	REG_DEAD notes when substituting into an insn.

2000-10-19  Jim Wilson  <wilson@cygnus.com>

	* c-decl.c (start_decl): Check for error_mark_node type before using
	COMPLETE_TYPE_P.
	(finish_decl): Likewise.  Don't give an error if decl type is
	already error_mark_node.

	* haifa-sched.c (compute_trg_info): Add explanatory comments.
	New local update_blocks.  Use update_blocks to remove duplicates
	when computing update blocks.  Check for bblst_table overflow.
	(schedule_block): Add explanatory comment.  Reduce bblst_size by
	factor of 2.
	* config/ia64/ia64.md (movdi_symbolic): Document loss of REG_LABEL
	notes.

2000-10-19  Chandrakala Chavva   <cchavva@redhat.com>

	* libgcc2.c (_mulvsi3): Change variables u and v to a and b.

2000-10-19  Chandrakala Chavva   <cchavva@redhat.com>

	* expmed.c: Minor corrections in comments.
	* invoke.texi: Added desciption for the new option -ftrapv.

2000-10-19  Chandrakala Chavva   <cchavva@redhat.com>

	* libgcc2.c: Added the missing #endif.

Thu Oct 19 14:25:11 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* i386.h (CONST_OK_FOR_LETTER): Re-add 'N'; document.

2000-10-18  Chandrakala Chavva  <cchavva@redhat.com>

	* expmed.c (expand_mult): Don't do synth_mult optimization for -ftrapv.
	Use smulv_optab for -ftrapv.
	(expand_mult_highpart): Use unsigned multiply.
	(expand_divmod): Special-case division by -1.
	For EXACT_DIV_EXPR, do right shift first, then the multiply.
	For complex divide, use abs with unsigned result.
	* expr.c (force_operand): Use unsigned multiply.
	(expand_expr): Use overflow-trapping optabs for signed types if
	flag_trapv.
	If flag_trapv, don't generate a recursive call with EXPAND_SUM
	if the type is signed and the original call wasn't EXPAND_SUM or
	EXPAND_INITIALIZER.
	* expr.h (addv_optab, subv_optab, smulv_optab, sdivv_optab): Declare.
	(negv_optab, absv_optab): Declare.
	* flags.h (flag_trapv): Declare.
	* genopinit.c (optabs): Add entries for addv_optab, subv_optab,
	smulv_optab, sdivv_optab, negv_optab and absv_optab.
	(gen_insn): Interpret '$P' as requiring an integer mode,
	including partial integer modes.
	* loop.c (emit_iv_add_mult): Use unsigned expand_mult_add.
	(product_cheap_p): Use unsigned expand_mult.
	* optabs.c (addv_optab, subv_optab, smulv_optab, sdivv_optab): Define.
	(negv_optab, absv_optab): Define.
	(expand_binop): Use overflow-trapping optabs for signed types if
	flag_trapv.
	Handle negv_optab libe neg_optab.
	(expand_abs): Take result_unsignedp argument instead of unsignedp one.
	Use overflow-trapping optabs for signed result if flag_trapv.
	(expand_complex_abs): Use overflow-trapping optabs for signed types if
	flag_trapv.
	Don't open-code complex absolute-value operation for flag_trapv.
	(init_optabs): Initialize addv_optab, subv_optab, smulv_optab,
	sdivv_optab, negv_optab and absv_optab.
	* toplev.c (flag_trapv): Define.
	(lang_independent_options f_options): Include flag_trapv.
	* tree.h (TYPE_TRAP_SIGNED): Define.
	* libgcc2.c (__addvsi3, __addvdi3, __subvsi3,__subvsi3, __subvdi3,
	__mulvsi3, __negvsi2, __negvdi2, __absvsi2, __absvdi2, __mulvdi3):
	New functions.
	* Makefile.in: add _absvsi2 _absvdi2 _addvsi3 _addvdi3 _subvsi3
	_subvdi3 _mulvsi3 _mulvdi3 _negvsi2 _negvdi2.

2000-10-18  Geoffrey Keating  <geoffk@cygnus.com>
	    David V. Henkel-Wallace  <gumby@cygnus.com>

	* config/i386/t-netware: Bring in from the Red Hat tree.
	* config/i386/netware.h: Likewise.
	* config/netware.h: Likewise.
	* config/rs6000/netware.h: Delete.
	* configure.in: Add i[34567]86-*-netware.
	* configure: Hand-edit to match configure.in change.

2000-10-18  Mark Mitchell  <mark@codesourcery.com>

	* c-common.h (flag_no_builtin): Declare.
	(flag_no_nonansi_builtin): Likewise.
	(c_common_nodes_and_builtins): Change prototype.
	* c-common.c (flag_no_builtin): New variable.
	(flag_no_nonansi_builtin): Likewise.
	(c_common_nodes_and_builtins): Remove parameters.  Adjust
	accordingly.
	* c-decl.c (flag_no_builtin): Remove.
	(flag_no_nonansi_builtin): Likewise.
	(init_decl_processing): Adjust call to
	c_common_nodes_and_builtins.

2000-10-18  Marc Espie <espie@openbsd.org>

	* tm.texi (LIBGCC_SPEC): Synch with reality.

2000-10-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (check_format_types): Check for writing through a
	NULL pointer argument.

2000-10-18  Hans-Peter Nilsson  <hp@axis.com>

	* tm.texi (Exception Region Output): Document
	DWARF_CIE_DATA_ALIGNMENT.
	* dwarf2out.c (DWARF_CIE_DATA_ALIGNMENT): Wrap definition in
	#ifndef.
	[ENABLE_CHECKING] (reg_save): Abort if offset is not a multiple of
	DWARF_CIE_DATA_ALIGNMENT.

2000-10-18  Michael Hayes  <mhayes@cygnus.com>

	* basic-block.h (struct loop): Delete fields pre_header_root
	and pre_header_trace and replace with pre_header_edges
	and num_pre_header_edges.
	* flow.c (flow_loop_dump): Dump pre_header_edges.
	(flow_loops_free): Free pre_header_edges.
	(flow_loop_pre_header_scan): Calculate pre_header_edges.

2000-10-18  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* contrib.texi: Update references to steering committee members
	and Jeff Law's entry.

2000-10-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (CPLUSPLUS_STD_VER, C_STD_VER, C_STD_NAME): Define.
	(maybe_read_dollar_number, check_format_info_main): Use them for
	pedantic warning messages.

2000-10-18  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (check_format_info_main): Minor cleanup: move
	variables into inner scopes; initialize declarations where
	appropriate; don't hardcode "scanf" name on warning for zero
	width.

2000-10-17  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (back_end_hook): New variable.
	* c-common.h (back_end_hook): Declare it.
	* c-lang.c (finish_file): Use it.

	* emit-rtl.c (init_emit_once): Initialize the const_int_htab
	earlier.

2000-10-18  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_comparison_operator, put_condition_code,
	ix86_match_ccmode, ix86_cc_mode): Handle CCRCmode.
	(ix86_expand_strlensi_unroll_1): Use CCRCmode.
	* i386.h (EXTRA_CC_MODES): Add CCRCmode.
	* i386.md (adddi and negdi splitter): Use CCRCmode.
	(add?i_3, add?i_4, add?i_5): Use CCRCmode; swap operands
	(subsi3_carry): add '*'
	(addsi3_carry_rc, subsi3_carry_rc, x86_movsicc_0_m1_rc): New.
	(cmp to add peep2): Use CCRCmode; swap operands.

2000-10-18  Kazu Hirata  <kazu@hxi.com>

	* h8300.c: Fix a comment typo.
	(round_frame_size): New.
	(compute_saved_regs): Likewise.
	(push): Likewise.
	(pop): Likewise.
	(push_order): Remove.
	(pop_order): Likewise.
	(function_prologue): Rearrange code for readability.
	(function_epilogue): Likewise.

	* config/h8300/h8300.md: Remove an unnecessary sign_extend
	expander that is used when not optimizing.  Output a tab after
	each assembly insns.

	* reorg.c: Fix formatting.

2000-10-17  Joern Rennecke <amylaar@redhat.co.uk>

	* reload1.c (move2add_note_store): Check for simple
	auto-inc in destination.

2000-10-17  Michael Chastain  <chastain@redhat.com>

	* config/i386/i386-aout.h: define INT_ASM_OP.

Tue Oct 17 20:11:08 2000  Alan Modra <alan@linuxcare.com.au>

	* pa.c (print_operand): Handle case 'c' for .vtable_inherit

Tue Oct 17 20:05:51 2000  Martin Buchholz <martin@xemacs.org>

	* i370.md: Fix spelling typo.

2000-10-17  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* function.c (locate_and_pad_parm): Don't align stack unconditionally.
	Fixes execute/20001017-1.c on powerpc-linux-gnu.

	* expr.c (store_constructor): Apply MEM_ALIAS_SET to MEMs only.
	* rs6000/rs6000.c (rs6000_hash_constant): Use X0INT to access a
	LABEL_REF.

	* rs6000/rs6000.h (NO_DOLLAR_IN_LABEL, DOLLARS_IN_IDENTIFIERS,
	ENCODE_SECTION_INFO, ASM_OUTPUT_SPECIAL_POOL_ENTRY_P): Move from
	here...
	* rs6000/aix.h: ...to here.
	* rs6000/linux.h (ASM_APP_ON, ASM_APP_OFF): Define to Linux-style.

2000-10-17  Jakub Jelinek  <jakub@redhat.com>

	* config/alpha/alpha.h (ASM_OUTPUT_MI_THUNK): Reload gp if needed.

	* config/sparc/sparc.h (ASM_OUTPUT_MI_THUNK): Always use call, make
	sure linker can relax even the delay slot mov %g1,%o7, fix output
	formating.

2000-10-17  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md: Remove an unnecessary zero_extend
	expander that is used when not optimizing.  Output a tab after
	each assembly insns.

2000-10-17  Chandrakala Chavva  <cchavva@redhat.com>

	* gcc.c: New options --target-help.
	(process_command): Added code to parse this new option.
	* toplev.c (display_target_options): New function to support the
	above new option.
	* cppinit.c (new_pending_directive) : New option OPT_target__help.
	(cpp_handle_option): Support this new option.
	* invoke.texi: Added notes about --target-help option.

2000-10-17  Graham Stott  <grahams@redhat.com>

	* config/i386/i386.md (testqi_1): Add missing operand prefix
	for operand 0.
	* config/i386/i386-protos.h: Add missing prototype.

2000-10-17  Diego Novillo  <dnovillo@cygnus.com>

	* config/i386/unix.h (ASM_OUTPUT_MI_THUNK): Symbol
	_GLOBAL_OFFSET_TABLE should not have a $ prefix when
	using -mintel-syntax.

2000-10-17  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (FMT_FLAG_DOLLAR_MULTIPLE): Define.
	(format_types): Use it for printf.
	(maybe_read_dollar_number): Add parameter for the kind of format
	involved.  Warn for multiple use for arguments if this is
	inappropriate for the kind of format involved.
	(check_format_info_main): Update calls to maybe_read_dollar_number.

2000-10-17  J. David Anglin  <dave@hiauly1.hia.nrc.ca>

	* inclhack.def (hpux_maxint): Also apply fix to values.h.
	* fixincl.x: Rebuilt.

2000-10-17  Alexandre Oliva  <aoliva@redhat.com>

	* genrecog.c (write_switch): Return the first condition that needs a
	label.

2000-10-17  Bernd Schmidt  <bernds@redhat.co.uk>

	* c-tree.h (warn_sequence_point): Move declaration to...
	* c-common.h (warn_sequence_point): ... here.
	* c-decl.c (warn_sequence_point): Move definition to...
	* c-common.c (warn_sequence_point): ... here.
	(struct reverse_tree): New.
	(reverse_list, reverse_max_depth): New static variables.
	(build_reverse_tree, common_ancestor, modify_ok
	verify_sequence_points): New functions.
	(c_expand_expr_stmt): Call verify_sequence_points if -Wsequence-point.
	* c-typeck.c (check_modify_expr): Delete.
	(build_modify_expr): Don't call it.

2000-10-17  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.h (warn_missing_format_attribute): New variable.
	* c-decl.c (warn_missing_format_attribute): New variable.
	(c_decode_option): Decode -Wmissing-format-attribute and
	-Wno-missing-format-attribute.
	* c-common.c (check_function_format): If
	-Wmissing-format-attribute, give a warning where a vprintf or
	vscanf function is called by a function without its own printf or
	scanf attribute.
	* toplev.c (documented_lang_options): Add
	-Wmissing-format-attribute.
	* invoke.texi: Document -Wmissing-format-attribute.

2000-10-17  Marc Espie <espie@openbsd.org>

	* invoke.texi (-shared): Insist on requiring code generation flags
	to be used along with -shared, and document the subtle failure that
	may occur otherwise.

2000-10-16  J. David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.md (return_internal): Move `use' after `return'.

2000-10-16 Theodore Papadopoulo <Theodore.Papadopoulo@sophia.inria.fr>

	* machmode.def: Correct comment.

2000-10-16  Rodney Brown  <RodneyBrown@mynd.com>

	* print-rtl.c (print_rtx_head): Constify.
	* rtl.h (print_rtx_head): Similarly.

	* config/pa/pa/pa-protos.h (output_64bit_and, output_64bit_ior):
	Constify char * return value.
	* config/pa/pa/pa.c
	(output_64bit_and, output_64bit_ior): Constify char * return value.
	(pa_can_combine_p): Make static.
	(function_arg): Decorate unused `named' argument. Fix comment typo.
	(function_arg_partial_nregs): Decorate unused `named' argument.

2000-10-16  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (format_check_results): New structure.
	(finish_dollar_format_checking): Adjust to take a
	format_check_results * parameter.
	(check_format_info, check_format_info_recurse,
	check_format_info_main): Split check_format_info into three
	functions, the main checking going in check_format_info_main.
	Recurse when any reduction of the format string argument towards a
	string literal is done; go down both branches of a conditional
	expression.  Don't warn for extra format arguments or empty format
	strings if they only occur in some branches of a conditional
	expression.

2000-10-16  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c: Remove obstack.  Include ggc.h.

2000-10-16  Jakub Jelinek  <jakub@redhat.com>

	* rtlanal.c (may_trap_p): Check operand modes of COMPARE.

2000-10-15  Diego Novillo  <dnovillo@cygnus.com>

	* i386.md (*movsi_or): Switch operand order for intel syntax.

2000-10-14  Joseph S. Myers  <jsm28@cam.ac.uk>

	* PROBLEMS: Remove.

	* gcc.texi (Contributing): Update.

2000-10-13  Diego Novillo  <dnovillo@cygnus.com>

	* config/i386/unix.h (ASM_OUTPUT_MI_THUNK): Output final jump using
	appropriate assembler dialect.

2000-10-13  Alexandre Oliva  <aoliva@redhat.com>

	* c-common.c (c_expand_builtin): PARAMS-ize prototype.

2000-10-12  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (output_movhi, output_movsisf): Fix loading
	constants 1 and 2 to NO_LD_REGS.

2000-10-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (c-parse.c, tradcif.c): Create atomically.

	* objc/Make-lang.in (objc-parse.c): Likewise.

2000-10-13  Richard Earnshaw <rearnsha@arm.com>

	* arm.c: Include obstack.h
	(minipool_obstack, minipool_startobj): Define.
	(arm_add_gc_roots): Initialize them.
	(create_fix_barrier): Use our new obstack.
	(push_minipool_barrier, push_minipool_fix): Likewise.
	(arm_reorg): Release obstack memory.

2000-10-13  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (nonlocal_goto_receiver): Remove.
	(prologue, exception_receiver, builtin_setjmp_receiver): New
	patterns.
	* config/sparc/sparc.h (FINALIZE_PIC): Remove.
	* config/sparc/sparc-protos.h (finalize_pic): Remove.
	(load_pic_register): New prototype.
	* config/sparc/sparc.c (pic_setup_code): Remove.
	(finalize_pic): Rename to...
	(load_pic_register): ...this function.
	Don't look for nonlocal_goto_receivers and emit pic setup code
	directly.  Don't check current_function_uses_pic_offset_table.

2000-10-13  Richard Earnshaw <rearnsha@arm.com>

	* tree.h (struct obstack): Declare.

2000-10-12  Mark Mitchell  <mark@codesourcery.com>

	Remove obstacks.
	* Makefile.in (ggc-callbacks.o): Remove target.
	(flow.o): Depend on GGC_H.
	* alias.c (init_alias_analysis):
	Remove ggc_p conditionals.
	(end_alias_analysis): Likewise.
	* basic-block.h (init_flow): New function.
	(allocate_reg_life_data): Declare.
	* bb-reorder.c	(function_obstack): Replace with ...
	(flow_obstack): ... new variable.
	(fixup_reorder_chain): Use it.
	* c-decl.c (ggc_p): Remove.
	(caller-save.c): Don't call oballoc/obfree.
	* combine.c (struct
	undobuf): Remove storage.
	(try_combine): Don't call oballoc.
	(undo_all): Don't call obfree.
	* cse.c (insert): Use xmalloc, not
	oballoc.
	(cse_main): Adjust accordingly.
	* dwarf2out.c (save_rtx): Remove
	obstack code.
	(dwarf2out_init): Remove ggc_p conditionals.
	* emit-rtl.c (rtl_obstack): Remove.
	(gen_rtx_CONST_INT): Remove ggc_p conditionals.
	(make_insn_raw): Likewise.
	(emit_insn_before): Likewise.
	(emit_insn_after): Likewise.
	(emit_insn): Likewise.
	(gen_sequence): Likewise.
	(copy_insn_1): Remove handling of `b' RTL components.
	(init_emit_once): Remove ggc_p conditionals.
	* except.c (create_rethrow_ref): Don't fool with obstacks.
	(add_partial_entry): Likewise.
	(call_get_eh_context): Likewise.
	(begin_protect_partials): Likewise.
	(protect_with_terminate): Likewise.
	* explow.c
	(plus_constant_wide): Likewise.
	* expr.c (init_expr_once):
	Likewise.
	(emit_block_move): Likewise.
	(clear_storage): Likewise.
	(expand_expr): Likewise.
	* flow.c (function_obstack): Remove.
	(flow_obstack): New variable.
	(flow_firstobj): Likewise.
	(create_base_block): Use the flow_obstack.
	(split_block): Likewise.
	(split_edge): Likewise.
	(calculate_global_regs_live): Likewise.
	(allocate_bb_life_data): Make it static.  Likewiwse.
	(init_flow): New function.
	(size_int_type_wide): Remove ggc_p conditionals.
	* function.c
	(push_function_context_to): Don't call save_tree_status.
	(pop_function_context_from): Or restore_tree_status.
	(assign_stack_local_1): Don't call push_obstacks.
	(find_fixup_replacement): Use xmalloc.
	(fixup_var_refs_insns): Free the storage.
	(insns_for_mem_walk): Don't mess with obstacks.
	(instantiate_decls): Likewise.
	(trampoline_address): Likewise.
	(expand_function_end): Likewise.
	* function.h (sturct function):
	Remove obstack-related variables.
	(save_tree_status): Don't declare.
	(restore_tree_status): Likewise.
	* gcse.c (compute_can_copy):
	Don't call oballoc/obfree.
	* genattrtab.c (operate_exp): Remove
	ggc_p conditionals.
	(simplify_cond): Likewise.
	(simplify_test_exp): Don't mess with obstacks.
	(optimize_attrs): Likewise.
	* gengenrtl.c (gendef): Don't include
	ggc_p conditionals.
	* ggc-callbacks.c (ggc_p): Remove.
	* ggc-none.c (ggc_p): Remove.
	* ggc.h (ggc_p): Don't declare.
	* integrate.c (save_for_inline): Don't mess with obstacks.
	(integrate_decl_tree): Likewise.
	(output_inline_function): Likewise.
	* lists.c
	(init_EXPR_INSN_LIST_cache): Likewise.
	* loop.c (temp_obstack):
	Remove.
	(rtl_obstack): Likewise.
	(init_loop): Don't mess with obstacks.
	(reg_address_cost): Free BIVs and GIVs.
	(check_insns_for_bivs): Use xmalloc, not oballoc.
	(find_mem_givs): Likewise.
	(record_biv): Likewise.
	(general_induction_var): Likewise.
	(product_cheap_p): Likewse.
	* optabs.c (init_one_libfunc): Remove
	ggc_p conditional.
	* print-tree.c (debug_tree): Don't use
	oballoc/obfree.
	(print_node): Likewise.
	* profile.c (output_func_start_profiler):
	Remove call to temporary_allocation.
	* reload1.c
	(eliminate_regs_in_insn): Don't mess with obstacks.
	* resource.c
	(mark_target_live_regs): Use xmalloc.
	(free_resource_info): Free the memory.
	* rtl.c (rtl_obstack):
	Remove.
	(rtvec_alloc): Don't mess with obstacks.
	(rtx_alloc): Likewise.
	(rtx_free): Remove.
	(copy_rtx): Don't handle `b' cases.
	(read_rtx): Use a local rtl_obstack.
	* rtl.h (oballoc): Remove.
	(obfree): Likewise.
	(pop_obstacks): Likewise.
	(push_obstacks): Likewise.
	(allocate_bb_life_data): Likewise.
	(allocate_reg_life_data): Likewise.
	(rtx_free): Likewise.
	* sdbout.c (sdbout_queue_anonymous_type):
	Use tree_cons, not saveable_tree_cons.
	* simplify-rtx.c
	(cselib_init): Don't mess with obstacks.
	* stmt.c
	(mark_block_nesting): Mark the label_chain.
	(epxand_label): Use ggc_alloc, not oballoc.
	(clear_last_expr): Don't mess with obstacks.
	(expand_decl_cleanup): Likewise.
	(expand_dcc_cleanup): Likewise.
	(expand_dhc_cleanup): Likewise.
	(expand_anon_union_decl): Likewise.
	(add_case_node): Use xmalloc, not oballoc.
	(free_case_nodes): New function.
	(expand_end_case): Call it.
	* stor-layout.c (layout_type): Don't
	mess with obstacks.
	(layout_type): Likewise.
	* toplev.c (wrapup_global_declarations):
	Likewise.
	(compile_file): Remove ggc_p conditionals.
	(rest_of_compilation): Call init_flow.  Remove ggc_p conditionals.
	(decode_f_option): Remove ggc_p conditionals.
	* tree.c
	(function_maybepermanent_obstack): Remove.
	(maybepermanent_obstack): Likewise.
	(function_obstack): Likewise.
	(tmeporary_obstack): Likewise.
	(momentary_obstack): Likewise.
	(temp_decl_obstack): Likewise.
	(saveable_obstack): Likewise.
	(rtl_obstack): Likewise.
	(current_obstack): Likewise.
	(expression_obstack): Likewise.
	(struct obstack_stack): Likewise.
	(obstack_stack): Likewise.
	(obstack_stack_obstack): Likewise.
	(maybepermanent_firstobj): Likewise.
	(temporary_firstobj): Likewise.
	(momentary_firstobj): Likewise.
	(temp_decl_firstobj): Likewise.
	(momentary_function_firstobj): Likewise.
	(all_types_permanent): Likewise.
	(struct momentary_level): Likewise.
	(momentary_stack): Likewise.
	(init_obstacks): Remove initialization of removed obstacks.
	(save_tree_status): Remove.
	(restore_tree_status): Likewise.
	(temporary_allocation): Liekwise.
	(end_temporary_allocation): Liekwise.
	(resume_temporary_allocation): Likewise.
	(saveable_allocation): Likewise.
	(push_obstacks): Likewise.
	(push_obstacks_nochange): Likewise.
	(pop_obstacks): Likewise.
	(allocation_temporary_p): Likewise.
	(permanent_allocation): Likewise.
	(preserve_data): Likewise.
	(preserve_initializer): Likewise.
	(rtl_in_current_obstack): Likewise.
	(rtl_in_saveable_obstack): Likewise.
	(oballoc): Likewise.
	(obfree): Likewise.
	(savealloc): Likewise.
	(expralloc): Likewise.
	(print_obstack_name): Likewise.
	(debug_obstack): Likewise.
	(object_permanent_p): Likewise.
	(push_momentary): Likewise.
	(perserve_momentary): Likewise.
	(clear_momentary): Likewise.
	(pop_momentary): Likewise.
	(pop_momentary_nofree): Likewise.
	(suspend_momentary): Likewise.
	(resume_momentary): Likewise.
	(make_node): Don't set TREE_PERMANENT.
	(copy_node): Remove ggc_p conditionals.  Don't set TYPE_OBSTACK.
	Don't set TREE_PERMANENT.
	(get_identifier): Remove ggc_p conditionals.
	(build_string): Likewise.
	(make_tree_vec): Likewise.
	(build_decl_list): Remove.
	(build_expr_list): Likewise.
	(tree_cons): Remove ggc_p conditionals.
	(decl_tree_cons): Remove.
	(expr_tree_cons): Likewise.
	(perm_tree_cons): Likewise.
	(temp_tree_cons): Likewise.
	(saveable_tree_cons): Likewise.
	(build1): Remove ggc_p conditionals.
	(build_parse_node): Likewise.
	(build_type_attribute_variant): Don't mess with obstacks.
	(build_type_copy): Likewise.
	(type_hash_canon): Likewise.
	(build_pointer_type): Likewise.
	(build_reference_type): Likewise.
	(build_index_type): Likewise.
	(build_range_type): Likewise.
	(dump_tree_statistics): Don't print obstack information.
	* tree.h
	(struct tree_common): Remove permanent_flag.
	(TREE_PERMANENT): Remove.
	(TREE_SET_PERMANENT): Likewise.
	(TYPE_OBSTACK): Likewise.
	(struct tree_type): Remove obstack.
	(oballoc): Remove.
	(savealloc): Likewise.
	(build_decl_list): Likewise.
	(build_expr_list): Likewise.
	(perm_tree_cons): Likewise.
	(temp_tree_cons): Likewise.
	(saveable_tree_cons): Likewise.
	(decl_tree_cons): Likewise.
	(expr_tree_cons): Likewise.
	(suspend_momentary): Likewise.
	(allocation_temporary_p): Likewise.
	(resume_momentary): Likewise.
	(push_obstacks_nochange): Likewise.
	(permanent_allocation): Likewise.
	(push_momentary): Likewise.
	(clear_momentary): Likewise.
	(pop_momentary): Likewise.
	(end_temporary_allocation): Likewise.
	(pop_obstacks): Likewise.
	(push_obstacks): Likewise.
	(pop_momentary_nofree): LIkewise.
	(preserve_momentary): Likewise.
	(saveable_allocation): Likewise.
	(temporary_allocation): Likewise.
	(resume_temporary_allocation): Likewise.
	(perserve_initializer): Likewise.
	(debug_obstack): Likewise.
	(rtl_in_current_obstack): Likewise.
	(rtl_in_saveable_obstack): Likewise.
	(obfree): Likewise.
	* varasm.c (current_obstack): Remove.
	(saveable_obstack): Remove.
	(rtl_obstack): Remove.
	(immed_double_const): Don't mess with obstacks.
	(immed_real_cons): Likewise.
	(output_constant_def): Likewise.
	(init_varasm_status): Use xcalloc.
	(mark_pool_constant): Mark the pool constant itself.
	(free_varasm_status): Free memory.
	(decode_rtx_const): Call bzero directly, rather than expanding it
	inline.
	(record_rtx_const): Don't mess with obstacks.
	(force_const_mem): Likewise.
	* config/arm/arm.c (arm_encode_call_attribute): Remove ggc_p
	conditionals.
	(aof_pic_entry): Likewise.
	* config/ia64/ia64.c (ia64_encode_section_info): Likewise.
	* config/m32r/m32r.c (m32r_encode_section_info): Likewise.
	* config/pa/pa.c (saveable_obstack): Remove.
	(rtl_obstack): Likewise.
	(current_obstack): Likewise.
	(output_call): Don't mess with obstacks.
	(hppa_encode_label): Remove ggc_p conditionals.
	* config/romp/romp.c (get_symref): Don't mess with obstacks.
	* config/rs6000/rs6000.c (output_toc): Remove ggc_p conditional.
	(rs6000_encode_section_info): Likewise.
	* config/sh/sh.c (get_fpscr_rtx): Likewise.

Thu Oct 12 16:02:31 MET DST 2000 Jan Hubicka  <jh@suse.cz>

	* i386.md (adddi3, subdi3 splitters): Update for new pattern.
	(addsi3_cc, addqi3_cc, subsi3_cc): Remove
	(addsi3_carry): Canonicalize.
	(addqi_5): Remove '*'.
	(sbb pattern): Canonicalize.

	* i386.md (cmp to inc/add peep2): New.

2000-10-12  Richard Earnshaw  <rearnsha@arm.com>

	* bb-reorder.c (reorder_basic_blocks): Allocate an aux block for
	the exit block.

2000-10-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gcc.texi: Merge in contents of README.TRAD and TESTS.FLUNK.
	* README.TRAD, TESTS.FLUNK: Remove.

2000-10-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (decl_attributes): Don't allow strftime formats with
	first_arg_num nonzero.
	(check_format_info): Set wanted_type and wanted_type_name to zero
	before they are possibly assigned and used.

2000-10-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (scanf_flag_specs): Add flags ' and I.
	(strftime_flag_pairs): Disallow any pair of the _, - and 0 flags,
	or the ^ and # flags together.
	(scan_char_table): Handle the ' and I flags.
	(format_types): Add ' and I flags for scanf.

2000-10-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (print_char_table): Use the unpromoted type for
	lengths "h" and "hh" with conversions dioxXu.
	(check_format_types): Apply the default argument promotions where
	the wanted type is not a pointer target.

2000-10-11  Michael Meeks  <mmeeks@gnu.org>
	    Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (check_modify_expr): New function.
	(build_modify_expr): Call it if warn_sequence_point.
	* c-decl.c (warn_sequence_point): New variable.
	(c_decode_option): Handle -Wsequence-point and
	-Wno-sequence-point.  Enable -Wsequence-point as part of -Wall.
	* c-tree.h (warn_sequence_point): Declare.
	* invoke.texi (-Wsequence-point): Document.
	* toplev.c (documented_lang_options): Add -Wsequence-point and
	-Wno-sequence-point.
	Original work by Michael Meeks, 16 Jun 1998.

Wed Oct 11 06:15:41 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.c (get_narrower): Don't look at precision of field if
	not laid out yet.

Tue Oct 10 23:14:33 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (valid_machine_decl_attribute): Allow `extern'
	declaration for data with "progmem" attribute.

2000-10-09  Marek Michalkiewicz  <marekm@linux.org.pl>

	* config/avr/avr.c (out_shift_with_cnt): Use AS2 macro.
	Correct insn length if shift count is a memory operand.
	* config/avr/avr.md: New define_peephole2 to use *reload_inqi.
	(*iorhi3_clobber): Change lo8 to hi8.
	(zero_extendhisi2): Change %B0 to %A1.
	(ashlhi3, ashrhi3): Correct insn length.
	(andhi3, abssf2, extendqisi2, extendhisi2): Change "cc"
	from "clobber" to "set_n" in some alternatives.

2000-10-10  Jakub Jelinek  <jakub@redhat.com>

	* reload1.c (calculate_needs_all_insns): If deleting an instruction,
	remove its insn_chain structure as well.

2000-10-09  J. David Anglin  <dave@hiauly1.hia.nrc.ca>

	* dbxout.c (dbxout_source_line): Remove extra tab.

2000-10-09  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/elfos.h (UNIQUE_SECTION): Apply STRIP_NAME_ENCODING on name.

2000-10-09  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (LANG_LIB2FUNCS): Remove.
	(LIB2FUNCS): Remove _pure.
	(LIB2ADD): Remove LANG_LIB2FUNCS.
	(stage_a): Don't set LANG_LIB2FUNCS.
	* libgcc2.c (__terminate): Mark noreturn.
	(__pure_virtual): Remove.
	* mklibgcc.in: Remove LIB2ADD .txt processing.

2000-10-09  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (push_multi): Revert unintended change.

2000-10-09  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c: Miscellaneous white space and comment clean-ups.  No
	functional change.
	* arm.md: Likewise.

2000-10-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c (c_expand_builtin_printf): Set the TREE_TYPE of a new
	STRING_CST by calling combine_strings.

2000-10-09  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (thumb_expand_movstrqi): Rewrite to support SSA form.
	(thumb_output_move_mem_multiple): Support new insn format.
	* arm.md (movmem12b): Use SSA compatible format.
	(movmem8b): Likewise.

2000-10-09  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (predicable): New attribute, default to "no".
	(all patterns): Mark as predicable if appropriate.
	(conditional execution splits): Split using predication format.
	(define_cond_exec): Define.
	* arm.c (arm_print_operand): handle insn predicate.

2000-10-09  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.NS32K: Remove file.

2000-10-09  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README-bugs: Remove file.

2000-10-08  Philipp Thomas  <pthomas@suse.de>
	* aclocal.m4 (AM_GNU_GETTEXT): Fix non portable use of == operator
	for test.
	* configure: Rebuilt.

2000-10-08  Philipp Thomas  <pthomas@suse.de>
	* aclocal.m4 (AM_WITH_NLS): When not using included gettext,
	disable catalog building if no suitable program was found.
	Move warning message from here
	(AM_GNU_GETTEXT): To here.
	* configure: Rebuilt.

2000-10-08  Philipp Thomas  <pthomas@suse.de>
	* aclocal.m4 (GCC_PATH_PROG): New. Like AC_PATH_PROG but uses
	different cache variables.
	(GCC_PATH_PROG_WITH_TEST): New. Like AM_PATH_PROG_WITH_TEST but
	uses different cache variables.
	(AM_WITH_NLS): Use GCC_PATH_PROG and GCC_PATH_PROG_WITH_TEST.
	* configure: Regenerated.

2000-10-08  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (libgcc.mk): Pass SHLIB_EXT, not SHLIB_LIBS.
	* configure.in (sparc*-*-solaris*): Use t-slibgcc{,-sld}.
	* mklibgcc.in: Consider SHLIB_LINK the entire shlib build command.
	Use SHLIB_EXT.

	* config/t-linux (SHLIB_EXT): New.
	(SHLIB_LINK): Use the entire build command, with substitutions.
	(SHLIB_LIBS): Remove.
	* config/alpha/t-osf4: Likewise.
	* config/mips/t-iris6: Likewise.
	* config/sparc/t-sol2: Likewise, but move shlib stuff...
	* config/sparc/t-slibgcc-sld: ...here.
	* config/sparc/t-slibgcc: New file.

2000-10-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* tm.texi (INTMAX_TYPE, UINTMAX_TYPE): Define.
	* c-common.h (enum c_tree_index): Add CTI_INTMAX_TYPE and
	CTI_UINTMAX_TYPE.
	(intmax_type_node, uintmax_type_node): Define.
	* c-common.c (decl_attributes): If pedantic, warn if `mode'
	attributes create a type wider than intmax_t.
	(T_IM, T_UIM): Define properly.
	* c-decl.c (INTMAX_TYPE, UINTMAX_TYPE): Define if not already
	defined.
	(init_decl_processing): Initialize intmax_type_node and
	uintmax_type_node.
	* c-lex.c (lex_number): When pedantic and warning for integer
	constants that are too large, in C99 mode warn for those that have
	a type wider than long long.

2000-10-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (FMT_FLAG_ARG_CONVERT, FMT_FLAG_SCANF_A_KLUDGE,
	FMT_FLAG_FANCY_PERCENT_OK): Define.
	(format_char_info): Add flag "4" to comment.
	(format_flag_spec, format_flag_pair): New structures.
	(format_kind_info): Add additional fields to control format
	checking.
	(printf_flag_specs, printf_flag_pairs, scanf_flag_specs,
	scanf_flag_pairs, strftime_flag_specs, strftime_flag_pairs): New
	arrays.
	(time_char_table): Use "4" flag to handle %Ey.
	(format_types): Add entries for new fields.
	(get_flag_spec): New function.
	(check_format_info): Increase size of flag_chars[] to 256.
	Control format checking using the new fields of a format_kind_info
	and the new tables; remove all conditionals on printf_format_type,
	scanf_format_type or strftime_format_type.  Handle all details of
	bad combinations of flags (including width, precision and strftime
	modifiers) through data rather than ad hoc code.  Handle all
	details of standard versions in which flags appeared through
	data.  Use the "4" flag.

2000-10-07  Will Cohen  <wcohen@redhat.com>, Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.md: Remove the memory alternative and correct
	the insn lengths in the templates for sign extension and zero
	extension.

2000-10-07  Richard Henderson  <rth@cygnus.com>

	* calls.c (expand_call): Disallow sibcalls to noreturn functions.
	* flow.c (make_edges): Revert last change.

	* config/alpha/alpha.h (FUNCTION_OK_FOR_SIBCALL): Don't test
	TREE_THIS_VOLATILE.
	* config/pa/pa.h (FUNCTION_OK_FOR_SIBCALL): Likewise.

2000-10-06  David O'Brien  <obrien@dragon.nuxi.com>

	* config/alpha/elf.h: Standardize the formatting.

2000-10-06  David O'Brien  <obrien@FreeBSD.org>

	* config/alpha/elf.h: Protect the ASM_OUTPUT_IDENT definition with an
	#undef.

2000-10-06  Richard Henderson  <rth@cygnus.com>

	* function.c (diddle_return_value): Examine
	current_function_return_rtx instead of the DECL_RESULT.
	(expand_function_end): Handle reloading DECL_RESULT from memory
	into a hard register.  Query promote_mode for sign of mismatched
	modes.

2000-10-06  Vladimir Makarov  <vmakarov@touchme.toronto.redhat.com>

	* haifa-sched.c (schedule_insns): Fix typo in freeing
	forward_dependency_cache.

2000-10-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (calli_pcrel, call_valuei_pcrel): Add
	`TARGET_SH2' as a condition.

2000-10-06  Vladimir Makarov  <vmakarov@touchme.toronto.redhat.com>

	* haifa-sched.c (anti_dependency_cache, output_dependency_cache,
	forward_dependency_cache): New variables.
	(add_dependence, remove_dependence): Use anti_dependency_cache and
	output_dependency_cache.
	(compute_block_forward_dependences): Use forward_dependency_cache.
	(schedule_insns): Allocate and free memory for anti/output/forward
	dependencies caches.

2000-10-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (call, call_value): Use `TARGET_SH2' instead of
	`! TARGET_SH1'.  Reindent.

2000-10-06  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (is_valid_printf_arglist, expand_builtin_printf):
	Move functions from here ...

	* c-common.c (is_valid_printf_arglist, c_expand_builtin_printf):
	... to here.
	(c_expand_builtin): New function.
	(init_function_format_info): Don't set `check_function_format_ptr'.
	(c_common_nodes_and_builtins): Set built_in_class type for
	printf/__builtin_printf to BUILT_IN_FRONTEND.
	(c_expand_expr): Handle CALL_EXPRs that are front-end builtins.

	* c-common.h (build_function_call): Declare.

	* expr.c (expand_expr): Pass builtins with class BUILT_IN_FRONTEND
	to `lang_expand_expr' rather than `expand_builtin'.

	* tree.c (check_function_format_ptr): Delete.

	* tree.h (check_function_format_ptr): Likewise.

2000-10-06  Hans-Peter Nilsson  <hp@bitrange.com>

	* dwarf2out.c (build_cfa_loc): Correct to use DW_OP_regx or
	DW_OP_bregx when cfa->reg > 31.

	* frame-dwarf2.c (decode_stack_op) [case DW_OP_regx]: Add missing
	break.

2000-10-05  Richard Henderson  <rth@cygnus.com>

	* c-decl.c (warn_missing_noreturn): Remove.
	(c_expand_body): Don't set or check can_reach_end.
	* c-tree.h (warn_missing_noreturn): Move ...
	* flags.h: ... here.
	(can_reach_end): Remove.
	* flow.c (check_function_return_warnings): New.
	(make_edges): No edge to exit for noreturn sibcalls.
	* function.c (expand_function_end): Save the return value
	clobber instruction.
	(mark_function_status): Mark it.
	* function.h (struct function): Add x_clobber_return_insn.
	* jump.c (can_reach_end): Remove.
	(calculate_can_reach_end): Remove.
	(jump_optimize_1): Don't call it.
	* output.h (check_function_return_warnings): Declare.
	* toplev.c (warn_missing_noreturn): Move from c-decl.c
	(rest_of_compilation): Call check_function_return_warnings.

2000-10-05  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (NM_FOR_TARGET): New.
	(libgcc.mk): Pass SHLIB_MKMAP, SHLIB_MAPFILES.
	(libgcc.a, stmp-multilib): Pass NM_FOR_TARGET.
	* mklibgcc.in: If SHLIB_MKMAP, build libgcc.map.  Depend the
	shared library build on that and EXTRA_MULTILIB_PARTS.
	* mkmap-flat.awk: New file.
	* mkmap-symver.awk: New file.
	* libgcc-std.ver: New file.
	* config/libgcc-glibc.ver: New file.
	* config/ia64/libgcc-ia64.ver: New file.
	* config/t-linux (SHLIB_MKMAP, SHLIB_MAPFILES): New.
	(SHLIB_LINK): Add --version-script.
	* config/ia64/t-ia64 (SHLIB_MAPFILES): Add libgcc-ia64.ver.
	* config/mips/t-iris6 (SHLIB_MKMAP, SHLIB_MAPFILES): New.
	* config/sparc/t-sol2 (SHLIB_MKMAP, SHLIB_MAPFILES): New.
	(SHLIB_LINK): Add -M.

2000-10-05  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (LIB2FUNCS): Add _clz.
	* libgcc2.c (__ffsdi2): Use count_trailing_zeros.
	(__clz_tab): Put in its own unit, non-static.
	* libgcc2.h: Always include longlong.h.

	* longlong.h [alpha] (count_leading_zeros): Use cmpbge with
	a zero instead of -1.
	(count_trailing_zeros): Likewise.

2000-10-05  Richard Henderson  <rth@cygnus.com>

	* config/alpha/alpha.c (alpha_emit_setcc): Don't swap GT tests
	when second op1 is const0_rtx.  Validate op0 as a register.
	* config/alpha/alpha.md (setcc_internal): Don't allow constants
	in the first argument of the compare.
	(setcc_swapped_internal): Likewise.
	(setne_internal): Likewise.

2000-10-05  Geoff Keating  <geoffk@cygnus.com>

	* tree.c (tree_size): New function split out of copy_node.
	(make_node): Remove obstack handling.  Use tree_size.
	(copy_node): Use tree_size.
	* tree.h: Prototype tree_size.

2000-10-05  Richard Henderson  <rth@cygnus.com>

	* diagnostic.c (output_format): Add missing break.

2000-10-05  Jim Wilson  <wilson@cygnus.com>

	* function.c (fixup_var_refs_1, case SET): When gen_move_insn returns a
	SEQUENCE, call emit_insn_before, copy PATTERN and REG_NOTES of last
	sequence insn to INSN, and delete last sequence insn.

2000-10-05  Phil Edwards  <pme@gcc.gnu.org>

	* gcc.c (main): Include generated configargs.h header
	and use arguments in '-v' output.

Thu Oct  5 16:16:57 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* gcc.c: Move data on prefixes forward in file and reorganize.
	(md_exec_prefix, md_startfile_prefix, md_startfile_prefix_1):
	Always define, but make null if no value.
